(* Content-type: application/mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 7.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       145,          7]
NotebookDataLength[     21626,        486]
NotebookOptionsPosition[     21010,        462]
NotebookOutlinePosition[     21366,        478]
CellTagsIndexPosition[     21323,        475]
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[BoxData[
 RowBox[{
  RowBox[{"Vol", "[", 
   RowBox[{"n_", ",", "e_"}], "]"}], " ", ":=", " ", 
  RowBox[{"Sum", "[", 
   RowBox[{
    RowBox[{"Binomial", "[", 
     RowBox[{"n", ",", "k"}], "]"}], ",", 
    RowBox[{"{", 
     RowBox[{"k", ",", "0", ",", "e"}], "}"}]}], "]"}]}]], "Input",
 CellChangeTimes->{{3.504115141580509*^9, 3.504115313902766*^9}, {
  3.507649508759862*^9, 3.507649512302758*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Hamming", "[", 
    RowBox[{"n_", ",", "d_"}], "]"}], " ", ":=", " ", 
   RowBox[{
    RowBox[{"2", "^", "n"}], " ", "/", " ", 
    RowBox[{"Vol", "[", 
     RowBox[{"n", ",", 
      RowBox[{"Floor", "[", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{"d", "-", "1"}], ")"}], "/", "2"}], "]"}]}], "]"}]}]}], ";", 
  " ", 
  RowBox[{
   RowBox[{"RHamming", "[", 
    RowBox[{"n_", ",", "d_"}], "]"}], " ", ":=", " ", 
   RowBox[{
    RowBox[{"Log", "[", 
     RowBox[{"Hamming", "[", 
      RowBox[{"n", ",", "d"}], "]"}], "]"}], "/", 
    RowBox[{"Log", "[", "2", "]"}]}]}]}]], "Input",
 CellChangeTimes->{{3.5041153150807543`*^9, 3.5041153507222233`*^9}, {
   3.505649607127906*^9, 3.505649664413278*^9}, {3.507649514375711*^9, 
   3.5076495521984158`*^9}, {3.5079028995485687`*^9, 3.507902940723536*^9}, 
   3.507902986855341*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Singleton", "[", 
    RowBox[{"n_", ",", "d_"}], "]"}], " ", ":=", " ", 
   RowBox[{"2", "^", 
    RowBox[{"(", 
     RowBox[{"n", "-", "d", "+", "1"}], ")"}]}]}], ";", " ", 
  RowBox[{
   RowBox[{"RSingleton", "[", 
    RowBox[{"n_", ",", "d_"}], "]"}], " ", ":=", " ", 
   RowBox[{
    RowBox[{"Log", "[", 
     RowBox[{"Singleton", "[", 
      RowBox[{"n", ",", "d"}], "]"}], "]"}], "/", 
    RowBox[{"Log", "[", "2", "]"}]}]}]}]], "Input",
 CellChangeTimes->{{3.504115358532401*^9, 3.504115367640964*^9}, {
  3.5056496668843603`*^9, 3.505649680644246*^9}, {3.505650040660326*^9, 
  3.5056500422423067`*^9}, {3.507649526389694*^9, 3.5076495564851303`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Plotkin", "[", 
    RowBox[{"n_", ",", "d_"}], "]"}], " ", ":=", " ", 
   RowBox[{
    RowBox[{"2", "^", 
     RowBox[{"(", 
      RowBox[{"n", "-", 
       RowBox[{"2", "*", "d"}], "+", "1"}], ")"}]}], "*", "n"}]}], ";", " ", 
  RowBox[{
   RowBox[{"RPlotkin", "[", 
    RowBox[{"n_", ",", "d_"}], "]"}], " ", ":=", " ", 
   RowBox[{
    RowBox[{"Log", "[", 
     RowBox[{"Plotkin", "[", 
      RowBox[{"n", ",", "d"}], "]"}], "]"}], "/", 
    RowBox[{"Log", "[", "2", "]"}]}]}]}]], "Input",
 CellChangeTimes->{{3.504115370605585*^9, 3.5041153885967293`*^9}, {
  3.505649683355595*^9, 3.505649697907885*^9}, {3.505650972084053*^9, 
  3.505650992433648*^9}, {3.5076494785983562`*^9, 3.5076494814762383`*^9}, {
  3.507649558687468*^9, 3.5076495656299057`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"GV", "[", 
    RowBox[{"n_", ",", "d_"}], "]"}], " ", ":=", " ", 
   RowBox[{
    RowBox[{"2", "^", "n"}], " ", "/", " ", 
    RowBox[{"Vol", "[", 
     RowBox[{"n", ",", 
      RowBox[{"d", "-", "1"}]}], "]"}]}]}], ";", " ", 
  RowBox[{
   RowBox[{"RGV", "[", 
    RowBox[{"n_", ",", "d_"}], "]"}], " ", ":=", " ", 
   RowBox[{
    RowBox[{"Log", "[", 
     RowBox[{"GV", "[", 
      RowBox[{"n", ",", "d"}], "]"}], "]"}], "/", 
    RowBox[{"Log", "[", "2", "]"}]}]}]}]], "Input",
 CellChangeTimes->{{3.504115409430686*^9, 3.504115415840027*^9}, {
  3.504115464155307*^9, 3.504115475603422*^9}, {3.505649744545163*^9, 
  3.505649756200625*^9}, {3.5076495798996773`*^9, 3.507649593360897*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"n", " ", ":=", " ", "20"}], ";", " ", 
  RowBox[{
   RowBox[{"Plot", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"RHamming", "[", 
        RowBox[{"n", ",", "d"}], "]"}], ",", " ", 
       RowBox[{"RGV", "[", 
        RowBox[{"n", ",", "d"}], "]"}], ",", 
       RowBox[{"RSingleton", "[", 
        RowBox[{"n", ",", "d"}], "]"}], ",", 
       RowBox[{"RPlotkin", "[", 
        RowBox[{"n", ",", "d"}], "]"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"d", ",", "1", ",", "n"}], "}"}], ",", 
     RowBox[{"PlotStyle", " ", "\[Rule]", " ", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"Thick", ",", "Black"}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"Thick", ",", "Dotted", ",", "Black"}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"Thick", ",", "Dashed", ",", "Black"}], "}"}], ",", 
        RowBox[{"{", "Black", "}"}]}], "}"}]}], ",", " ", 
     RowBox[{"PlotRange", " ", "\[Rule]", " ", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"0", ",", "n"}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"0", ",", "n"}], "}"}]}], "}"}]}]}], "]"}], " ", "//", " ", 
   "Quiet"}]}]], "Input",
 CellChangeTimes->{{3.504115489820808*^9, 3.5041156236292887`*^9}, {
   3.504115671124943*^9, 3.504115734209305*^9}, {3.505649460794098*^9, 
   3.505649477935261*^9}, {3.505649576514035*^9, 3.50564959724924*^9}, {
   3.505649764585477*^9, 3.505649793247736*^9}, {3.505649865395974*^9, 
   3.5056499121530523`*^9}, {3.5056500057130957`*^9, 
   3.5056500206356077`*^9}, {3.505651030818507*^9, 3.5056510415116167`*^9}, {
   3.505651078603664*^9, 3.505651131811948*^9}, {3.505651229713634*^9, 
   3.505651243855268*^9}, {3.5056513333879347`*^9, 3.5056513334658527`*^9}, {
   3.50565142799749*^9, 3.505651428044984*^9}, {3.505651498346239*^9, 
   3.505651513784914*^9}, {3.505651583830186*^9, 3.505651615635808*^9}, {
   3.507648897412294*^9, 3.507648928172532*^9}, {3.507648968181432*^9, 
   3.507649073490059*^9}, {3.507649180592749*^9, 3.507649201401032*^9}, {
   3.507649311377056*^9, 3.50764936969725*^9}, 3.50764946314999*^9, {
   3.507649604708353*^9, 3.50764972080816*^9}, {3.507650146801301*^9, 
   3.507650241300782*^9}, {3.5076502840074244`*^9, 3.507650297772566*^9}, {
   3.507650378703848*^9, 3.5076503906121397`*^9}, {3.507650510271052*^9, 
   3.507650540568767*^9}, {3.5076506796724377`*^9, 3.507650768711128*^9}, {
   3.507650889674032*^9, 3.507650997118861*^9}, {3.5076510876408463`*^9, 
   3.507651099588017*^9}, {3.507651525039925*^9, 3.5076515611768923`*^9}, {
   3.507902843012932*^9, 3.5079028449868717`*^9}, {3.507902998201486*^9, 
   3.50790299934198*^9}, {3.507903195239058*^9, 3.507903219460519*^9}}],

Cell[BoxData[
 GraphicsBox[{{{}, {}, 
    {GrayLevel[0], Thickness[Large], 
     LineBox[{{1.000000387755102, 20.}, {1.1864724752920899`, 20.}, {
      1.3729445628290775`, 20.}, {1.7772587846237142`, 20.}, {
      2.1547797878328896`, 20.}, {2.524895327558645, 20.}, {2.725638120781853,
       20.}, {2.926380914005061, 20.}, {2.949799186996371, 20.}, {
      2.9732174599876804`, 20.}, {2.9849265964833354`, 20.}, {
      2.9939413265306123`, 20.}}], 
     LineBox[{{3.0060586734693877`, 15.60768257722124}, {3.008344869474645, 
      15.60768257722124}, {3.014199437722472, 15.60768257722124}, {
      3.0200540059703, 15.60768257722124}, {3.0668905519529193`, 
      15.60768257722124}, {3.1137270979355387`, 15.60768257722124}, {
      3.2074001899007776`, 15.60768257722124}, {3.301073281866016, 
      15.60768257722124}, {3.5041044891568243`, 15.60768257722124}, {
      3.7071356964476325`, 15.60768257722124}, {4.105792647545829, 
      15.60768257722124}, {4.477656380058563, 15.60768257722124}, {
      4.67927326967526, 15.60768257722124}, {4.880890159291958, 
      15.60768257722124}, {4.92794522937295, 15.60768257722124}, {
      4.975000299453942, 15.60768257722124}, {4.986764066974191, 
      15.60768257722124}, {4.993941326530612, 15.60768257722124}}], 
     LineBox[CompressedData["
1:eJxTTMoPSmViYGAQB2IQ/W3hRjsTNhEHy5V+Ymf6NBxi/HY87ORC8L3vOJ7o
F0DwrbJOr5sqhuB/XfjRY60egr/hpvjjI24I/pwdG7yVlyP47dM9tzSyi8L5
Bskx94uPIPg39PK50hrF4Hyl3cdvZEpLwPkp31b++DtTEs5v6ttyJDxTCs6f
r7Z/wkYLaThfSsAqamo2gj/t5xblynkIfkheEcfr7Qi+0GP9tzEXEfzCuX33
Re8h+BfC31489wrBZ9gq4639EcHXF/I50v4dweeK8zt4+ieCDwBalZZn
      "]], 
     LineBox[{{7.006058673469388, 9.600188040674315}, {7.103547239712388, 
      9.600188040674315}, {7.202941366846627, 9.600188040674315}, {
      7.388333011822374, 9.600188040674315}, {7.57372465679812, 
      9.600188040674315}, {7.9758779934702755`, 9.600188040674315}, {
      8.35123811155697, 9.600188040674315}, {8.554603193960649, 
      9.600188040674315}, {8.757968276364327, 9.600188040674315}, {
      8.85779945169531, 9.600188040674315}, {8.957630627026294, 
      9.600188040674315}, {8.970109523942668, 9.600188040674315}, {
      8.98258842085904, 9.600188040674315}, {8.988827869317227, 
      9.600188040674315}, {8.993941326530612, 9.600188040674315}}], 
     LineBox[CompressedData["
1:eJxTTMoPSmViYGAQBmIQ/ftChLwUs5LDrDw74545sg4L5n2SuIvElzbpjl0i
gOBPO6m8KFsWwe/5EqL9ywzBb5Zv29IRgOBLmq99+2w9gr/e74qaK78ynB/x
wzpU8B6CX1uZsUZ1vgqc/8Phfcupvwh+MUdZbH6MKpx/4dT+HUf7EXydXk4R
mcMIflTeOsfjdxD8Dv/g/KJvCP661+xXl/9E8K+077G6+wfBZ9Vf/uApEh8A
LiZ8Qg==
      "]], LineBox[CompressedData["
1:eJxTTMoPSmViYGAQAWIQ/ftChLwUs5qDJm/BgzsJYg7yB1TZPJD4WT/6Lm7i
RPC3GfyYIyuA4PstPGX8WQbBfyo499QJTQQ/hmny1JmdCP7lTx0JWS8RfDu/
vk3SO9Xh/KrtJXFMrRpw/rXwUycknyD4hj/kjQ2dNeH8f2qB1w+UIfinQ5uq
A1Yh+EZvZ/lKHEHwZ7Rsln9wF8H3vrCf48grJPOkz3xc/h3Bf63H/+bBLwSf
TX/5g6d/EHwAbgWGDA==
      "]], 
     LineBox[{{13.00605867346939, 4.11630664148493}, {13.008879507938989`, 
      4.11630664148493}, {13.021467666904549`, 4.11630664148493}, {
      13.034055825870107`, 4.11630664148493}, {13.222069760026324`, 
      4.11630664148493}, {13.410083694182541`, 4.11630664148493}, {
      13.778706099011554`, 4.11630664148493}, {14.17869855056123, 
      4.11630664148493}, {14.551897783525442`, 4.11630664148493}, {
      14.75418242336788, 4.11630664148493}, {14.956467063210317`, 
      4.11630664148493}, {14.968272565119673`, 4.11630664148493}, {
      14.98007806702903, 4.11630664148493}, {14.985980817983709`, 
      4.11630664148493}, {14.991883568938388`, 4.11630664148493}, {
      14.993941326530612`, 4.11630664148493}}], 
     LineBox[{{15.006058673469388`, 2.925900359950195}, {15.027300074666458`, 
      2.925900359950195}, {15.050911078485171`, 2.925900359950195}, {
      15.098133086122598`, 2.925900359950195}, {15.145355093760024`, 
      2.925900359950195}, {15.239799109034877`, 2.925900359950195}, {
      15.33424312430973, 2.925900359950195}, {15.519428423117727`, 
      2.925900359950195}, {15.704613721925723`, 2.925900359950195}, {
      16.106354366262376`, 2.925900359950195}, {16.481301792013568`, 
      2.925900359950195}, {16.684460528249495`, 2.925900359950195}, {
      16.887619264485423`, 2.925900359950195}, {16.937483265608975`, 
      2.925900359950195}, {16.98734726673253, 2.925900359950195}, {
      16.993580266872975`, 2.925900359950195}, {16.993941326530614`, 
      2.925900359950195}}], LineBox[CompressedData["
1:eJxTTMoPSmViYGAQB2IQXZuxhr+X0dDBY6b01tzr/+1XFb3ercKM4Md837Ql
lA3B56upWtvGieAXtXLOf8GP4F/rmzHBSwzBT99yJeySPoL/46aAbJQngv8z
atfm3xUI/q/byV5zVyD4VrMPh77gN4LzLY61loYXIPg68vej58xH8OUrLJwe
nkPwWdImlG++jeC/CH6xpvUFgn/La8rxd+8Q/LOODo/CvyL4brbT8nt+IPgH
LN78OfAbwa8xm+4c/RfBtzRx6vr6D8FPbWRjYPiP4AMAJim0Mw==
      "]], 
     LineBox[{{19.003906248485332`, 1.2796288059541314`}, {19.00845477548109, 
      1.2796288059541314`}, {19.108619825924944`, 1.2796288059541314`}, {
      19.208784876368796`, 1.2796288059541314`}, {19.395718367963774`, 
      1.2796288059541314`}, {19.582651859558748`, 1.2796288059541314`}, {
      19.79132573590182, 1.2796288059541314`}, {19.9999996122449, 
      1.2796288059541314`}}]}, 
    {GrayLevel[0], Thickness[Large], Dashing[{0, Small}], 
     LineBox[CompressedData["
1:eJxNzmk41AsDBfAxlEHWLGkIiUiRpYiu+cubYrJmu5HbpixFScqS7BRJQvZW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      "]]}, 
    {GrayLevel[0], Thickness[Large], Dashing[{Small, Small}], 
     LineBox[CompressedData["
1:eJxF1Gs01HkYB/DBOOSYZZJLTYshozAX888ltL/vptolt5RSm10lrWylkphE
hFnL2ZrNNeWY1Wljkcilm1XsqpwKWzFdWJdIsRlTZlyzs+fsOfviOc+b7/c8
r54Pe1dUYLgmjUbzVc+/e3CTSQSNJidNBYlT8/MUBBZB13tM5YRxOXLRyY8U
jr3N0mvgy0nwnS18+hwFw2RmhegbORl7zQvXnabgdllfofhNTpY6/dVu+IHC
KV2t44MJ4yS2jZSwhyk4N4ydbp1REC5dY6tnOwUx5359tmqC5O9PqRFLKeg/
/GL4l6hZwk+J/0l7FYX6vKP8OQ8NLOAyt4fKhOAl+QbOCumY9q+LkYqEyA3M
CHfbq4OKWr+rsoVC/H3yOetshB6KK1NfjlY7wqVQ0uRcwsC20QrbKW9HhMWG
D2/eZwjb4qE/3r4SgO2vf8f8DROuo7f8r6UJIGMNMXXFRtATiWcSzAX4Ps+r
JlnHGB4rX9iQ43zIeFF6e5JNkB1xb9qnkQerm3dle1lmOGB13miDgovdytLJ
ubOL8ZBepqVBcVHEaZRUubJwZZ/U5VKYA44fzn3Z1rYUTS01TLN8ewTsV4kS
N5gj2IvejOd2MA/JPO3z2gKHNrpd26ZvB0XC5vinVy3BOFmWauezAn/enY1c
lMoGz1UrZyR+OVIsxDXpAVZI6BVtiK20RaXfE846A2tsrLJ/dkPOQfCkexCz
xxolOr//+o7NQYIootymaBlSxHmbnofaIFr3aEjUDhv8qPqhWHJhGQaZha33
VnDAerfLyaXTGo8V6aGRbzjgMmKLckys8ZnfqWrWdVs0VR3yfbXeCsfqj3yt
mbYc4i8zf547xobjpAXl6LkCbTq9Dx7dskT41VfNUUw7OJ91jrPstoDx+gMJ
yg47dEZbaxvtMEfukExSfcoeT4R+PQX9S5GtERKa+JUDZLPriJYXC4wPF4PP
LOFiyLTG70XrYmjt1GXUveFievXYYJaDGY5c5L9ll/FgViu1v1VqgnqVC7s5
go8zhpIGEc8Y7v0Oem4sARbF+nSZZhkheKVlvnO8AFLeiSIbo4Wo8bSkuw8I
IBhPHDOKNsTkM8NPt3s5gghEpvxaBqZfhHkXljhCYNlXbnxTD27nmoOGDYTg
cwY2NiTpwLUlLWbrQSHwqGPT2gQ6LOJc1/Q9EkKXeLybSNfA2teq0cNOFBoz
kwUdJbPEtmlx+fIcCpLusM9iKpQkI8h/wZNcCqGX9L5rPKMko8Ope07kU8Ch
qrwFcUpyxUBu2XmOAk17Xl64RkncQlpyUorVeYeCCy1dE8Rv8vCJnkoKlvHt
umaaE+QI70FgdiuF22arH9/Y8p503tG4Qh5QkPYPzNM93pNVQS6MkYcUDpZn
OPiz35OP8cV3P+9Q9yFLGxhRkPT7cR5jXRSSv4121U9WkHO7bTjegxQC6koL
Q8rGyUfV9pSJIXU+KaD1kmSchGZKeqXqv6Z5q5TjMeNkWfVMgWpEfb97bYAY
4+TyfIfBRQUFC+1ezcqncmKYpbM/QO0CrU3Mn7ohJ9Gc1a0zExTa87k7PKVy
4upbkho4RSHJIb62K1JOCnq7++bUruxUsvvZAXIyF21ESmfVLt2+98k+JzkJ
1fE6v1ntEi0jyr1uyf9u9f3n2D9WaiWd
      "]]}, 
    {GrayLevel[0], LineBox[CompressedData["
1:eJwB0QEu/iFib1JlAgAAABwAAAACAAAAttG8hKdJBUAAAAAAAAA0QJZSimU6
aQdAyJ/MRxt4M0DtgtobmWgKQLOTOJpDuDJAN52QwjaoDUAgDYswXOgxQGN3
ZehUbBBAvXj8bD8cMUAhTwzBHukRQN4MqYDaXTBA2BvmEQiGE0AETXiwyx4v
QIeXSbSBBxVAVdEUDlKdLUDYLm8KZoEWQAQ677dtIyxAIrvH2GkbGEC6rZbp
aYkqQGT2qfj9mRlAeHK0ydUKKUCfJr+QsTgbQD5CnzEibCdAfHKW3M/PHEBh
9sflA9UlQFBt93l+Sx5AjPtmSFVZJEAeXYuPTOcfQL4L0zKHvSJA8n1Ue9Wz
IED4bLXLKD0hQNLH/GoUhCFAcbLJ2FU5H0CDH4a0iFAiQKxTpLKEBxxAr07U
JkUPI0D9lmvpkgwZQFj4O1UR3iNAWfDML2LRFUB9eWisJZ8kQMXrGtMQzRJA
cwh2XW9cJUDZX8kd1K8PQOURncrIKSZASRSRtAhFCUDT8ohgaukmQNkMMgX8
RwNAPk6Oshu5J0ABYw7q4pT5P3q3dF4ChShAhZ5PV/Cs6T8x+B8zMUMpQEd6
eB5cca4/bjQv4WlSKUAAAAAAAAAAADrXt4Q=
      
      "]]}, {}}, {{}, {}, {}, {}, {}, {}}},
  AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
  Axes->True,
  AxesOrigin->{0, 0},
  ImageSize->{590., Automatic},
  PlotRange->{{0, 20}, {0, 20}},
  PlotRangeClipping->True,
  PlotRangePadding->{Automatic, Automatic}]], "Output",
 CellChangeTimes->{{3.507903181249465*^9, 3.507903242704472*^9}, 
   3.538763158784047*^9, 3.570874350037847*^9}]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{"n", " ", ":=", " ", "100"}], ";", " ", 
  RowBox[{
   RowBox[{"Plot", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"RHamming", "[", 
        RowBox[{"n", ",", "d"}], "]"}], ",", " ", 
       RowBox[{"RGV", "[", 
        RowBox[{"n", ",", "d"}], "]"}], ",", 
       RowBox[{"RSingleton", "[", 
        RowBox[{"n", ",", "d"}], "]"}], ",", 
       RowBox[{"RPlotkin", "[", 
        RowBox[{"n", ",", "d"}], "]"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"d", ",", "1", ",", "n"}], "}"}], ",", 
     RowBox[{"PlotStyle", " ", "\[Rule]", " ", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"Thick", ",", "Black"}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"Thick", ",", "Dotted", ",", "Black"}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"Thick", ",", "Dashed", ",", "Black"}], "}"}], ",", 
        RowBox[{"{", "Black", "}"}]}], "}"}]}], ",", " ", 
     RowBox[{"PlotRange", " ", "\[Rule]", " ", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"0", ",", "n"}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"0", ",", "n"}], "}"}]}], "}"}]}]}], "]"}], " ", "//", " ", 
   "Quiet"}]}]], "Input",
 CellChangeTimes->{{3.50790295250343*^9, 3.507903011304338*^9}, {
  3.507903260290798*^9, 3.507903283822423*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"n", " ", ":=", " ", "1000"}], ";", " ", 
  RowBox[{
   RowBox[{"Plot", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"RHamming", "[", 
        RowBox[{"n", ",", "d"}], "]"}], ",", " ", 
       RowBox[{"RGV", "[", 
        RowBox[{"n", ",", "d"}], "]"}], ",", 
       RowBox[{"RSingleton", "[", 
        RowBox[{"n", ",", "d"}], "]"}], ",", 
       RowBox[{"RPlotkin", "[", 
        RowBox[{"n", ",", "d"}], "]"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"d", ",", "1", ",", "n"}], "}"}], ",", 
     RowBox[{"PlotStyle", " ", "\[Rule]", " ", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"Thick", ",", "Black"}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"Dotted", ",", "Black"}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"Thick", ",", "Dashed", ",", "Black"}], "}"}], ",", 
        RowBox[{"{", "Black", "}"}]}], "}"}]}], ",", "\[IndentingNewLine]", 
     RowBox[{"PlotRange", " ", "\[Rule]", " ", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"0", ",", "n"}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"0", ",", "n"}], "}"}]}], "}"}]}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"AspectRatio", "\[Rule]", "0.8"}]}], "]"}], " ", "//", " ", 
   "Quiet"}]}]], "Input",
 CellChangeTimes->{
  3.507903303211461*^9, {3.538763205740107*^9, 3.538763218939045*^9}, {
   3.538763264983577*^9, 3.538763288039603*^9}, {3.5387646309652557`*^9, 
   3.5387646435622272`*^9}, {3.53876470812772*^9, 3.538764725198489*^9}}]
},
WindowSize->{1101, 695},
WindowMargins->{{4, Automatic}, {Automatic, 0}},
FrontEndVersion->"8.0 for Mac OS X x86 (32-bit, 64-bit Kernel) (February 23, \
2011)",
StyleDefinitions->"Default.nb"
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[545, 20, 409, 11, 27, "Input"],
Cell[957, 33, 888, 25, 27, "Input"],
Cell[1848, 60, 706, 18, 27, "Input"],
Cell[2557, 80, 806, 21, 27, "Input"],
Cell[3366, 103, 740, 20, 27, "Input"],
Cell[CellGroupData[{
Cell[4131, 127, 2761, 56, 73, "Input"],
Cell[6895, 185, 11171, 192, 388, "Output"]
}, Open  ]],
Cell[18081, 380, 1354, 37, 73, "Input"],
Cell[19438, 419, 1568, 41, 88, "Input"]
}
]
*)

(* End of internal cache information *)
