(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 8.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       157,          7]
NotebookDataLength[     36048,       1011]
NotebookOptionsPosition[     32774,        903]
NotebookOutlinePosition[     33305,        926]
CellTagsIndexPosition[     33220,        921]
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{

Cell[CellGroupData[{
Cell["General Functions", "Section",
 CellChangeTimes->{{3.541513092283128*^9, 3.5415130999729424`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Distance", "[", 
    RowBox[{"u_", ",", "v_"}], "]"}], " ", ":=", " ", 
   RowBox[{"Length", "[", 
    RowBox[{"Select", "[", 
     RowBox[{
      RowBox[{"MapThread", "[", 
       RowBox[{"Equal", ",", 
        RowBox[{"{", 
         RowBox[{"u", ",", "v"}], "}"}]}], "]"}], ",", 
      RowBox[{
       RowBox[{"#1", "\[Equal]", "False"}], "&"}]}], "]"}], "]"}]}], 
  ";"}]], "Input"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"TaggedDistancesFrom", "[", 
    RowBox[{"us_", ",", "v_"}], "]"}], " ", ":=", " ", 
   RowBox[{"Map", "[", 
    RowBox[{
     RowBox[{
      RowBox[{"{", 
       RowBox[{
        RowBox[{"Distance", "[", 
         RowBox[{"#1", ",", "v"}], "]"}], ",", "#1"}], "}"}], "&"}], ",", 
     "us"}], "]"}]}], ";"}]], "Input",
 CellChangeTimes->{{3.5369406633803377`*^9, 3.536940692201168*^9}, {
  3.5369407336073914`*^9, 3.536940734687084*^9}, {3.536940903967011*^9, 
  3.5369409042687263`*^9}, {3.541543356999042*^9, 3.5415433696753283`*^9}, {
  3.541543675284193*^9, 3.5415436858755608`*^9}, {3.541543893065137*^9, 
  3.54154389386452*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"NonZeroDistancesFrom", "[", 
   RowBox[{"us_", ",", "v_"}], "]"}], " ", ":=", " ", 
  RowBox[{"Map", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"#1", "[", 
      RowBox[{"[", "1", "]"}], "]"}], "&"}], ",", 
    RowBox[{"Select", "[", 
     RowBox[{
      RowBox[{"DistancesFrom", "[", 
       RowBox[{"us", ",", "v"}], "]"}], ",", 
      RowBox[{
       RowBox[{
        RowBox[{"#1", "[", 
         RowBox[{"[", "1", "]"}], "]"}], ">", "0"}], "&"}]}], "]"}]}], 
   "]"}]}]], "Input",
 CellChangeTimes->{{3.536940693669734*^9, 3.536940768605527*^9}, {
  3.536940906182901*^9, 3.5369409096463537`*^9}, {3.541543373507359*^9, 
  3.541543378867167*^9}, {3.541543510716955*^9, 3.5415435168442183`*^9}, {
  3.541543692537092*^9, 3.5415436934825773`*^9}, {3.541543905424446*^9, 
  3.541543919583843*^9}, {3.541543964261712*^9, 3.54154396433578*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"NonZeroDistances", "[", "us_", "]"}], " ", ":=", " ", 
  RowBox[{"Flatten", "[", 
   RowBox[{"Map", "[", 
    RowBox[{
     RowBox[{
      RowBox[{"NonZeroDistancesFrom", "[", 
       RowBox[{"us", ",", "#1"}], "]"}], "&"}], ",", "us"}], "]"}], 
   "]"}]}]], "Input",
 CellChangeTimes->{{3.5369409014733973`*^9, 3.536940977690729*^9}, {
  3.541543390042419*^9, 3.541543394042231*^9}, {3.541543434849093*^9, 
  3.541543437096018*^9}, {3.54154351825237*^9, 3.541543523051683*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"MinimumDistance", "[", "us_", "]"}], " ", ":=", " ", 
  RowBox[{"Min", "[", 
   RowBox[{"NonZeroDistances", "[", "us", "]"}], "]"}]}]], "Input",
 CellChangeTimes->{{3.536940895040936*^9, 3.536940899692143*^9}, {
  3.536940988626288*^9, 3.536941018672275*^9}, {3.541543396257545*^9, 
  3.541543398001334*^9}, {3.541543526617868*^9, 3.541543526930827*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"AllWords", "[", 
   RowBox[{"_", ",", "0"}], "]"}], " ", ":=", " ", 
  RowBox[{"{", 
   RowBox[{"{", "}"}], "}"}]}]], "Input",
 CellChangeTimes->{{3.541361442551158*^9, 3.541361445721717*^9}, {
  3.541361496503908*^9, 3.5413615036376038`*^9}, {3.541507998117969*^9, 
  3.5415080266119537`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"AllWords", "[", 
   RowBox[{"ss_", ",", "n_"}], "]"}], " ", ":=", " ", 
  RowBox[{"Module", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"vs", " ", "=", " ", 
      RowBox[{"AllWords", "[", 
       RowBox[{"ss", ",", 
        RowBox[{"n", "-", "1"}]}], "]"}]}], "}"}], ",", "\[IndentingNewLine]", 
    RowBox[{"Flatten", "[", 
     RowBox[{
      RowBox[{"Table", "[", 
       RowBox[{
        RowBox[{"Map", "[", 
         RowBox[{
          RowBox[{
           RowBox[{"Append", "[", 
            RowBox[{"#1", ",", 
             RowBox[{"ss", "[", 
              RowBox[{"[", "i", "]"}], "]"}]}], "]"}], "&"}], ",", "vs"}], 
         "]"}], ",", 
        RowBox[{"{", 
         RowBox[{"i", ",", "1", ",", 
          RowBox[{"Length", "[", "ss", "]"}]}], "}"}]}], "]"}], ",", "1"}], 
     "]"}]}], "]"}]}]], "Input",
 CellChangeTimes->{{3.54136150458195*^9, 3.541361595629717*^9}, {
  3.541508000775291*^9, 3.541508123569419*^9}, {3.541517527535046*^9, 
  3.5415175279580803`*^9}, {3.541517598331089*^9, 3.541517616281485*^9}, {
  3.541518032508222*^9, 3.541518040707273*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"Weight", "[", "v_", "]"}], ":=", 
  RowBox[{"Length", "[", 
   RowBox[{"Select", "[", 
    RowBox[{"v", ",", 
     RowBox[{
      RowBox[{"Not", "[", 
       RowBox[{"#1", "\[Equal]", "0"}], "]"}], "&"}]}], "]"}], 
   "]"}]}]], "Input",
 CellChangeTimes->{{3.541537649628685*^9, 3.541537684263452*^9}}]
}, Open  ]],

Cell[CellGroupData[{

Cell["Nearest Neighbour Decoding", "Section",
 CellChangeTimes->{{3.541539894617207*^9, 3.5415399010658493`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"SortedDistancesFrom", "[", 
   RowBox[{"us_", ",", "v_"}], "]"}], " ", ":=", " ", 
  RowBox[{"Sort", "[", 
   RowBox[{"TaggedDistancesFrom", "[", 
    RowBox[{"us", ",", "v"}], "]"}], "]"}]}]], "Input",
 CellChangeTimes->{{3.541539904740387*^9, 3.541540040887857*^9}, {
  3.541543347482813*^9, 3.541543348682912*^9}, {3.5415434091218233`*^9, 
  3.5415434155527554`*^9}, {3.5415439862530823`*^9, 3.541543987003294*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"NearestNeighbours", "[", 
   RowBox[{"us_", ",", "v_"}], "]"}], " ", ":=", " ", 
  RowBox[{"Module", "[", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
      RowBox[{"allDistances", " ", "=", " ", 
       RowBox[{"SortedDistancesFrom", "[", 
        RowBox[{"us", ",", "v"}], "]"}]}], ",", "d"}], "}"}], ",", 
    "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"d", " ", ":=", " ", 
      RowBox[{
       RowBox[{"allDistances", "[", 
        RowBox[{"[", "1", "]"}], "]"}], "[", 
       RowBox[{"[", "1", "]"}], "]"}]}], ";", " ", 
     RowBox[{"Map", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"Drop", "[", 
         RowBox[{"#1", ",", "1"}], "]"}], "&"}], ",", 
       RowBox[{"TakeWhile", "[", 
        RowBox[{"allDistances", ",", 
         RowBox[{
          RowBox[{
           RowBox[{"#1", "[", 
            RowBox[{"[", "1", "]"}], "]"}], "\[Equal]", "d"}], "&"}]}], 
        "]"}]}], "]"}]}]}], "]"}]}]], "Input",
 CellChangeTimes->{{3.54154015556116*^9, 3.541540265565406*^9}, {
  3.541540350945684*^9, 3.541540409950163*^9}, {3.541543991917899*^9, 
  3.541543998293399*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"FirstNearestNeighbour", "[", 
   RowBox[{"us_", ",", "v_"}], "]"}], " ", ":=", " ", 
  RowBox[{
   RowBox[{"NearestNeighbours", "[", 
    RowBox[{"us", ",", "v"}], "]"}], "[", 
   RowBox[{"[", "1", "]"}], "]"}]}]], "Input",
 CellChangeTimes->{{3.5415404301810513`*^9, 3.541540445799955*^9}, {
  3.5415409911004477`*^9, 3.5415409987619047`*^9}}]
}, Open  ]],

Cell[CellGroupData[{

Cell["Drawing Codes", "Section",
 CellChangeTimes->{{3.541537472940064*^9, 3.541537482666148*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"DrawWordsWithRules", "[", 
   RowBox[{"us_", ",", "rules_"}], "]"}], " ", ":=", " ", 
  RowBox[{"ArrayPlot", "[", 
   RowBox[{"us", ",", 
    RowBox[{"Mesh", "\[Rule]", "All"}], ",", 
    RowBox[{"ColorRules", "\[Rule]", "rules"}]}], "]"}]}]], "Input",
 CellChangeTimes->{{3.54150789639987*^9, 3.5415079763825417`*^9}, {
  3.541509766334771*^9, 3.54150978451921*^9}, {3.541509851690508*^9, 
  3.5415099809623747`*^9}, {3.5415111806207647`*^9, 3.541511217033288*^9}, {
  3.5415135030084352`*^9, 3.541513503863894*^9}, {3.541513846846037*^9, 
  3.5415138702115707`*^9}, {3.5415182632230053`*^9, 3.5415182643728743`*^9}, {
  3.541533082799629*^9, 3.541533094457778*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"DrawWords", "[", "us_", "]"}], " ", ":=", " ", 
  RowBox[{"DrawWordsWithRules", "[", 
   RowBox[{"us", ",", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"0", " ", "\[Rule]", " ", "Black"}], ",", " ", 
      RowBox[{
       RowBox[{"B", "[", "0", "]"}], " ", "\[Rule]", " ", "Black"}], ",", " ", 
      RowBox[{"1", " ", "\[Rule]", " ", "White"}], ",", " ", 
      RowBox[{
       RowBox[{"B", "[", "1", "]"}], "\[Rule]", "White"}]}], "}"}]}], 
   "]"}]}]], "Input",
 CellChangeTimes->{{3.5415330969973097`*^9, 3.541533119924613*^9}, {
  3.5415331511727*^9, 3.541533163297246*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"DrawWordsInverse", "[", "us_", "]"}], " ", ":=", 
  "\[IndentingNewLine]", 
  RowBox[{"DrawWordsWithRules", "[", 
   RowBox[{"us", ",", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"0", " ", "\[Rule]", " ", "White"}], ",", " ", 
      RowBox[{
       RowBox[{"B", "[", "0", "]"}], " ", "\[Rule]", " ", "White"}], ",", " ", 
      RowBox[{"1", " ", "\[Rule]", " ", "Black"}], ",", " ", 
      RowBox[{
       RowBox[{"B", "[", "1", "]"}], "\[Rule]", "Black"}]}], "}"}]}], 
   "]"}]}]], "Input",
 CellChangeTimes->{{3.541533125008683*^9, 3.5415331757550583`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"DrawWordsComparingWith", "[", 
   RowBox[{"us_", ",", "v_"}], "]"}], " ", ":=", " ", 
  RowBox[{"Module", "[", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"ws", " ", "=", " ", 
      RowBox[{"Map", "[", 
       RowBox[{
        RowBox[{
         RowBox[{"MapThread", "[", 
          RowBox[{"Equal", ",", 
           RowBox[{"{", 
            RowBox[{"#1", ",", "v"}], "}"}]}], "]"}], "&"}], ",", "us"}], 
       "]"}]}], "}"}], ",", "\[IndentingNewLine]", 
    RowBox[{"DrawWordsWithRules", "[", 
     RowBox[{"ws", ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"True", "\[Rule]", "White"}], ",", 
        RowBox[{"False", "\[Rule]", "Red"}]}], "}"}]}], "]"}]}], 
   "]"}]}]], "Input",
 CellChangeTimes->{{3.541544046757346*^9, 3.5415440670380898`*^9}, {
  3.5415446254671373`*^9, 3.5415447359821*^9}, {3.541544782763908*^9, 
  3.541544830632884*^9}, {3.541544891143126*^9, 3.54154489261384*^9}, {
  3.541685293031735*^9, 3.5416853009188213`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"DrawWordsComparingDistances", "[", 
   RowBox[{"us_", ",", "v_"}], "]"}], " ", ":=", " ", 
  RowBox[{"Module", "[", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"ws", " ", "=", " ", 
      RowBox[{"Map", "[", 
       RowBox[{
        RowBox[{
         RowBox[{"MapThread", "[", 
          RowBox[{"Equal", ",", " ", 
           RowBox[{"{", 
            RowBox[{"#1", ",", "v"}], "}"}]}], "]"}], "&"}], ",", "us"}], 
       "]"}]}], "}"}], ",", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"wsWithDistances", " ", ":=", " ", 
      RowBox[{"Map", "[", 
       RowBox[{
        RowBox[{
         RowBox[{"Append", "[", 
          RowBox[{"#1", ",", 
           RowBox[{"Length", "[", 
            RowBox[{"Select", "[", 
             RowBox[{"#1", ",", 
              RowBox[{
               RowBox[{"Equal", "[", 
                RowBox[{"#", ",", "False"}], "]"}], "&"}]}], "]"}], "]"}]}], 
          "]"}], "&"}], ",", "ws"}], "]"}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"DrawWordsWithRules", "[", 
      RowBox[{"wsWithDistances", ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"True", "\[Rule]", "White"}], ",", 
         RowBox[{"False", "\[Rule]", "Red"}], ",", 
         RowBox[{"1", "\[Rule]", "1"}]}], "}"}]}], "]"}]}]}], 
   "]"}]}]], "Input",
 CellChangeTimes->{{3.541714965224489*^9, 3.54171529706478*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"DrawWords", "[", 
  RowBox[{"BinaryHammingCode", "[", "3", "]"}], "]"}]], "Input",
 CellChangeTimes->{{3.541685689216346*^9, 3.541685696575686*^9}}],

Cell[BoxData[
 RowBox[{
  StyleBox[
   RowBox[{"ArrayPlot", "::", "mat"}], "MessageName"], 
  RowBox[{
  ":", " "}], "\<\"Argument \[NoBreak]\\!\\(BinaryHammingCode[3]\\)\[NoBreak] \
at position \[NoBreak]\\!\\(1\\)\[NoBreak] is not a list of lists. \
\\!\\(\\*ButtonBox[\\\"\[RightSkeleton]\\\", ButtonStyle->\\\"Link\\\", \
ButtonFrame->None, ButtonData:>\\\"paclet:ref/ArrayPlot\\\", ButtonNote -> \\\
\"ArrayPlot::mat\\\"]\\)\"\>"}]], "Message", "MSG",
 CellChangeTimes->{3.572002889018416*^9}],

Cell[BoxData[
 RowBox[{"ArrayPlot", "[", 
  RowBox[{
   RowBox[{"BinaryHammingCode", "[", "3", "]"}], ",", 
   RowBox[{"Mesh", "\[Rule]", "All"}], ",", 
   RowBox[{"ColorRules", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"0", "\[Rule]", 
       RowBox[{"GrayLevel", "[", "0", "]"}]}], ",", 
      RowBox[{
       RowBox[{"B", "[", "0", "]"}], "\[Rule]", 
       RowBox[{"GrayLevel", "[", "0", "]"}]}], ",", 
      RowBox[{"1", "\[Rule]", 
       RowBox[{"GrayLevel", "[", "1", "]"}]}], ",", 
      RowBox[{
       RowBox[{"B", "[", "1", "]"}], "\[Rule]", 
       RowBox[{"GrayLevel", "[", "1", "]"}]}]}], "}"}]}]}], "]"}]], "Output",
 CellChangeTimes->{3.541685697478306*^9, 3.572002889029079*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{"DrawWords", "[", 
  RowBox[{"{", 
   RowBox[{"{", 
    RowBox[{"0", ",", "0", ",", "0", ",", "1", ",", "1", ",", "1", ",", "0"}],
     "}"}], "}"}], "]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"DrawWordsComparingDistances", "[", 
   RowBox[{
    RowBox[{"BinaryHammingCode", "[", "3", "]"}], ",", 
    RowBox[{"{", 
     RowBox[{
     "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", "1", ",", "0"}], 
     "}"}]}], "]"}], " "}], "\[IndentingNewLine]"}], "Input",
 CellChangeTimes->{{3.5415447385407248`*^9, 3.541544775410644*^9}, {
  3.541544855230482*^9, 3.5415448863644648`*^9}, {3.5416853131487837`*^9, 
  3.5416853365244217`*^9}, {3.541685646569067*^9, 3.541685663499049*^9}, {
  3.541685711934877*^9, 3.541685714753817*^9}, {3.541715134382653*^9, 
  3.541715135948738*^9}}],

Cell[BoxData[
 GraphicsBox[{
   RasterBox[SparseArray[
    Automatic, {1, 7}, 0., {1, {{0, 3}, {{4}, {5}, {6}}}, {1., 1., 1.}}], {{0,
     0}, {7, 1}}, {0, 1}], {
    {GrayLevel[
      NCache[-1 + GoldenRatio, 0.6180339887498949]], 
     StyleBox[LineBox[{{{0, 1}, {7, 1}}, {{0, 0}, {7, 0}}}],
      Antialiasing->False]}, 
    {GrayLevel[
      NCache[-1 + GoldenRatio, 0.6180339887498949]], 
     StyleBox[
      LineBox[{{{0, 0}, {0, 1}}, {{1, 0}, {1, 1}}, {{2, 0}, {2, 1}}, {{3, 
       0}, {3, 1}}, {{4, 0}, {4, 1}}, {{5, 0}, {5, 1}}, {{6, 0}, {6, 1}}, {{7,
        0}, {7, 1}}}],
      Antialiasing->False]}}},
  Frame->False,
  FrameLabel->{None, None},
  FrameTicks->{{None, None}, {None, None}},
  ImageSize->{169., Automatic}]], "Output",
 CellChangeTimes->{{3.541685647671666*^9, 3.541685664293644*^9}, 
   3.5416857159019203`*^9, {3.5417151321350603`*^9, 3.541715146783168*^9}, 
   3.541715180110345*^9, {3.541715235320973*^9, 3.5417152998517923`*^9}, 
   3.572002889100691*^9}],

Cell[BoxData[
 RowBox[{
  StyleBox[
   RowBox[{"MapThread", "::", "mptd"}], "MessageName"], 
  RowBox[{
  ":", " "}], "\<\"Object \[NoBreak]\\!\\(3\\)\[NoBreak] at position {2, \
\[NoBreak]\\!\\(1\\)\[NoBreak]} in \[NoBreak]\\!\\(MapThread[\\(\\(Equal, \\(\
\\({3, \\(\\({0, 0, 0, 1, 1, 1, 0}\\)\\)}\\)\\)\\)\\)]\\)\[NoBreak] has only \
\[NoBreak]\\!\\(0\\)\[NoBreak] of required \[NoBreak]\\!\\(1\\)\[NoBreak] \
dimensions. \\!\\(\\*ButtonBox[\\\"\[RightSkeleton]\\\", \
ButtonStyle->\\\"Link\\\", ButtonFrame->None, \
ButtonData:>\\\"paclet:ref/message/MapThread/mptd\\\", ButtonNote -> \
\\\"MapThread::mptd\\\"]\\)\"\>"}]], "Message", "MSG",
 CellChangeTimes->{3.5720028891938763`*^9}],

Cell[BoxData[
 RowBox[{
  StyleBox[
   RowBox[{"MapThread", "::", "argt"}], "MessageName"], 
  RowBox[{
  ":", " "}], "\<\"\[NoBreak]\\!\\(MapThread\\)\[NoBreak] called with \
\[NoBreak]\\!\\(0\\)\[NoBreak] arguments; \[NoBreak]\\!\\(2\\)\[NoBreak] or \
\[NoBreak]\\!\\(3\\)\[NoBreak] arguments are expected. \
\\!\\(\\*ButtonBox[\\\"\[RightSkeleton]\\\", ButtonStyle->\\\"Link\\\", \
ButtonFrame->None, ButtonData:>\\\"paclet:ref/message/General/argt\\\", \
ButtonNote -> \\\"MapThread::argt\\\"]\\)\"\>"}]], "Message", "MSG",
 CellChangeTimes->{3.572002889278956*^9}],

Cell[BoxData[
 RowBox[{
  StyleBox[
   RowBox[{"ArrayPlot", "::", "mat"}], "MessageName"], 
  RowBox[{
  ":", " "}], "\<\"Argument \[NoBreak]\\!\\(BinaryHammingCode[\\(\\(3 \
\[Equal] \\(\\({0, 0, 0, 1, 1, 1, 0}\\)\\)\\)\\)]\\)\[NoBreak] at position \
\[NoBreak]\\!\\(1\\)\[NoBreak] is not a list of lists. \
\\!\\(\\*ButtonBox[\\\"\[RightSkeleton]\\\", ButtonStyle->\\\"Link\\\", \
ButtonFrame->None, ButtonData:>\\\"paclet:ref/ArrayPlot\\\", ButtonNote -> \\\
\"ArrayPlot::mat\\\"]\\)\"\>"}]], "Message", "MSG",
 CellChangeTimes->{3.5720028893227787`*^9}],

Cell[BoxData[
 RowBox[{"ArrayPlot", "[", 
  RowBox[{
   RowBox[{"BinaryHammingCode", "[", 
    RowBox[{"3", "\[Equal]", 
     RowBox[{"{", 
      RowBox[{
      "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", "1", ",", "0"}], 
      "}"}]}], "]"}], ",", 
   RowBox[{"Mesh", "\[Rule]", "All"}], ",", 
   RowBox[{"ColorRules", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"True", "\[Rule]", 
       RowBox[{"GrayLevel", "[", "1", "]"}]}], ",", 
      RowBox[{"False", "\[Rule]", 
       RowBox[{"RGBColor", "[", 
        RowBox[{"1", ",", "0", ",", "0"}], "]"}]}], ",", 
      RowBox[{"1", "\[Rule]", "1"}]}], "}"}]}]}], "]"}]], "Output",
 CellChangeTimes->{{3.541685647671666*^9, 3.541685664293644*^9}, 
   3.5416857159019203`*^9, {3.5417151321350603`*^9, 3.541715146783168*^9}, 
   3.541715180110345*^9, {3.541715235320973*^9, 3.5417152998517923`*^9}, 
   3.572002889325379*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", "ArrayPlot"}]], "Input",
 CellChangeTimes->{{3.541715330167061*^9, 3.541715331864664*^9}}],

Cell[BoxData[
 RowBox[{
  StyleBox["\<\"\!\(\*RowBox[{\\\"ArrayPlot\\\", \\\"[\\\", \
StyleBox[\\\"array\\\", \\\"TI\\\"], \\\"]\\\"}]\) generates a plot in which \
the values in an array are shown in a discrete array of squares. \"\>", "MSG"],
   "\[NonBreakingSpace]", 
  ButtonBox[
   StyleBox["\[RightSkeleton]", "SR"],
   Active->True,
   BaseStyle->"Link",
   ButtonData->"paclet:ref/ArrayPlot"]}]], "Print", "PrintUsage",
 CellChangeTimes->{3.572002889702125*^9},
 CellTags->"Info3572002889-4411412"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Linear codes", "Section",
 CellChangeTimes->{{3.5415131677976093`*^9, 3.541513171382127*^9}, {
  3.541519607300683*^9, 3.541519607391157*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"CodewordFor", "[", 
   RowBox[{"bs_", ",", "G_", ",", "p_"}], "]"}], " ", ":=", " ", 
  RowBox[{"Mod", "[", 
   RowBox[{
    RowBox[{"Total", "[", 
     RowBox[{"Table", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"bs", "[", 
         RowBox[{"[", "i", "]"}], "]"}], "*", 
        RowBox[{"G", "[", 
         RowBox[{"[", "i", "]"}], "]"}]}], ",", 
       RowBox[{"{", 
        RowBox[{"i", ",", "1", ",", 
         RowBox[{"Length", "[", "bs", "]"}]}], "}"}]}], "]"}], "]"}], ",", 
    "p"}], "]"}]}]], "Input",
 CellChangeTimes->{{3.54151327841785*^9, 3.5415132849781322`*^9}, {
  3.541513809824132*^9, 3.541513827574794*^9}, {3.541517253243504*^9, 
  3.5415172533072042`*^9}, {3.54151824841726*^9, 3.541518249358556*^9}, {
  3.541533820760664*^9, 3.54153383035253*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"CodeFromGeneratorMatrix", "[", 
   RowBox[{"G_", ",", "p_"}], "]"}], " ", ":=", " ", 
  RowBox[{"Module", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"m", "=", 
      RowBox[{"Length", "[", "G", "]"}]}], "}"}], ",", "\[IndentingNewLine]", 
    
    RowBox[{"Map", "[", 
     RowBox[{
      RowBox[{
       RowBox[{"CodewordFor", "[", 
        RowBox[{"#1", ",", "G", ",", "p"}], "]"}], "&"}], ",", 
      RowBox[{"AllWords", "[", 
       RowBox[{
        RowBox[{"Range", "[", 
         RowBox[{"0", ",", 
          RowBox[{"p", "-", "1"}]}], "]"}], ",", "m"}], "]"}]}], "]"}]}], 
   "]"}]}]], "Input",
 CellChangeTimes->{{3.541363910185338*^9, 3.5413639757560453`*^9}, {
  3.541364204865398*^9, 3.541364215247736*^9}, {3.541517279194149*^9, 
  3.541517279697523*^9}, {3.5415338126902*^9, 3.5415338132091093`*^9}, {
  3.5415359932324266`*^9, 3.541536041893709*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"BinaryCodeFromGeneratorMatrix", "[", "G_", "]"}], " ", ":=", " ", 
  RowBox[{"CodeFromGeneratorMatrix", "[", 
   RowBox[{"G", ",", "2"}], "]"}]}]], "Input",
 CellChangeTimes->{{3.541533839445053*^9, 3.5415338494301233`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"KernelMod", "[", 
   RowBox[{"x_", ",", "p_"}], "]"}], " ", ":=", " ", 
  RowBox[{"NullSpace", "[", 
   RowBox[{"x", ",", " ", 
    RowBox[{"Modulus", "\[Rule]", "p"}]}], "]"}]}]], "Input",
 CellChangeTimes->{{3.54151311851766*^9, 3.541513126072434*^9}, {
  3.541533374984133*^9, 3.541533459018993*^9}, {3.5415335898943243`*^9, 
  3.541533606619467*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"NumberOfWordsOfWeight", "[", 
   RowBox[{"us_", ",", "r_"}], "]"}], " ", ":=", " ", 
  RowBox[{"Length", "[", 
   RowBox[{"Select", "[", 
    RowBox[{"us", ",", 
     RowBox[{
      RowBox[{
       RowBox[{"Weight", "[", "#1", "]"}], "\[Equal]", "r"}], "&"}]}], "]"}], 
   "]"}]}]], "Input",
 CellChangeTimes->{{3.5415376984871264`*^9, 3.5415377076720667`*^9}, {
  3.541540852087762*^9, 3.5415409054658327`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"WeightEnumerator", "[", "us_", "]"}], " ", ":=", " ", 
  RowBox[{"Table", "[", 
   RowBox[{
    RowBox[{"NumberOfWordsOfWeight", "[", 
     RowBox[{"us", ",", "r"}], "]"}], ",", 
    RowBox[{"{", 
     RowBox[{"r", ",", "0", ",", 
      RowBox[{"Length", "[", 
       RowBox[{"us", "[", 
        RowBox[{"[", "1", "]"}], "]"}], "]"}]}], "}"}]}], "]"}]}]], "Input",
 CellChangeTimes->{{3.5415408779562197`*^9, 3.541540895294004*^9}}]
}, Open  ]],

Cell[CellGroupData[{

Cell["\<\
Full code, Repetition codes, Parity check codes, Binary Hamming codes\
\>", "Section",
 CellChangeTimes->{{3.54151313219669*^9, 3.541513135754237*^9}, {
  3.54151699600633*^9, 3.541516997668364*^9}, {3.5415193669710617`*^9, 
  3.541519367792892*^9}, {3.541519588565301*^9, 3.541519605483307*^9}, {
  3.541529428010057*^9, 3.5415294342339153`*^9}, {3.541536992226017*^9, 
  3.541537001520927*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"Repeat", "[", 
   RowBox[{"s_", ",", "n_"}], "]"}], " ", ":=", " ", 
  RowBox[{"Table", "[", 
   RowBox[{"s", ",", 
    RowBox[{"{", 
     RowBox[{"i", ",", "1", ",", "n"}], "}"}]}], "]"}]}]], "Input",
 CellChangeTimes->{{3.541516719640287*^9, 3.5415167331488943`*^9}, {
  3.541516788002522*^9, 3.541516788602453*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"RepetitionCode", "[", 
   RowBox[{"ss_", ",", "n_"}], "]"}], " ", ":=", 
  RowBox[{"Map", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"Repeat", "[", 
      RowBox[{"#1", ",", "n"}], "]"}], "&"}], ",", "ss"}], "]"}]}]], "Input",
 CellChangeTimes->{{3.5415117259219217`*^9, 3.541511726643107*^9}, {
  3.541513179279804*^9, 3.541513183916451*^9}, {3.5415165319611473`*^9, 
  3.5415165353589973`*^9}, {3.541516593411914*^9, 3.5415166683033247`*^9}, {
  3.541516769322947*^9, 3.541516776195381*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"SFGMForFullCode", "[", "n_", "]"}], " ", ":=", " ", 
  RowBox[{"IdentityMatrix", "[", "n", "]"}]}]], "Input",
 CellChangeTimes->{{3.5415182796691923`*^9, 3.541518299692384*^9}, {
   3.541519379323668*^9, 3.541519385762781*^9}, {3.541519527955576*^9, 
   3.541519528020235*^9}, 3.541528605338254*^9, {3.541534013263979*^9, 
   3.5415340166694736`*^9}, {3.5415340808114758`*^9, 3.541534081554852*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"SFGMForRepetitionCode", "[", "n_", "]"}], " ", ":=", " ", 
  RowBox[{"{", 
   RowBox[{"Repeat", "[", 
    RowBox[{"1", ",", "n"}], "]"}], "}"}]}]], "Input",
 CellChangeTimes->{{3.541519370124488*^9, 3.541519411000902*^9}, {
   3.541519500308935*^9, 3.5415195005241413`*^9}, 3.541528606272614*^9, {
   3.5415340219739122`*^9, 3.541534023805175*^9}, {3.541534056563265*^9, 
   3.5415340737783823`*^9}, {3.541543617502573*^9, 3.5415436182539988`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"SFGMForParityCheckCode", "[", "n_", "]"}], " ", ":=", " ", 
  RowBox[{"Map", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"Append", "[", 
      RowBox[{"#1", ",", 
       RowBox[{"-", "1"}]}], "]"}], "&"}], ",", 
    RowBox[{"SFGMForFullCode", "[", 
     RowBox[{"n", "-", "1"}], "]"}]}], "]"}]}]], "Input",
 CellChangeTimes->{{3.5415194373230047`*^9, 3.541519492533618*^9}, 
   3.541528607105338*^9, {3.541535925589733*^9, 3.541535939651001*^9}, {
   3.541536361190935*^9, 3.541536364588442*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"FullCode", "[", 
   RowBox[{"n_", ",", "p_"}], "]"}], " ", ":=", " ", 
  RowBox[{"CodeFromGeneratorMatrix", "[", 
   RowBox[{
    RowBox[{"SFGMForFullCode", "[", "n", "]"}], ",", "p"}], "]"}]}]], "Input",\

 CellChangeTimes->{{3.5415169793858557`*^9, 3.5415169825568523`*^9}, {
   3.5415170558518972`*^9, 3.5415170934668293`*^9}, {3.5415172126284103`*^9, 
   3.541517237339274*^9}, {3.541518293299633*^9, 3.541518312745891*^9}, {
   3.5415193824868*^9, 3.54151938288279*^9}, 3.541519553537847*^9, 
   3.541528608320252*^9, {3.54153410716177*^9, 3.5415341076647882`*^9}, {
   3.541535944153865*^9, 3.541535977911847*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"BinaryRepetitionCode", "[", "n_", "]"}], " ", ":=", " ", 
  RowBox[{"CodeFromGeneratorMatrix", "[", 
   RowBox[{
    RowBox[{"SFGMForRepetitionCode", "[", "n", "]"}], ",", "2"}], 
   "]"}]}]], "Input",
 CellChangeTimes->{{3.541519421133039*^9, 3.5415194336776667`*^9}, 
   3.541519557055798*^9, 3.541528609392242*^9, {3.541536325534235*^9, 
   3.541536330207515*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"BinaryParityCheckCode", "[", "n_", "]"}], " ", ":=", " ", 
  "\[IndentingNewLine]", 
  RowBox[{"CodeFromGeneratorMatrix", "[", 
   RowBox[{
    RowBox[{"SFGMForParityCheckCode", "[", "n", "]"}], ",", "2"}], 
   "]"}]}]], "Input",
 CellChangeTimes->{{3.541519541526208*^9, 3.5415195653589497`*^9}, 
   3.541528610408449*^9, {3.54153633277407*^9, 3.5415363371495333`*^9}, {
   3.541536383731835*^9, 3.541536384306752*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"PCMForBinaryHammingCode", "[", "r_", "]"}], " ", ":=", " ", 
  RowBox[{"Transpose", "[", 
   RowBox[{"Drop", "[", 
    RowBox[{
     RowBox[{"FullCode", "[", 
      RowBox[{"r", ",", "2"}], "]"}], ",", "1"}], "]"}], "]"}]}]], "Input",
 CellChangeTimes->{{3.541529484283539*^9, 3.5415295032724037`*^9}, {
  3.54152962335569*^9, 3.541529699856267*^9}, {3.541532047447217*^9, 
  3.541532065707405*^9}, {3.541532106337605*^9, 3.541532119354024*^9}, {
  3.541536663900631*^9, 3.541536668595934*^9}, {3.5415376125936813`*^9, 
  3.5415376132052937`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"GMForBinaryHammingCode", "[", "r_", "]"}], " ", ":=", " ", 
  RowBox[{"KernelMod", "[", 
   RowBox[{
    RowBox[{"PCMForBinaryHammingCode", "[", "r", "]"}], ",", "2"}], 
   "]"}]}]], "Input",
 CellChangeTimes->{{3.541532407825149*^9, 3.5415324168341913`*^9}, {
  3.541536652457753*^9, 3.5415366537643633`*^9}, {3.541536707082261*^9, 
  3.541536722545835*^9}, {3.541537615355261*^9, 3.541537626780333*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"BinaryHammingCode", "[", "r_", "]"}], " ", ":=", " ", 
  RowBox[{"CodeFromGeneratorMatrix", "[", 
   RowBox[{
    RowBox[{"GMForBinaryHammingCode", "[", "r", "]"}], ",", "2"}], 
   "]"}]}]], "Input",
 CellChangeTimes->{{3.5415367254857883`*^9, 3.541536733656163*^9}, {
  3.5415369562881727`*^9, 3.541536972883975*^9}, {3.541537620218854*^9, 
  3.541537624163836*^9}}]
}, Open  ]],

Cell[CellGroupData[{

Cell["Other Special Codes", "Section",
 CellChangeTimes->{{3.541519577460972*^9, 3.541519582887171*^9}, {
  3.541519614107937*^9, 3.5415196230709457`*^9}}],

Cell[BoxData[
 RowBox[{"SFGMForSquareCode", " ", ":=", "\[IndentingNewLine]", 
  RowBox[{"{", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
     "1", ",", "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", "1", ",", 
      "0"}], "}"}], ",", "\[IndentingNewLine]", 
    RowBox[{"{", 
     RowBox[{
     "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", 
      "1"}], "}"}], ",", "\[IndentingNewLine]", 
    RowBox[{"{", 
     RowBox[{
     "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
      "0"}], "}"}], ",", "\[IndentingNewLine]", 
    RowBox[{"{", 
     RowBox[{
     "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", "1", ",", "0", ",", 
      "1"}], "}"}]}], "}"}]}]], "Input",
 CellChangeTimes->{{3.541519628007647*^9, 3.541519631874941*^9}, 
   3.5415286203348513`*^9, {3.5415293625932903`*^9, 3.541529392368821*^9}, {
   3.541532889631259*^9, 3.541532937054962*^9}, {3.5415372406190147`*^9, 
   3.541537243695866*^9}}],

Cell[BoxData[
 RowBox[{"SquareCode", " ", ":=", " ", 
  RowBox[{"CodeFromGeneratorMatrix", "[", 
   RowBox[{"SFGMForSquareCode", ",", "2"}], "]"}]}]], "Input",
 CellChangeTimes->{{3.5415293999443502`*^9, 3.541529415236947*^9}, {
  3.541537258509185*^9, 3.541537258620573*^9}}]
}, Open  ]],

Cell[CellGroupData[{

Cell["Examples", "Section",
 CellChangeTimes->{{3.5415375064595003`*^9, 3.5415375164938993`*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"WeightEnumerator", "[", 
  RowBox[{"BinaryHammingCode", "[", "3", "]"}], "]"}]], "Input",
 CellChangeTimes->{{3.541537517862743*^9, 3.5415375183758917`*^9}, {
  3.541540910351894*^9, 3.541540916619954*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
  "1", ",", "0", ",", "0", ",", "7", ",", "7", ",", "0", ",", "0", ",", "1"}],
   "}"}]], "Output",
 CellChangeTimes->{3.541540917045199*^9, 3.5415434494421577`*^9, 
  3.5416249156852427`*^9, 3.572002890630871*^9}]
}, Open  ]],

Cell[BoxData[
 RowBox[{"DrawWords", "[", "SFGMForSquareCode", "]"}]], "Input",
 CellChangeTimes->{{3.541540963410204*^9, 3.5415409738138943`*^9}}],

Cell[BoxData[
 RowBox[{"DrawWords", "[", "SquareCode", "]"}]], "Input",
 CellChangeTimes->{{3.541540952154976*^9, 3.5415409595734787`*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"DrawWords", "[", 
  RowBox[{"BinaryHammingCode", "[", "3", "]"}], "]"}]], "Input",
 CellChangeTimes->{{3.541541030208016*^9, 3.541541040400958*^9}}],

Cell[BoxData[
 GraphicsBox[{
   RasterBox[SparseArray[
    Automatic, {16, 7}, 0., {
     1, {{0, 7, 10, 14, 18, 22, 26, 29, 32, 36, 40, 43, 46, 49, 52, 56, 
       56}, {{1}, {2}, {3}, {4}, {5}, {6}, {7}, {3}, {5}, {6}, {1}, {3}, {
       5}, {7}, {2}, {3}, {4}, {5}, {2}, {3}, {6}, {7}, {1}, {3}, {4}, {6}, {
       3}, {4}, {7}, {1}, {2}, {3}, {4}, {5}, {6}, {7}, {1}, {2}, {5}, {6}, {
       2}, {5}, {7}, {1}, {4}, {5}, {1}, {6}, {7}, {2}, {4}, {6}, {1}, {2}, {
       4}, {7}}}, CompressedData["
1:eJxTTMoPSmVkYGCwYICBD/aj9NCkAdAsRCs=
      "]}], {{0, 0}, {7, 16}}, {0, 
    1}], {
    {GrayLevel[
      NCache[-1 + GoldenRatio, 0.6180339887498949]], 
     StyleBox[
      LineBox[{{{0, 16}, {7, 16}}, {{0, 15}, {7, 15}}, {{0, 14}, {7, 14}}, {{
       0, 13}, {7, 13}}, {{0, 12}, {7, 12}}, {{0, 11}, {7, 11}}, {{0, 10}, {7,
        10}}, {{0, 9}, {7, 9}}, {{0, 8}, {7, 8}}, {{0, 7}, {7, 7}}, {{0, 6}, {
       7, 6}}, {{0, 5}, {7, 5}}, {{0, 4}, {7, 4}}, {{0, 3}, {7, 3}}, {{0, 
       2}, {7, 2}}, {{0, 1}, {7, 1}}, {{0, 0}, {7, 0}}}],
      Antialiasing->False]}, 
    {GrayLevel[
      NCache[-1 + GoldenRatio, 0.6180339887498949]], 
     StyleBox[
      LineBox[{{{0, 0}, {0, 16}}, {{1, 0}, {1, 16}}, {{2, 0}, {2, 16}}, {{3, 
       0}, {3, 16}}, {{4, 0}, {4, 16}}, {{5, 0}, {5, 16}}, {{6, 0}, {6, 
       16}}, {{7, 0}, {7, 16}}}],
      Antialiasing->False]}}},
  Frame->False,
  FrameLabel->{None, None},
  FrameTicks->{{None, None}, {None, None}}]], "Output",
 CellChangeTimes->{3.541541040882843*^9, 3.541543449549429*^9, 
  3.5416249158204803`*^9, 3.572002890750407*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"FirstNearestNeighbour", "[", 
  RowBox[{
   RowBox[{"BinaryHammingCode", "[", "3", "]"}], ",", 
   RowBox[{"{", 
    RowBox[{"0", ",", "1", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0"}],
     "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.5415410036098967`*^9, 3.541541020626194*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"{", 
   RowBox[{"0", ",", "1", ",", "0", ",", "0", ",", "1", ",", "0", ",", "1"}], 
   "}"}], "}"}]], "Output",
 CellChangeTimes->{
  3.5415410212109137`*^9, {3.541543423485866*^9, 3.541543449591374*^9}, 
   3.541543556306982*^9, 3.541624915853714*^9, 3.572002890829958*^9}]
}, Open  ]]
}, Open  ]]
},
WindowSize->{787, 662},
WindowMargins->{{Automatic, 92}, {Automatic, 0}},
ShowSelection->True,
FrontEndVersion->"8.0 for Mac OS X x86 (32-bit, 64-bit Kernel) (February 23, \
2011)",
StyleDefinitions->"Default.nb"
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{
 "Info3572002889-4411412"->{
  Cell[18153, 505, 507, 12, 39, "Print",
   CellTags->"Info3572002889-4411412"]}
 }
*)
(*CellTagsIndex
CellTagsIndex->{
 {"Info3572002889-4411412", 33115, 915}
 }
*)
(*NotebookFileOutline
Notebook[{
Cell[CellGroupData[{
Cell[579, 22, 104, 1, 67, "Section"],
Cell[686, 25, 432, 14, 27, "Input"],
Cell[1121, 41, 682, 17, 27, "Input"],
Cell[1806, 60, 879, 22, 27, "Input"],
Cell[2688, 84, 513, 12, 27, "Input"],
Cell[3204, 98, 389, 7, 27, "Input"],
Cell[3596, 107, 329, 8, 27, "Input"],
Cell[3928, 117, 1118, 30, 43, "Input"],
Cell[5049, 149, 337, 10, 27, "Input"]
}, Open  ]],
Cell[CellGroupData[{
Cell[5423, 164, 113, 1, 67, "Section"],
Cell[5539, 167, 453, 9, 27, "Input"],
Cell[5995, 178, 1157, 32, 58, "Input"],
Cell[7155, 212, 379, 9, 27, "Input"]
}, Open  ]],
Cell[CellGroupData[{
Cell[7571, 226, 98, 1, 67, "Section"],
Cell[7672, 229, 702, 13, 27, "Input"],
Cell[8377, 244, 617, 15, 27, "Input"],
Cell[8997, 261, 598, 15, 43, "Input"],
Cell[9598, 278, 1018, 26, 58, "Input"],
Cell[10619, 306, 1401, 38, 73, "Input"],
Cell[CellGroupData[{
Cell[12045, 348, 172, 3, 27, "Input"],
Cell[12220, 353, 498, 10, 23, "Message"],
Cell[12721, 365, 712, 18, 43, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[13470, 388, 812, 18, 58, "Input"],
Cell[14285, 408, 990, 23, 45, "Output"],
Cell[15278, 433, 689, 13, 40, "Message"],
Cell[15970, 448, 569, 11, 23, "Message"],
Cell[16542, 461, 557, 11, 23, "Message"],
Cell[17102, 474, 893, 22, 43, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[18032, 501, 118, 2, 27, "Input"],
Cell[18153, 505, 507, 12, 39, "Print",
 CellTags->"Info3572002889-4411412"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[18709, 523, 148, 2, 67, "Section"],
Cell[18860, 527, 816, 21, 27, "Input"],
Cell[19679, 550, 905, 24, 43, "Input"],
Cell[20587, 576, 259, 5, 27, "Input"],
Cell[20849, 583, 389, 9, 27, "Input"],
Cell[21241, 594, 447, 12, 27, "Input"],
Cell[21691, 608, 467, 12, 27, "Input"]
}, Open  ]],
Cell[CellGroupData[{
Cell[22195, 625, 406, 7, 67, "Section"],
Cell[22604, 634, 353, 9, 27, "Input"],
Cell[22960, 645, 529, 12, 27, "Input"],
Cell[23492, 659, 434, 7, 27, "Input"],
Cell[23929, 668, 483, 9, 27, "Input"],
Cell[24415, 679, 531, 13, 27, "Input"],
Cell[24949, 694, 655, 13, 27, "Input"],
Cell[25607, 709, 402, 9, 27, "Input"],
Cell[26012, 720, 455, 10, 43, "Input"],
Cell[26470, 732, 582, 12, 27, "Input"],
Cell[27055, 746, 440, 9, 27, "Input"],
Cell[27498, 757, 402, 9, 27, "Input"]
}, Open  ]],
Cell[CellGroupData[{
Cell[27937, 771, 155, 2, 67, "Section"],
Cell[28095, 775, 970, 23, 88, "Input"],
Cell[29068, 800, 276, 5, 27, "Input"]
}, Open  ]],
Cell[CellGroupData[{
Cell[29381, 810, 97, 1, 67, "Section"],
Cell[CellGroupData[{
Cell[29503, 815, 230, 4, 27, "Input"],
Cell[29736, 821, 254, 6, 27, "Output"]
}, Open  ]],
Cell[30005, 830, 146, 2, 27, "Input"],
Cell[30154, 834, 139, 2, 27, "Input"],
Cell[CellGroupData[{
Cell[30318, 840, 172, 3, 27, "Input"],
Cell[30493, 845, 1585, 33, 447, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[32115, 883, 314, 7, 27, "Input"],
Cell[32432, 892, 314, 7, 27, "Output"]
}, Open  ]]
}, Open  ]]
}
]
*)

(* End of internal cache information *)
