(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 8.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       157,          7]
NotebookDataLength[    136256,       3738]
NotebookOptionsPosition[    127315,       3443]
NotebookOutlinePosition[    127693,       3460]
CellTagsIndexPosition[    127650,       3457]
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell["\<\
All bytes and bit streams are stored with most significant bit first\
\>", "Subsection",
 CellChangeTimes->{{3.565900508895306*^9, 3.565900518300283*^9}}],

Cell[CellGroupData[{

Cell["\<\
Make V1 QR symbol with specified format string and 26 specified bytes\
\>", "Section",
 CellChangeTimes->{{3.565719229426323*^9, 3.5657192411294127`*^9}, {
  3.5658955423206367`*^9, 3.565895553736293*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"drawMatrix", "[", "H_", "]"}], " ", ":=", " ", 
  RowBox[{"Module", "[", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"Boxes", " ", "=", " ", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"0", "\[Rule]", "White"}], ",", 
        RowBox[{"1", "\[Rule]", "Black"}]}], "}"}]}], "}"}], ",", 
    "\[IndentingNewLine]", 
    RowBox[{"ArrayPlot", "[", 
     RowBox[{"H", ",", 
      RowBox[{"ColorRules", "\[Rule]", "Boxes"}]}], "]"}]}], "]"}]}]], "Input",\

 CellChangeTimes->{{3.565637153407352*^9, 3.565637155053575*^9}, {
  3.5657121251223583`*^9, 3.565712125655843*^9}}],

Cell[BoxData[
 RowBox[{"emptyV1", " ", ":=", " ", "\[IndentingNewLine]", 
  RowBox[{"{", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
     "1", ",", "1", ",", "1", ",", "1", ",", "1", ",", "1", ",", "1", ",", 
      "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
      "1", ",", "1", ",", "1", ",", "1", ",", "1", ",", "1", ",", "1"}], 
     "}"}], ",", "\[IndentingNewLine]", 
    RowBox[{"{", 
     RowBox[{
     "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
      "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
      "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1"}], 
     "}"}], ",", "\[IndentingNewLine]", 
    RowBox[{"{", 
     RowBox[{
     "1", ",", "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", "1", ",", 
      "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
      "1", ",", "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", "1"}], 
     "}"}], ",", "\[IndentingNewLine]", 
    RowBox[{"{", 
     RowBox[{
     "1", ",", "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", "1", ",", 
      "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
      "1", ",", "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", "1"}], 
     "}"}], ",", "\[IndentingNewLine]", 
    RowBox[{"{", 
     RowBox[{
     "1", ",", "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", "1", ",", 
      "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
      "1", ",", "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", "1"}], 
     "}"}], ",", "\[IndentingNewLine]", 
    RowBox[{"{", 
     RowBox[{
     "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
      "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
      "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1"}], 
     "}"}], ",", "\[IndentingNewLine]", 
    RowBox[{"{", 
     RowBox[{
     "1", ",", "1", ",", "1", ",", "1", ",", "1", ",", "1", ",", "1", ",", 
      "0", ",", "1", ",", "0", ",", "1", ",", "0", ",", "1", ",", "0", ",", 
      "1", ",", "1", ",", "1", ",", "1", ",", "1", ",", "1", ",", "1"}], 
     "}"}], ",", "\[IndentingNewLine]", 
    RowBox[{"{", 
     RowBox[{
     "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
      "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
      "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0"}], 
     "}"}], ",", "\[IndentingNewLine]", 
    RowBox[{"{", 
     RowBox[{
     "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
      "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
      "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0"}], 
     "}"}], ",", "\[IndentingNewLine]", 
    RowBox[{"{", 
     RowBox[{
     "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
      "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
      "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0"}], 
     "}"}], ",", "\[IndentingNewLine]", 
    RowBox[{"{", 
     RowBox[{
     "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
      "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
      "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0"}], 
     "}"}], ",", "\[IndentingNewLine]", 
    RowBox[{"{", 
     RowBox[{
     "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
      "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
      "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0"}], 
     "}"}], ",", "\[IndentingNewLine]", 
    RowBox[{"{", 
     RowBox[{
     "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
      "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
      "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0"}], 
     "}"}], ",", "\[IndentingNewLine]", 
    RowBox[{"{", 
     RowBox[{
     "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
      "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
      "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0"}], 
     "}"}], ",", "\[IndentingNewLine]", 
    RowBox[{"{", 
     RowBox[{
     "1", ",", "1", ",", "1", ",", "1", ",", "1", ",", "1", ",", "1", ",", 
      "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
      "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0"}], 
     "}"}], ",", "\[IndentingNewLine]", 
    RowBox[{"{", 
     RowBox[{
     "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
      "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
      "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0"}], 
     "}"}], ",", "\[IndentingNewLine]", 
    RowBox[{"{", 
     RowBox[{
     "1", ",", "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", "1", ",", 
      "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
      "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0"}], 
     "}"}], ",", "\[IndentingNewLine]", 
    RowBox[{"{", 
     RowBox[{
     "1", ",", "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", "1", ",", 
      "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
      "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0"}], 
     "}"}], ",", "\[IndentingNewLine]", 
    RowBox[{"{", 
     RowBox[{
     "1", ",", "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", "1", ",", 
      "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
      "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0"}], 
     "}"}], ",", "\[IndentingNewLine]", 
    RowBox[{"{", 
     RowBox[{
     "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
      "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
      "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0"}], 
     "}"}], ",", "\[IndentingNewLine]", 
    RowBox[{"{", 
     RowBox[{
     "1", ",", "1", ",", "1", ",", "1", ",", "1", ",", "1", ",", "1", ",", 
      "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
      "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0"}], 
     "}"}]}], "}"}]}]], "Input",
 CellChangeTimes->{{3.565637034780507*^9, 3.565637143161042*^9}, {
  3.565895008512805*^9, 3.5658952278267393`*^9}, {3.565898231438919*^9, 
  3.5658982315264883`*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"drawMatrix", "[", "emptyV1", "]"}]], "Input",
 CellChangeTimes->{{3.565895165385667*^9, 3.565895167658291*^9}, {
  3.5658982351414423`*^9, 3.565898235211691*^9}}],

Cell[BoxData[
 GraphicsBox[
  RasterBox[SparseArray[
   Automatic, {21, 21}, 1., {
    1, {{0, 7, 9, 14, 19, 24, 26, 33, 34, 35, 35, 36, 36, 37, 37, 54, 58, 68, 
      78, 88, 92, 106}, {{1}, {2}, {3}, {4}, {5}, {6}, {7}, {1}, {7}, {1}, {
      3}, {4}, {5}, {7}, {1}, {3}, {4}, {5}, {7}, {1}, {3}, {4}, {5}, {7}, {
      1}, {7}, {1}, {2}, {3}, {4}, {5}, {6}, {7}, {9}, {7}, {7}, {7}, {1}, {
      2}, {3}, {4}, {5}, {6}, {7}, {9}, {11}, {13}, {15}, {16}, {17}, {18}, {
      19}, {20}, {21}, {1}, {7}, {15}, {21}, {1}, {3}, {4}, {5}, {7}, {15}, {
      17}, {18}, {19}, {21}, {1}, {3}, {4}, {5}, {7}, {15}, {17}, {18}, {
      19}, {21}, {1}, {3}, {4}, {5}, {7}, {15}, {17}, {18}, {19}, {21}, {1}, {
      7}, {15}, {21}, {1}, {2}, {3}, {4}, {5}, {6}, {7}, {15}, {16}, {17}, {
      18}, {19}, {20}, {21}}}, CompressedData["
1:eJxTTMoPSmVkYGDIYhgFo2AUUBMAAPlyAhU=
     "]}], {{0, 0}, {21, 21}}, {0, 1}],
  
  Frame->Automatic,
  FrameLabel->{None, None},
  FrameTicks->{{None, None}, {None, None}}]], "Output",
 CellChangeTimes->{{3.5658951682953453`*^9, 3.565895176633108*^9}, {
   3.565895219052894*^9, 3.56589522965552*^9}, 3.565898235507942*^9, 
   3.565904529758243*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell["\<\
Format string appears twice: the least significant bit goes in the top middle \
(then down and left) and right middle (then left and down)\
\>", "Subsection",
 CellChangeTimes->{{3.565900450025052*^9, 3.56590048913398*^9}}],

Cell[BoxData[
 RowBox[{"testFormatString", " ", ":=", " ", 
  RowBox[{"{", 
   RowBox[{
   "14", ",", "13", ",", "12", ",", "11", ",", "10", ",", "9", ",", "8", ",", 
    "7", ",", "6", ",", "5", ",", "4", ",", "3", ",", "2", ",", "1", ",", 
    "0"}], "}"}]}]], "Input",
 CellChangeTimes->{{3.565898799361785*^9, 3.565898807918947*^9}, {
  3.565901395537014*^9, 3.565901401656787*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"V1withFormatString", "[", "fs_", "]"}], ":=", 
  "\[IndentingNewLine]", 
  RowBox[{"Module", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"M", " ", "=", " ", "emptyV1"}], "}"}], ",", 
    "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"For", "[", 
      RowBox[{
       RowBox[{"i", "=", "1"}], ",", 
       RowBox[{"i", "\[LessEqual]", "6"}], ",", 
       RowBox[{"i", "++"}], ",", 
       RowBox[{
        RowBox[{
         RowBox[{"M", "[", 
          RowBox[{"[", "9", "]"}], "]"}], "[", 
         RowBox[{"[", "i", "]"}], "]"}], " ", "=", " ", 
        RowBox[{"fs", "[", 
         RowBox[{"[", "i", "]"}], "]"}]}]}], "]"}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{
       RowBox[{"M", "[", 
        RowBox[{"[", "9", "]"}], "]"}], "[", 
       RowBox[{"[", "8", "]"}], "]"}], " ", "=", " ", 
      RowBox[{"fs", "[", 
       RowBox[{"[", "7", "]"}], "]"}]}], ";", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{
       RowBox[{"M", "[", 
        RowBox[{"[", "9", "]"}], "]"}], "[", 
       RowBox[{"[", "9", "]"}], "]"}], " ", "=", " ", 
      RowBox[{"fs", "[", 
       RowBox[{"[", "8", "]"}], "]"}]}], ";", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{
       RowBox[{"M", "[", 
        RowBox[{"[", "8", "]"}], "]"}], "[", 
       RowBox[{"[", "9", "]"}], "]"}], " ", "=", " ", 
      RowBox[{"fs", "[", 
       RowBox[{"[", "9", "]"}], "]"}]}], ";", " ", "\[IndentingNewLine]", 
     RowBox[{"For", "[", 
      RowBox[{
       RowBox[{"j", "=", "10"}], ",", 
       RowBox[{"j", "\[LessEqual]", "15"}], ",", 
       RowBox[{"j", "++"}], ",", 
       RowBox[{
        RowBox[{
         RowBox[{"M", "[", 
          RowBox[{"[", 
           RowBox[{"6", "-", 
            RowBox[{"(", 
             RowBox[{"j", "-", "10"}], ")"}]}], "]"}], "]"}], "[", 
         RowBox[{"[", "9", "]"}], "]"}], " ", "=", " ", 
        RowBox[{"fs", "[", 
         RowBox[{"[", "j", "]"}], "]"}]}]}], "]"}], ";", " ", 
     "\[IndentingNewLine]", 
     RowBox[{"For", "[", 
      RowBox[{
       RowBox[{"i", "=", "1"}], ",", 
       RowBox[{"i", "\[LessEqual]", "7"}], ",", 
       RowBox[{"i", "++"}], ",", 
       RowBox[{
        RowBox[{
         RowBox[{"M", "[", 
          RowBox[{"[", 
           RowBox[{"22", "-", "i"}], "]"}], "]"}], "[", 
         RowBox[{"[", "9", "]"}], "]"}], "=", 
        RowBox[{"fs", "[", 
         RowBox[{"[", "i", "]"}], "]"}]}]}], "]"}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"For", "[", 
      RowBox[{
       RowBox[{"j", "=", "8"}], ",", 
       RowBox[{"j", "\[LessEqual]", "15"}], ",", 
       RowBox[{"j", "++"}], ",", 
       RowBox[{
        RowBox[{
         RowBox[{"M", "[", 
          RowBox[{"[", "9", "]"}], "]"}], "[", 
         RowBox[{"[", 
          RowBox[{"14", "+", 
           RowBox[{"(", 
            RowBox[{"j", "-", "8"}], ")"}]}], "]"}], "]"}], "=", 
        RowBox[{"fs", "[", 
         RowBox[{"[", "j", "]"}], "]"}]}]}], "]"}], ";", 
     "\[IndentingNewLine]", "M"}]}], "]"}]}]], "Input",
 CellChangeTimes->{{3.5656372866391783`*^9, 3.565637288962586*^9}, {
   3.565637674445828*^9, 3.5656377108169203`*^9}, {3.56563776446484*^9, 
   3.565637848994725*^9}, {3.5656378818975153`*^9, 3.565637883531538*^9}, {
   3.5656379200235167`*^9, 3.565637920343645*^9}, 3.5656383669052477`*^9, {
   3.565895344238851*^9, 3.565895481678713*^9}, {3.5658982384027243`*^9, 
   3.565898238991662*^9}, {3.565899606546987*^9, 3.5658996900899153`*^9}, {
   3.5659005871848927`*^9, 3.5659006585411463`*^9}, {3.5659013161389427`*^9, 
   3.5659013546015663`*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"MatrixForm", "[", 
  RowBox[{"V1withFormatString", "[", "testFormatString", "]"}], 
  "]"}]], "Input",
 CellChangeTimes->{{3.565895489371166*^9, 3.565895508450101*^9}, {
  3.565900541709345*^9, 3.565900555300352*^9}, {3.565901407312149*^9, 
  3.565901409447937*^9}}],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {"1", "1", "1", "1", "1", "1", "1", "0", "0", "0", "0", "0", "0", "0", 
      "1", "1", "1", "1", "1", "1", "1"},
     {"1", "0", "0", "0", "0", "0", "1", "0", "1", "0", "0", "0", "0", "0", 
      "1", "0", "0", "0", "0", "0", "1"},
     {"1", "0", "1", "1", "1", "0", "1", "0", "2", "0", "0", "0", "0", "0", 
      "1", "0", "1", "1", "1", "0", "1"},
     {"1", "0", "1", "1", "1", "0", "1", "0", "3", "0", "0", "0", "0", "0", 
      "1", "0", "1", "1", "1", "0", "1"},
     {"1", "0", "1", "1", "1", "0", "1", "0", "4", "0", "0", "0", "0", "0", 
      "1", "0", "1", "1", "1", "0", "1"},
     {"1", "0", "0", "0", "0", "0", "1", "0", "5", "0", "0", "0", "0", "0", 
      "1", "0", "0", "0", "0", "0", "1"},
     {"1", "1", "1", "1", "1", "1", "1", "0", "1", "0", "1", "0", "1", "0", 
      "1", "1", "1", "1", "1", "1", "1"},
     {"0", "0", "0", "0", "0", "0", "0", "0", "6", "0", "0", "0", "0", "0", 
      "0", "0", "0", "0", "0", "0", "0"},
     {"14", "13", "12", "11", "10", "9", "1", "8", "7", "0", "0", "0", "0", 
      "7", "6", "5", "4", "3", "2", "1", "0"},
     {"0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", 
      "0", "0", "0", "0", "0", "0", "0"},
     {"0", "0", "0", "0", "0", "0", "1", "0", "0", "0", "0", "0", "0", "0", 
      "0", "0", "0", "0", "0", "0", "0"},
     {"0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", 
      "0", "0", "0", "0", "0", "0", "0"},
     {"0", "0", "0", "0", "0", "0", "1", "0", "0", "0", "0", "0", "0", "0", 
      "0", "0", "0", "0", "0", "0", "0"},
     {"0", "0", "0", "0", "0", "0", "0", "0", "1", "0", "0", "0", "0", "0", 
      "0", "0", "0", "0", "0", "0", "0"},
     {"1", "1", "1", "1", "1", "1", "1", "0", "8", "0", "0", "0", "0", "0", 
      "0", "0", "0", "0", "0", "0", "0"},
     {"1", "0", "0", "0", "0", "0", "1", "0", "9", "0", "0", "0", "0", "0", 
      "0", "0", "0", "0", "0", "0", "0"},
     {"1", "0", "1", "1", "1", "0", "1", "0", "10", "0", "0", "0", "0", "0", 
      "0", "0", "0", "0", "0", "0", "0"},
     {"1", "0", "1", "1", "1", "0", "1", "0", "11", "0", "0", "0", "0", "0", 
      "0", "0", "0", "0", "0", "0", "0"},
     {"1", "0", "1", "1", "1", "0", "1", "0", "12", "0", "0", "0", "0", "0", 
      "0", "0", "0", "0", "0", "0", "0"},
     {"1", "0", "0", "0", "0", "0", "1", "0", "13", "0", "0", "0", "0", "0", 
      "0", "0", "0", "0", "0", "0", "0"},
     {"1", "1", "1", "1", "1", "1", "1", "0", "14", "0", "0", "0", "0", "0", 
      "0", "0", "0", "0", "0", "0", "0"}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{{3.56589549926985*^9, 3.565895508954749*^9}, 
   3.5658982415512123`*^9, 3.565899693538179*^9, 3.565900556031268*^9, 
   3.565901358070058*^9, 3.5659014099885597`*^9, {3.565904533841066*^9, 
   3.565904566773136*^9}}]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{"row", "[", "k_", "]"}], " ", ":=", " ", 
  RowBox[{
   RowBox[{"positionsOfMostSignificantBits", "[", 
    RowBox[{"[", "k", "]"}], "]"}], "[", 
   RowBox[{"[", "1", "]"}], "]"}]}]], "Input",
 CellChangeTimes->{{3.565895804187066*^9, 3.565895820824251*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"col", "[", "k_", "]"}], " ", ":=", " ", 
  RowBox[{
   RowBox[{"positionsOfMostSignificantBits", "[", 
    RowBox[{"[", "k", "]"}], "]"}], "[", 
   RowBox[{"[", "2", "]"}], "]"}]}]], "Input",
 CellChangeTimes->{{3.5658958225144167`*^9, 3.565895832575675*^9}}],

Cell[BoxData[
 RowBox[{"positionsOfMostSignificantBits", " ", ":=", " ", 
  RowBox[{"{", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"21", ",", "21"}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"17", ",", "21"}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"13", ",", "21"}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"10", ",", "19"}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"14", ",", "19"}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"18", ",", "19"}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"21", ",", "17"}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"17", ",", "17"}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"13", ",", "17"}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"10", ",", "15"}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"14", ",", "15"}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"18", ",", "15"}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"21", ",", "13"}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"17", ",", "13"}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"13", ",", "13"}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"9", ",", "13"}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"4", ",", "13"}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"1", ",", "11"}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"5", ",", "11"}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"10", ",", "11"}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"14", ",", "11"}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"18", ",", "11"}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"13", ",", "9"}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"10", ",", "6"}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"13", ",", "4"}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"10", ",", "2"}], "}"}]}], "}"}]}]], "Input",
 CellChangeTimes->{{3.565895834619122*^9, 3.565895840663735*^9}, {
  3.5658962669184732`*^9, 3.5658963159854393`*^9}, {3.565896392589649*^9, 
  3.565896438492819*^9}, {3.565896489337563*^9, 3.565896556773967*^9}, {
  3.565896593116324*^9, 3.565896624347248*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"SetUp", "[", 
   RowBox[{"M_", ",", "r_", ",", "s_", ",", "bs_"}], "]"}], ":=", 
  RowBox[{"Module", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"N", "=", "M"}], "}"}], ",", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"For", "[", 
      RowBox[{
       RowBox[{"i", "=", "0"}], ",", 
       RowBox[{"i", "\[LessEqual]", "3"}], ",", 
       RowBox[{"i", "++"}], ",", 
       RowBox[{
        RowBox[{
         RowBox[{"N", "[", 
          RowBox[{"[", 
           RowBox[{"r", "-", "i"}], "]"}], "]"}], "[", 
         RowBox[{"[", "s", "]"}], "]"}], "=", 
        RowBox[{"bs", "[", 
         RowBox[{"[", 
          RowBox[{
           RowBox[{"2", "*", "i"}], "+", "1"}], "]"}], "]"}]}]}], "]"}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"For", "[", 
      RowBox[{
       RowBox[{"i", "=", "0"}], ",", 
       RowBox[{"i", "\[LessEqual]", "3"}], ",", 
       RowBox[{"i", "++"}], ",", 
       RowBox[{
        RowBox[{
         RowBox[{"N", "[", 
          RowBox[{"[", 
           RowBox[{"r", "-", "i"}], "]"}], "]"}], "[", 
         RowBox[{"[", 
          RowBox[{"s", "-", "1"}], "]"}], "]"}], "=", 
        RowBox[{"bs", "[", 
         RowBox[{"[", 
          RowBox[{
           RowBox[{"2", "*", "i"}], "+", "2"}], "]"}], "]"}]}]}], "]"}], ";", 
     "\[IndentingNewLine]", "N"}]}], "]"}]}]], "Input",
 CellChangeTimes->{{3.565639779060184*^9, 3.5656398742442913`*^9}, {
  3.5658231932367277`*^9, 3.5658232007641277`*^9}, {3.5658978240521383`*^9, 
  3.565897827404705*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"SetUp16", "[", 
   RowBox[{"M_", ",", "bs_"}], "]"}], " ", ":=", " ", 
  RowBox[{"Module", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"N", "=", "M"}], "}"}], ",", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{"N", "[", 
        RowBox[{"[", "9", "]"}], "]"}], "[", 
       RowBox[{"[", "13", "]"}], "]"}], "=", 
      RowBox[{"bs", "[", 
       RowBox[{"[", "1", "]"}], "]"}]}], ";", " ", 
     RowBox[{
      RowBox[{
       RowBox[{"N", "[", 
        RowBox[{"[", "9", "]"}], "]"}], "[", 
       RowBox[{"[", "12", "]"}], "]"}], "=", 
      RowBox[{"bs", "[", 
       RowBox[{"[", "2", "]"}], "]"}]}], ";", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{
       RowBox[{"N", "[", 
        RowBox[{"[", "8", "]"}], "]"}], "[", 
       RowBox[{"[", "13", "]"}], "]"}], "=", 
      RowBox[{"bs", "[", 
       RowBox[{"[", "3", "]"}], "]"}]}], ";", " ", 
     RowBox[{
      RowBox[{
       RowBox[{"N", "[", 
        RowBox[{"[", "8", "]"}], "]"}], "[", 
       RowBox[{"[", "12", "]"}], "]"}], "=", 
      RowBox[{"bs", "[", 
       RowBox[{"[", "4", "]"}], "]"}]}], ";", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{
       RowBox[{"N", "[", 
        RowBox[{"[", "6", "]"}], "]"}], "[", 
       RowBox[{"[", "13", "]"}], "]"}], "=", 
      RowBox[{"bs", "[", 
       RowBox[{"[", "5", "]"}], "]"}]}], ";", " ", 
     RowBox[{
      RowBox[{
       RowBox[{"N", "[", 
        RowBox[{"[", "6", "]"}], "]"}], "[", 
       RowBox[{"[", "12", "]"}], "]"}], "=", 
      RowBox[{"bs", "[", 
       RowBox[{"[", "6", "]"}], "]"}]}], ";", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{
       RowBox[{"N", "[", 
        RowBox[{"[", "5", "]"}], "]"}], "[", 
       RowBox[{"[", "13", "]"}], "]"}], "=", 
      RowBox[{"bs", "[", 
       RowBox[{"[", "7", "]"}], "]"}]}], ";", " ", 
     RowBox[{
      RowBox[{
       RowBox[{"N", "[", 
        RowBox[{"[", "5", "]"}], "]"}], "[", 
       RowBox[{"[", "12", "]"}], "]"}], "=", 
      RowBox[{"bs", "[", 
       RowBox[{"[", "8", "]"}], "]"}]}], ";", "\[IndentingNewLine]", "N"}]}], 
   "]"}]}]], "Input",
 CellChangeTimes->{{3.565897194044273*^9, 3.565897209217894*^9}, {
  3.565897440944539*^9, 3.5658975186124477`*^9}, {3.5658976955478077`*^9, 
  3.56589773002575*^9}, {3.5658978297084503`*^9, 3.5658978359656773`*^9}, {
  3.565898469131764*^9, 3.565898517841872*^9}, {3.565898591047114*^9, 
  3.565898591910376*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"SetDown", "[", 
   RowBox[{"M_", ",", "r_", ",", "s_", ",", "bs_"}], "]"}], " ", ":=", " ", 
  RowBox[{"Module", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"N", "=", "M"}], "}"}], ",", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"For", "[", 
      RowBox[{
       RowBox[{"i", "=", "0"}], ",", 
       RowBox[{"i", "\[LessEqual]", "3"}], ",", 
       RowBox[{"i", "++"}], ",", 
       RowBox[{
        RowBox[{
         RowBox[{"N", "[", 
          RowBox[{"[", 
           RowBox[{"r", "+", "i"}], "]"}], "]"}], "[", 
         RowBox[{"[", "s", "]"}], "]"}], "=", 
        RowBox[{"bs", "[", 
         RowBox[{"[", 
          RowBox[{
           RowBox[{"2", "*", "i"}], "+", "1"}], "]"}], "]"}]}]}], "]"}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"For", "[", 
      RowBox[{
       RowBox[{"i", "=", "0"}], ",", 
       RowBox[{"i", "\[LessEqual]", "3"}], ",", 
       RowBox[{"i", "++"}], ",", 
       RowBox[{
        RowBox[{
         RowBox[{"N", "[", 
          RowBox[{"[", 
           RowBox[{"r", "+", "i"}], "]"}], "]"}], "[", 
         RowBox[{"[", 
          RowBox[{"s", "-", "1"}], "]"}], "]"}], "=", 
        RowBox[{"bs", "[", 
         RowBox[{"[", 
          RowBox[{
           RowBox[{"2", "*", "i"}], "+", "2"}], "]"}], "]"}]}]}], "]"}], ";", 
     "\[IndentingNewLine]", "N"}]}], "]"}]}]], "Input",
 CellChangeTimes->{{3.565640078258872*^9, 3.5656400828918247`*^9}, {
  3.56570958877995*^9, 3.565709631441284*^9}, {3.565709709143387*^9, 
  3.565709768525827*^9}, {3.56582328519205*^9, 3.5658233103106337`*^9}, {
  3.565896935173356*^9, 3.565896943857849*^9}, {3.565897838715394*^9, 
  3.565897842507123*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"SetDown19", "[", 
   RowBox[{"M_", ",", "bs_"}], "]"}], " ", ":=", " ", 
  RowBox[{"Module", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"N", "=", "M"}], "}"}], ",", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{"N", "[", 
        RowBox[{"[", "5", "]"}], "]"}], "[", 
       RowBox[{"[", "11", "]"}], "]"}], "=", 
      RowBox[{"bs", "[", 
       RowBox[{"[", "1", "]"}], "]"}]}], ";", " ", 
     RowBox[{
      RowBox[{
       RowBox[{"N", "[", 
        RowBox[{"[", "5", "]"}], "]"}], "[", 
       RowBox[{"[", "10", "]"}], "]"}], "=", 
      RowBox[{"bs", "[", 
       RowBox[{"[", "2", "]"}], "]"}]}], ";", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{
       RowBox[{"N", "[", 
        RowBox[{"[", "6", "]"}], "]"}], "[", 
       RowBox[{"[", "11", "]"}], "]"}], "=", 
      RowBox[{"bs", "[", 
       RowBox[{"[", "3", "]"}], "]"}]}], ";", " ", 
     RowBox[{
      RowBox[{
       RowBox[{"N", "[", 
        RowBox[{"[", "6", "]"}], "]"}], "[", 
       RowBox[{"[", "10", "]"}], "]"}], "=", 
      RowBox[{"bs", "[", 
       RowBox[{"[", "4", "]"}], "]"}]}], ";", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{
       RowBox[{"N", "[", 
        RowBox[{"[", "8", "]"}], "]"}], "[", 
       RowBox[{"[", "11", "]"}], "]"}], "=", 
      RowBox[{"bs", "[", 
       RowBox[{"[", "5", "]"}], "]"}]}], ";", " ", 
     RowBox[{
      RowBox[{
       RowBox[{"N", "[", 
        RowBox[{"[", "8", "]"}], "]"}], "[", 
       RowBox[{"[", "10", "]"}], "]"}], "=", 
      RowBox[{"bs", "[", 
       RowBox[{"[", "6", "]"}], "]"}]}], ";", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{
       RowBox[{"N", "[", 
        RowBox[{"[", "9", "]"}], "]"}], "[", 
       RowBox[{"[", "11", "]"}], "]"}], "=", 
      RowBox[{"bs", "[", 
       RowBox[{"[", "7", "]"}], "]"}]}], ";", " ", 
     RowBox[{
      RowBox[{
       RowBox[{"N", "[", 
        RowBox[{"[", "9", "]"}], "]"}], "[", 
       RowBox[{"[", "10", "]"}], "]"}], "=", 
      RowBox[{"bs", "[", 
       RowBox[{"[", "8", "]"}], "]"}]}], ";", "\[IndentingNewLine]", "N"}]}], 
   "]"}]}]], "Input",
 CellChangeTimes->{{3.565897524317943*^9, 3.565897525828312*^9}, {
  3.5658976983792467`*^9, 3.565897747816868*^9}, {3.565897844731935*^9, 
  3.56589785200342*^9}, {3.5658985312808647`*^9, 3.565898573927103*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"SetCodeword", "[", 
   RowBox[{"M_", ",", "k_", ",", "u_"}], "]"}], ":=", "\[IndentingNewLine]", 
  RowBox[{"If", "[", 
   RowBox[{
    RowBox[{"MemberQ", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
       "1", ",", "2", ",", "3", ",", "7", ",", "8", ",", "9", ",", "13", ",", 
        "14", ",", "15", ",", "17", ",", "23", ",", "25"}], "}"}], ",", "k"}],
      "]"}], ",", "\[IndentingNewLine]", 
    RowBox[{"SetUp", "[", 
     RowBox[{"M", ",", 
      RowBox[{"row", "[", "k", "]"}], ",", 
      RowBox[{"col", "[", "k", "]"}], ",", "u"}], "]"}], ",", 
    "\[IndentingNewLine]", 
    RowBox[{"If", "[", 
     RowBox[{
      RowBox[{"MemberQ", "[", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4", ",", "5", ",", "6", ",", "10", ",", "11", ",", "12", ",", "18", 
          ",", "20", ",", "21", ",", "22", ",", "24", ",", "26"}], "}"}], ",",
         "k"}], "]"}], ",", "\[IndentingNewLine]", 
      RowBox[{"SetDown", "[", 
       RowBox[{"M", ",", 
        RowBox[{"row", "[", "k", "]"}], ",", 
        RowBox[{"col", "[", "k", "]"}], ",", "u"}], "]"}], ",", 
      "\[IndentingNewLine]", 
      RowBox[{"If", "[", 
       RowBox[{
        RowBox[{"k", "\[Equal]", "16"}], ",", "\[IndentingNewLine]", 
        RowBox[{"SetUp16", "[", 
         RowBox[{"M", ",", "u"}], "]"}], ",", "\[IndentingNewLine]", 
        RowBox[{"If", "[", 
         RowBox[{
          RowBox[{"k", "\[Equal]", "19"}], ",", "\[IndentingNewLine]", 
          RowBox[{"SetDown19", "[", 
           RowBox[{"M", ",", "u"}], "]"}], ",", "\[IndentingNewLine]", 
          RowBox[{
          "Print", "[", "\"\<No codeword exists for that number in V1\>\"", 
           "]"}]}], "]"}]}], "]"}]}], "]"}]}], "]"}]}]], "Input",
 CellChangeTimes->{{3.5656380755960197`*^9, 3.5656381574322577`*^9}, {
  3.565638287045641*^9, 3.565638362772292*^9}, {3.5656384541179123`*^9, 
  3.565638749306477*^9}, {3.5656387933777733`*^9, 3.5656388095661497`*^9}, {
  3.565639980730612*^9, 3.5656400305230427`*^9}, {3.565709796513208*^9, 
  3.565709849912136*^9}, {3.565896967223373*^9, 3.565897047516157*^9}, {
  3.565897111444703*^9, 3.5658971833426533`*^9}, {3.5658978551801023`*^9, 
  3.565897861763373*^9}, {3.565898333739469*^9, 3.565898342298687*^9}, {
  3.5658986741699533`*^9, 3.565898682785187*^9}, {3.5658987176336317`*^9, 
  3.565898749231615*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"V1", "[", 
   RowBox[{"formatString_", ",", "us_"}], "]"}], ":=", " ", 
  RowBox[{"Module", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"N", " ", "=", " ", 
      RowBox[{"V1withFormatString", "[", "formatString", "]"}]}], "}"}], ",", 
    "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"For", "[", 
      RowBox[{
       RowBox[{"k", "=", "1"}], ",", 
       RowBox[{"k", "\[LessEqual]", "26"}], ",", 
       RowBox[{"k", "++"}], ",", 
       RowBox[{"N", "=", 
        RowBox[{"SetCodeword", "[", 
         RowBox[{"N", ",", "k", ",", 
          RowBox[{"us", "[", 
           RowBox[{"[", "k", "]"}], "]"}]}], "]"}]}]}], "]"}], ";", " ", 
     "N"}]}], "]"}]}]], "Input",
 CellChangeTimes->{{3.565710824164525*^9, 3.565710924726698*^9}, {
  3.565711141852227*^9, 3.565711152195837*^9}, {3.565897767543725*^9, 
  3.565897773781186*^9}, {3.565897864296966*^9, 3.565897867656537*^9}, {
  3.565898004291135*^9, 3.5658980130972977`*^9}, {3.56589804992706*^9, 
  3.5658980847477627`*^9}, {3.565898262430346*^9, 3.565898262515891*^9}, {
  3.5658983486557827`*^9, 3.5658984018368177`*^9}, {3.56589861641809*^9, 
  3.565898621745322*^9}, {3.565898755714693*^9, 3.565898759738593*^9}}],

Cell[BoxData[
 RowBox[{"usTest", " ", ":=", 
  RowBox[{"Table", "[", 
   RowBox[{
    RowBox[{"Table", "[", 
     RowBox[{
      RowBox[{"i", "+", 
       RowBox[{"j", "/", "10.0"}]}], ",", 
      RowBox[{"{", 
       RowBox[{"j", ",", "1", ",", "8"}], "}"}]}], "]"}], " ", ",", 
    RowBox[{"{", 
     RowBox[{"i", ",", "1", ",", "26"}], "}"}]}], "]"}]}]], "Input",
 CellChangeTimes->{{3.565897798947693*^9, 3.5658978034242983`*^9}, {
  3.565897873838426*^9, 3.565897919276821*^9}, {3.5658980271597652`*^9, 
  3.565898059942028*^9}}],

Cell[BoxData[
 RowBox[{"usZero", " ", ":=", " ", 
  RowBox[{"Table", "[", 
   RowBox[{
    RowBox[{"Table", "[", 
     RowBox[{"0", ",", 
      RowBox[{"{", 
       RowBox[{"j", ",", "1", ",", "8"}], "}"}]}], "]"}], ",", 
    RowBox[{"{", 
     RowBox[{"i", ",", "1", ",", "26"}], "}"}]}], "]"}]}]], "Input",
 CellChangeTimes->{{3.5659028275502768`*^9, 3.565902838951029*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"MatrixForm", "[", 
  RowBox[{"V1", "[", 
   RowBox[{"testFormatString", ",", "usTest"}], "]"}], "]"}]], "Input",
 CellChangeTimes->{{3.565898357471287*^9, 3.565898383268111*^9}, {
  3.565898811872796*^9, 3.5658988144457817`*^9}}],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {"1", "1", "1", "1", "1", "1", "1", "0", "0", "18.2`", "18.1`", "17.8`", 
      "17.7`", "0", "1", "1", "1", "1", "1", "1", "1"},
     {"1", "0", "0", "0", "0", "0", "1", "0", "1", "18.4`", "18.3`", "17.6`", 
      "17.5`", "0", "1", "0", "0", "0", "0", "0", "1"},
     {"1", "0", "1", "1", "1", "0", "1", "0", "2", "18.6`", "18.5`", "17.4`", 
      "17.3`", "0", "1", "0", "1", "1", "1", "0", "1"},
     {"1", "0", "1", "1", "1", "0", "1", "0", "3", "18.8`", "18.7`", "17.2`", 
      "17.1`", "0", "1", "0", "1", "1", "1", "0", "1"},
     {"1", "0", "1", "1", "1", "0", "1", "0", "4", "19.2`", "19.1`", "16.8`", 
      "16.7`", "0", "1", "0", "1", "1", "1", "0", "1"},
     {"1", "0", "0", "0", "0", "0", "1", "0", "5", "19.4`", "19.3`", "16.6`", 
      "16.5`", "0", "1", "0", "0", "0", "0", "0", "1"},
     {"1", "1", "1", "1", "1", "1", "1", "0", "1", "0", "1", "0", "1", "0", 
      "1", "1", "1", "1", "1", "1", "1"},
     {"0", "0", "0", "0", "0", "0", "0", "0", "6", "19.6`", "19.5`", "16.4`", 
      "16.3`", "0", "0", "0", "0", "0", "0", "0", "0"},
     {"14", "13", "12", "11", "10", "9", "1", "8", "7", "19.8`", "19.7`", 
      "16.2`", "16.1`", "7", "6", "5", "4", "3", "2", "1", "0"},
     {"26.2`", "26.1`", "25.8`", "25.7`", "24.2`", "24.1`", "0", "23.8`", 
      "23.7`", "20.2`", "20.1`", "15.8`", "15.7`", "10.2`", "10.1`", "9.8`", 
      "9.7`", "4.2`", "4.1`", "3.8`", "3.7`"},
     {"26.4`", "26.3`", "25.6`", "25.5`", "24.4`", "24.3`", "1", "23.6`", 
      "23.5`", "20.4`", "20.3`", "15.6`", "15.5`", "10.4`", "10.3`", "9.6`", 
      "9.5`", "4.4`", "4.3`", "3.6`", "3.5`"},
     {"26.6`", "26.5`", "25.4`", "25.3`", "24.6`", "24.5`", "0", "23.4`", 
      "23.3`", "20.6`", "20.5`", "15.4`", "15.3`", "10.6`", "10.5`", "9.4`", 
      "9.3`", "4.6`", "4.5`", "3.4`", "3.3`"},
     {"26.8`", "26.7`", "25.2`", "25.1`", "24.8`", "24.7`", "1", "23.2`", 
      "23.1`", "20.8`", "20.7`", "15.2`", "15.1`", "10.8`", "10.7`", "9.2`", 
      "9.1`", "4.8`", "4.7`", "3.2`", "3.1`"},
     {"0", "0", "0", "0", "0", "0", "0", "0", "1", "21.2`", "21.1`", "14.8`", 
      "14.7`", "11.2`", "11.1`", "8.8`", "8.7`", "5.2`", "5.1`", "2.8`", 
      "2.7`"},
     {"1", "1", "1", "1", "1", "1", "1", "0", "8", "21.4`", "21.3`", "14.6`", 
      "14.5`", "11.4`", "11.3`", "8.6`", "8.5`", "5.4`", "5.3`", "2.6`", 
      "2.5`"},
     {"1", "0", "0", "0", "0", "0", "1", "0", "9", "21.6`", "21.5`", "14.4`", 
      "14.3`", "11.6`", "11.5`", "8.4`", "8.3`", "5.6`", "5.5`", "2.4`", 
      "2.3`"},
     {"1", "0", "1", "1", "1", "0", "1", "0", "10", "21.8`", "21.7`", "14.2`",
       "14.1`", "11.8`", "11.7`", "8.2`", "8.1`", "5.8`", "5.7`", "2.2`", 
      "2.1`"},
     {"1", "0", "1", "1", "1", "0", "1", "0", "11", "22.2`", "22.1`", "13.8`",
       "13.7`", "12.2`", "12.1`", "7.8`", "7.7`", "6.2`", "6.1`", "1.8`", 
      "1.7000000000000002`"},
     {"1", "0", "1", "1", "1", "0", "1", "0", "12", "22.4`", "22.3`", "13.6`",
       "13.5`", "12.4`", "12.3`", "7.6`", "7.5`", "6.4`", "6.3`", "1.6`", 
      "1.5`"},
     {"1", "0", "0", "0", "0", "0", "1", "0", "13", "22.6`", "22.5`", "13.4`",
       "13.3`", "12.6`", "12.5`", "7.4`", "7.3`", "6.6`", "6.5`", "1.4`", 
      "1.3`"},
     {"1", "1", "1", "1", "1", "1", "1", "0", "14", "22.8`", "22.7`", "13.2`",
       "13.1`", "12.8`", "12.7`", "7.2`", "7.1`", "6.8`", "6.7`", "1.2`", 
      "1.1`"}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{{3.565898372012863*^9, 3.5658984033957987`*^9}, {
   3.565898611680655*^9, 3.565898624095529*^9}, {3.565898723969329*^9, 
   3.565898761202732*^9}, 3.5658988149844017`*^9, 3.5659045759040318`*^9}]
}, Open  ]]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["\<\
Mask 000 (checkerboard, missing out finder symbols and other bis and pieces)\
\>", "Section",
 CellChangeTimes->{{3.565719188333572*^9, 3.565719203635785*^9}, {
  3.5658990841789618`*^9, 3.5658991206766357`*^9}, {3.566317779398542*^9, 
  3.566317786917797*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"zeroRow", " ", "=", " ", 
  RowBox[{"Table", "[", 
   RowBox[{"0", ",", 
    RowBox[{"{", 
     RowBox[{"i", ",", "1", ",", "21"}], "}"}]}], "]"}]}]], "Input",
 CellChangeTimes->{{3.5657127754918823`*^9, 3.565712783355557*^9}, {
   3.565822561932741*^9, 3.565822581939322*^9}, {3.565899231954337*^9, 
   3.565899239110653*^9}, 3.56589933742072*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", 
   ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
   "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0"}], "}"}]], "Output",
 CellChangeTimes->{3.565899337741534*^9, 3.565904577829303*^9, 
  3.566318215358651*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"oddMiddleRow", " ", "=", " ", 
  RowBox[{"Join", "[", 
   RowBox[{
    RowBox[{"Table", "[", 
     RowBox[{"0", ",", 
      RowBox[{"{", 
       RowBox[{"i", ",", "1", ",", "9"}], "}"}]}], "]"}], ",", 
    RowBox[{"{", 
     RowBox[{"0", ",", "1", ",", "0", ",", "1"}], "}"}], ",", 
    RowBox[{"Table", "[", 
     RowBox[{"0", ",", 
      RowBox[{"{", 
       RowBox[{"i", ",", "14", ",", "21"}], "}"}]}], "]"}]}], 
   "]"}]}]], "Input",
 CellChangeTimes->{
  3.566317789271611*^9, {3.566317819909247*^9, 3.5663178842272*^9}, {
   3.566317932591061*^9, 3.5663179331526213`*^9}, {3.566318156979478*^9, 
   3.566318158555244*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", 
   ",", "0", ",", "0", ",", "1", ",", "0", ",", "1", ",", "0", ",", "0", ",", 
   "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0"}], "}"}]], "Output",
 CellChangeTimes->{3.5663178810449*^9, 3.566318165548867*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"evenMiddleRow", " ", "=", " ", 
  RowBox[{"Join", "[", 
   RowBox[{
    RowBox[{"Table", "[", 
     RowBox[{"0", ",", 
      RowBox[{"{", 
       RowBox[{"i", ",", "1", ",", "9"}], "}"}]}], "]"}], ",", 
    RowBox[{"{", 
     RowBox[{"1", ",", "0", ",", "1", ",", "0"}], "}"}], ",", 
    RowBox[{"Table", "[", 
     RowBox[{"0", ",", 
      RowBox[{"{", 
       RowBox[{"i", ",", "14", ",", "21"}], "}"}]}], "]"}]}], 
   "]"}]}]], "Input",
 CellChangeTimes->{{3.566317887686308*^9, 3.5663178976965322`*^9}, {
  3.5663179344950733`*^9, 3.566317935208705*^9}, {3.5663181608667803`*^9, 
  3.566318162210589*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", 
   ",", "0", ",", "1", ",", "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", 
   "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0"}], "}"}]], "Output",
 CellChangeTimes->{3.566317898085236*^9, 3.566318162455014*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"evenLongRow", " ", "=", 
  RowBox[{"Join", "[", " ", 
   RowBox[{
    RowBox[{"Apply", "[", 
     RowBox[{"Join", ",", 
      RowBox[{"Table", "[", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"0", ",", "1"}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"i", ",", "1", ",", "10"}], "}"}]}], "]"}]}], "]"}], ",", 
    RowBox[{"{", "0", "}"}]}], "]"}]}]], "Input",
 CellChangeTimes->{{3.566317936318387*^9, 3.566318026523148*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
  "0", ",", "1", ",", "0", ",", "1", ",", "0", ",", "1", ",", "0", ",", "1", 
   ",", "0", ",", "1", ",", "0", ",", "1", ",", "0", ",", "1", ",", "0", ",", 
   "1", ",", "0", ",", "1", ",", "0", ",", "1", ",", "0"}], "}"}]], "Output",
 CellChangeTimes->{{3.566318020652265*^9, 3.566318026948608*^9}}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"oddLongRow", " ", "=", " ", 
  RowBox[{"{", 
   RowBox[{
   "1", ",", "0", ",", "1", ",", "0", ",", "1", ",", "0", ",", "0", ",", "0", 
    ",", "1", ",", "0", ",", "1", ",", "0", ",", "1", ",", "0", ",", "1", ",",
     "0", ",", "1", ",", "0", ",", "1", ",", "0", ",", "1"}], 
   "}"}]}]], "Input",
 CellChangeTimes->{{3.56631802842625*^9, 3.566318047712841*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
  "1", ",", "0", ",", "1", ",", "0", ",", "1", ",", "0", ",", "0", ",", "0", 
   ",", "1", ",", "0", ",", "1", ",", "0", ",", "1", ",", "0", ",", "1", ",", 
   "0", ",", "1", ",", "0", ",", "1", ",", "0", ",", "1"}], "}"}]], "Output",
 CellChangeTimes->{{3.56631804463943*^9, 3.566318048013081*^9}}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"evenRightRow", " ", "=", " ", 
  RowBox[{"{", 
   RowBox[{
   "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", 
    ",", "0", ",", "1", ",", "0", ",", "1", ",", "0", ",", "1", ",", "0", ",",
     "1", ",", "0", ",", "1", ",", "0", ",", "1", ",", "0"}], 
   "}"}]}]], "Input",
 CellChangeTimes->{{3.566318052635243*^9, 3.566318089398583*^9}, {
  3.5663181293645887`*^9, 3.566318130796423*^9}, {3.566318171763218*^9, 
  3.566318172538306*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", 
   ",", "0", ",", "1", ",", "0", ",", "1", ",", "0", ",", "1", ",", "0", ",", 
   "1", ",", "0", ",", "1", ",", "0", ",", "1", ",", "0"}], "}"}]], "Output",
 CellChangeTimes->{3.5663181310815763`*^9, 3.566318178796254*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"oddRightRow", " ", "=", " ", 
  RowBox[{"{", 
   RowBox[{
   "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", 
    ",", "0", ",", "0", ",", "1", ",", "0", ",", "1", ",", "0", ",", "1", ",",
     "0", ",", "1", ",", "0", ",", "1", ",", "0", ",", "1"}], 
   "}"}]}]], "Input",
 CellChangeTimes->{{3.566318132058107*^9, 3.5663181414678707`*^9}, {
  3.566318175258562*^9, 3.566318176036414*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", 
   ",", "0", ",", "0", ",", "1", ",", "0", ",", "1", ",", "0", ",", "1", ",", 
   "0", ",", "1", ",", "0", ",", "1", ",", "0", ",", "1"}], "}"}]], "Output",
 CellChangeTimes->{3.566318141980194*^9, 3.5663181764585543`*^9}]
}, Open  ]],

Cell[BoxData[
 RowBox[{"mask000", " ", ":=", " ", 
  RowBox[{"{", 
   RowBox[{
   "oddMiddleRow", ",", " ", "evenMiddleRow", ",", " ", "oddMiddleRow", ",", 
    " ", "evenMiddleRow", ",", " ", "oddMiddleRow", ",", " ", "evenMiddleRow",
     ",", " ", "zeroRow", ",", " ", "evenMiddleRow", ",", " ", "oddMiddleRow",
     ",", " ", "evenLongRow", ",", " ", "oddLongRow", ",", " ", "evenLongRow",
     ",", " ", "oddLongRow", ",", " ", "evenRightRow", ",", " ", 
    "oddRightRow", ",", " ", "evenRightRow", ",", " ", "oddRightRow", ",", 
    " ", "evenRightRow", ",", " ", "oddRightRow", ",", " ", "evenRightRow", 
    ",", " ", "oddRightRow"}], "}"}]}]], "Input",
 CellChangeTimes->{{3.566318148125182*^9, 3.566318151762484*^9}, {
  3.566318193897999*^9, 3.566318257517343*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"drawMatrix", "[", "mask000", "]"}]], "Input",
 CellChangeTimes->{{3.566318259323306*^9, 3.5663182635884457`*^9}}],

Cell[BoxData[
 GraphicsBox[{
   RasterBox[SparseArray[
    Automatic, {21, 21}, 1., {
     1, {{0, 6, 12, 18, 24, 30, 36, 42, 48, 58, 68, 78, 88, 90, 92, 92, 94, 
       96, 98, 100, 102, 104}, {{11}, {13}, {15}, {17}, {19}, {21}, {10}, {
       12}, {14}, {16}, {18}, {20}, {11}, {13}, {15}, {17}, {19}, {21}, {
       10}, {12}, {14}, {16}, {18}, {20}, {11}, {13}, {15}, {17}, {19}, {
       21}, {10}, {12}, {14}, {16}, {18}, {20}, {11}, {13}, {15}, {17}, {
       19}, {21}, {10}, {12}, {14}, {16}, {18}, {20}, {1}, {3}, {5}, {9}, {
       11}, {13}, {15}, {17}, {19}, {21}, {2}, {4}, {6}, {8}, {10}, {12}, {
       14}, {16}, {18}, {20}, {1}, {3}, {5}, {9}, {11}, {13}, {15}, {17}, {
       19}, {21}, {2}, {4}, {6}, {8}, {10}, {12}, {14}, {16}, {18}, {20}, {
       11}, {13}, {10}, {12}, {10}, {12}, {11}, {13}, {10}, {12}, {11}, {
       13}, {10}, {12}, {11}, {13}}}, CompressedData["
1:eJxTTMoPSmVkYGDIYBgFo2AUUAIA0ZoCEw==
      "]}], {{0, 0}, {21, 21}}, {0, 
    1}], {
    {GrayLevel[
      NCache[-1 + GoldenRatio, 0.6180339887498949]], 
     StyleBox[
      LineBox[{{{0, 21}, {21, 21}}, {{0, 20}, {21, 20}}, {{0, 19}, {21, 
       19}}, {{0, 18}, {21, 18}}, {{0, 17}, {21, 17}}, {{0, 16}, {21, 16}}, {{
       0, 15}, {21, 15}}, {{0, 14}, {21, 14}}, {{0, 13}, {21, 13}}, {{0, 
       12}, {21, 12}}, {{0, 11}, {21, 11}}, {{0, 10}, {21, 10}}, {{0, 9}, {21,
        9}}, {{0, 8}, {21, 8}}, {{0, 7}, {21, 7}}, {{0, 6}, {21, 6}}, {{0, 
       5}, {21, 5}}, {{0, 4}, {21, 4}}, {{0, 3}, {21, 3}}, {{0, 2}, {21, 
       2}}, {{0, 1}, {21, 1}}, {{0, 0}, {21, 0}}}],
      Antialiasing->False]}, 
    {GrayLevel[
      NCache[-1 + GoldenRatio, 0.6180339887498949]], 
     StyleBox[
      LineBox[{{{0, 0}, {0, 21}}, {{1, 0}, {1, 21}}, {{2, 0}, {2, 21}}, {{3, 
       0}, {3, 21}}, {{4, 0}, {4, 21}}, {{5, 0}, {5, 21}}, {{6, 0}, {6, 
       21}}, {{7, 0}, {7, 21}}, {{8, 0}, {8, 21}}, {{9, 0}, {9, 21}}, {{10, 
       0}, {10, 21}}, {{11, 0}, {11, 21}}, {{12, 0}, {12, 21}}, {{13, 0}, {13,
        21}}, {{14, 0}, {14, 21}}, {{15, 0}, {15, 21}}, {{16, 0}, {16, 
       21}}, {{17, 0}, {17, 21}}, {{18, 0}, {18, 21}}, {{19, 0}, {19, 21}}, {{
       20, 0}, {20, 21}}, {{21, 0}, {21, 21}}}],
      Antialiasing->False]}}},
  Frame->False,
  FrameLabel->{None, None},
  FrameTicks->{{None, None}, {None, None}}]], "Output",
 CellChangeTimes->{{3.566318260168478*^9, 3.566318264036194*^9}}]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{"ReduceMod2", "[", "x_", "]"}], " ", ":=", " ", 
  RowBox[{"Mod", "[", 
   RowBox[{"x", ",", "2"}], "]"}]}]], "Input",
 CellChangeTimes->{{3.565902570674553*^9, 3.5659025767882566`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"ApplyMask000", "[", "M_", "]"}], " ", ":=", " ", 
  RowBox[{"Map", "[", 
   RowBox[{"ReduceMod2", ",", " ", 
    RowBox[{"M", " ", "+", " ", "mask000"}], ",", "2"}], "]"}]}]], "Input",
 CellChangeTimes->{{3.565712822433066*^9, 3.565712854079742*^9}, {
  3.565712980177978*^9, 3.56571299345187*^9}, {3.5658227602886267`*^9, 
  3.56582276052829*^9}, {3.5658995261473293`*^9, 3.565899527569886*^9}, {
  3.565902580462449*^9, 3.5659025904916143`*^9}, {3.5663182903177137`*^9, 
  3.566318293147546*^9}}]
}, Open  ]],

Cell[CellGroupData[{

Cell["\<\
Mask 001 (alternate rows black, missing out finder symbols and other bis and \
pieces)\
\>", "Section",
 CellChangeTimes->{{3.565719188333572*^9, 3.565719203635785*^9}, {
  3.5658990841789618`*^9, 3.5658991206766357`*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"middleRow", " ", "=", " ", 
  RowBox[{"Join", "[", 
   RowBox[{
    RowBox[{"Table", "[", 
     RowBox[{"0", ",", 
      RowBox[{"{", 
       RowBox[{"i", ",", "1", ",", "9"}], "}"}]}], "]"}], ",", 
    RowBox[{"Table", "[", 
     RowBox[{"1", ",", 
      RowBox[{"{", 
       RowBox[{"i", ",", "10", ",", "13"}], "}"}]}], "]"}], ",", 
    RowBox[{"Table", "[", 
     RowBox[{"0", ",", 
      RowBox[{"{", 
       RowBox[{"i", ",", "14", ",", "21"}], "}"}]}], "]"}]}], 
   "]"}]}]], "Input",
 CellChangeTimes->{{3.565712784847183*^9, 3.5657127904534407`*^9}, 
   3.565822588225133*^9, 3.565825634606596*^9, {3.565899304143375*^9, 
   3.56589934157959*^9}, {3.565899427191456*^9, 3.5658994305847797`*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", 
   ",", "0", ",", "1", ",", "1", ",", "1", ",", "1", ",", "0", ",", "0", ",", 
   "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0"}], "}"}]], "Output",
 CellChangeTimes->{3.565899342013088*^9, 3.565904578364011*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"fullRow", " ", "=", " ", 
  RowBox[{"Join", "[", 
   RowBox[{
    RowBox[{"Table", "[", 
     RowBox[{"1", ",", 
      RowBox[{"{", 
       RowBox[{"i", ",", "1", ",", "6"}], "}"}]}], "]"}], ",", 
    RowBox[{"{", "0", "}"}], ",", 
    RowBox[{"Table", "[", 
     RowBox[{"1", ",", 
      RowBox[{"{", 
       RowBox[{"i", ",", "8", ",", "21"}], "}"}]}], "]"}]}], "]"}]}]], "Input",\

 CellChangeTimes->{{3.565899358808556*^9, 3.565899359721258*^9}, {
  3.565899412240305*^9, 3.565899437142436*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
  "1", ",", "1", ",", "1", ",", "1", ",", "1", ",", "1", ",", "0", ",", "1", 
   ",", "1", ",", "1", ",", "1", ",", "1", ",", "1", ",", "1", ",", "1", ",", 
   "1", ",", "1", ",", "1", ",", "1", ",", "1", ",", "1"}], "}"}]], "Output",
 CellChangeTimes->{3.5658994375935*^9, 3.565904578879696*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"rightRow", " ", "=", " ", 
  RowBox[{"Join", "[", 
   RowBox[{
    RowBox[{"Table", "[", 
     RowBox[{"0", ",", 
      RowBox[{"{", 
       RowBox[{"i", ",", "1", ",", "9"}], "}"}]}], "]"}], ",", 
    RowBox[{"Table", "[", 
     RowBox[{"1", ",", 
      RowBox[{"{", 
       RowBox[{"i", ",", "10", ",", "21"}], "}"}]}], "]"}]}], 
   "]"}]}]], "Input",
 CellChangeTimes->{{3.5658994478867598`*^9, 3.565899467244849*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", 
   ",", "0", ",", "1", ",", "1", ",", "1", ",", "1", ",", "1", ",", "1", ",", 
   "1", ",", "1", ",", "1", ",", "1", ",", "1", ",", "1"}], "}"}]], "Output",
 CellChangeTimes->{{3.565899462799788*^9, 3.5658994675247507`*^9}, 
   3.5659045793757267`*^9}]
}, Open  ]],

Cell[BoxData[
 RowBox[{"mask001", " ", ":=", 
  RowBox[{"{", 
   RowBox[{
   "middleRow", ",", "zeroRow", ",", "middleRow", ",", "zeroRow", ",", 
    "middleRow", ",", "zeroRow", ",", "zeroRow", ",", "zeroRow", ",", 
    "middleRow", ",", "zeroRow", ",", "fullRow", ",", "zeroRow", ",", 
    "fullRow", ",", "zeroRow", ",", "rightRow", ",", "zeroRow", ",", 
    "rightRow", ",", "zeroRow", ",", "rightRow", ",", "zeroRow", ",", 
    "rightRow"}], "}"}]}]], "Input",
 CellChangeTimes->{{3.565711450165338*^9, 3.565711451672271*^9}, {
  3.565712630316854*^9, 3.565712773774963*^9}, {3.5657129585826263`*^9, 
  3.565712959078815*^9}, {3.565713978614546*^9, 3.565713979608005*^9}, {
  3.565822756505929*^9, 3.5658227570646772`*^9}, {3.565899473502527*^9, 
  3.5658995221385727`*^9}, {3.5659026298452063`*^9, 3.565902630195981*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"drawMatrix", "[", "mask001", "]"}]], "Input",
 CellChangeTimes->{{3.565899529757958*^9, 3.5658995321162577`*^9}}],

Cell[BoxData[
 GraphicsBox[
  RasterBox[SparseArray[
   Automatic, {21, 21}, 1., {
    1, {{0, 12, 12, 24, 24, 36, 36, 48, 48, 68, 68, 88, 88, 92, 92, 92, 92, 
      96, 96, 100, 100, 104}, {{10}, {11}, {12}, {13}, {14}, {15}, {16}, {
      17}, {18}, {19}, {20}, {21}, {10}, {11}, {12}, {13}, {14}, {15}, {16}, {
      17}, {18}, {19}, {20}, {21}, {10}, {11}, {12}, {13}, {14}, {15}, {16}, {
      17}, {18}, {19}, {20}, {21}, {10}, {11}, {12}, {13}, {14}, {15}, {16}, {
      17}, {18}, {19}, {20}, {21}, {1}, {2}, {3}, {4}, {5}, {6}, {8}, {9}, {
      10}, {11}, {12}, {13}, {14}, {15}, {16}, {17}, {18}, {19}, {20}, {21}, {
      1}, {2}, {3}, {4}, {5}, {6}, {8}, {9}, {10}, {11}, {12}, {13}, {14}, {
      15}, {16}, {17}, {18}, {19}, {20}, {21}, {10}, {11}, {12}, {13}, {10}, {
      11}, {12}, {13}, {10}, {11}, {12}, {13}, {10}, {11}, {12}, {
      13}}}, CompressedData["
1:eJxTTMoPSmVkYGDIYBgFo2AUUAIA0ZoCEw==
     "]}], {{0, 0}, {21, 21}}, {0, 1}],
  
  Frame->Automatic,
  FrameLabel->{None, None},
  FrameTicks->{{None, None}, {None, None}}]], "Output",
 CellChangeTimes->{3.5658995325743237`*^9, 3.565902632245728*^9, 
  3.5659045809523478`*^9}]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{"ApplyMask001", "[", "M_", "]"}], " ", ":=", " ", 
  RowBox[{"Map", "[", 
   RowBox[{"ReduceMod2", ",", " ", 
    RowBox[{"M", " ", "+", " ", "mask001"}], ",", "2"}], "]"}]}]], "Input",
 CellChangeTimes->{{3.565712822433066*^9, 3.565712854079742*^9}, {
  3.565712980177978*^9, 3.56571299345187*^9}, {3.5658227602886267`*^9, 
  3.56582276052829*^9}, {3.5658995261473293`*^9, 3.565899527569886*^9}, {
  3.565902580462449*^9, 3.5659025904916143`*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"drawMatrix", "[", 
  RowBox[{"ApplyMask001", "[", "emptyV1", "]"}], "]"}]], "Input",
 CellChangeTimes->{{3.5663214251389008`*^9, 3.5663214527696238`*^9}}],

Cell[BoxData[
 GraphicsBox[
  RasterBox[SparseArray[
   Automatic, {21, 21}, 1., {
    1, {{0, 19, 21, 38, 43, 60, 62, 81, 82, 103, 103, 124, 124, 129, 129, 146,
       150, 164, 174, 188, 192, 210}, {{1}, {2}, {3}, {4}, {5}, {6}, {7}, {
      10}, {11}, {12}, {13}, {14}, {15}, {16}, {17}, {18}, {19}, {20}, {21}, {
      1}, {7}, {1}, {3}, {4}, {5}, {7}, {10}, {11}, {12}, {13}, {14}, {15}, {
      16}, {17}, {18}, {19}, {20}, {21}, {1}, {3}, {4}, {5}, {7}, {1}, {3}, {
      4}, {5}, {7}, {10}, {11}, {12}, {13}, {14}, {15}, {16}, {17}, {18}, {
      19}, {20}, {21}, {1}, {7}, {1}, {2}, {3}, {4}, {5}, {6}, {7}, {10}, {
      11}, {12}, {13}, {14}, {15}, {16}, {17}, {18}, {19}, {20}, {21}, {9}, {
      1}, {2}, {3}, {4}, {5}, {6}, {7}, {8}, {9}, {10}, {11}, {12}, {13}, {
      14}, {15}, {16}, {17}, {18}, {19}, {20}, {21}, {1}, {2}, {3}, {4}, {
      5}, {6}, {7}, {8}, {9}, {10}, {11}, {12}, {13}, {14}, {15}, {16}, {
      17}, {18}, {19}, {20}, {21}, {7}, {10}, {11}, {12}, {13}, {1}, {2}, {
      3}, {4}, {5}, {6}, {7}, {9}, {11}, {13}, {15}, {16}, {17}, {18}, {19}, {
      20}, {21}, {1}, {7}, {15}, {21}, {1}, {3}, {4}, {5}, {7}, {10}, {11}, {
      12}, {13}, {15}, {17}, {18}, {19}, {21}, {1}, {3}, {4}, {5}, {7}, {
      15}, {17}, {18}, {19}, {21}, {1}, {3}, {4}, {5}, {7}, {10}, {11}, {
      12}, {13}, {15}, {17}, {18}, {19}, {21}, {1}, {7}, {15}, {21}, {1}, {
      2}, {3}, {4}, {5}, {6}, {7}, {10}, {11}, {12}, {13}, {15}, {16}, {17}, {
      18}, {19}, {20}, {21}}}, CompressedData["
1:eJxTTMoPSmVkYGC4xDAKRsEoGAWjYBQMDgAAamgCfQ==
     "]}], {{0, 0}, {21, 
   21}}, {0, 1}],
  Frame->Automatic,
  FrameLabel->{None, None},
  FrameTicks->{{None, None}, {None, None}}]], "Output",
 CellChangeTimes->{{3.566321446669626*^9, 3.566321453203518*^9}}]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Format strings", "Section",
 CellChangeTimes->{{3.565719124042529*^9, 3.56571914395052*^9}, {
  3.565817917778201*^9, 3.56581793279907*^9}, {3.565817981558161*^9, 
  3.5658179870362587`*^9}, {3.565899750982573*^9, 3.5658997514522133`*^9}}],

Cell["testFormatString already defined", "Subsection",
 CellChangeTimes->{{3.565904552671549*^9, 3.56590455812481*^9}}],

Cell[CellGroupData[{

Cell["\<\
least significant bit first since first element of list is loaded into format \
position 0. First two data bits are: 01 for L, 00 for M, 11 for Q and 10 for \
H, then 000 or 001 encoding the masking pattern. Then encoded with BCH code \
and masked with the 15 bit mask below.\
\>", "Subsection",
 CellChangeTimes->{{3.5658997533699293`*^9, 3.56589979340193*^9}, {
  3.565902383356881*^9, 3.565902383908894*^9}, {3.565902780674062*^9, 
  3.565902788056087*^9}, {3.566318359617113*^9, 3.566318396373996*^9}}],

Cell[BoxData[
 RowBox[{"mask", " ", ":=", " ", 
  RowBox[{"{", 
   RowBox[{
   "1", ",", "0", ",", "1", ",", "0", ",", "1", ",", "0", ",", "0", ",", "0", 
    ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", "0"}], 
   "}"}]}]], "Input",
 CellChangeTimes->{{3.5659024860112257`*^9, 3.565902494937009*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"fsL000", " ", ":=", " ", 
   RowBox[{"{", 
    RowBox[{
    "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", "1",
      ",", "1", ",", "0", ",", "1", ",", "0", ",", "1", ",", "1", ",", "0"}], 
    "}"}]}], ";", " ", 
  RowBox[{"fsL000M", " ", "=", " ", 
   RowBox[{"Map", "[", 
    RowBox[{"ReduceMod2", ",", " ", 
     RowBox[{"fsL000", " ", "+", " ", "mask"}]}], "]"}]}]}]], "Input",
 CellChangeTimes->{{3.5663183013897133`*^9, 3.5663183189705544`*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
  "1", ",", "1", ",", "1", ",", "0", ",", "1", ",", "1", ",", "1", ",", "1", 
   ",", "1", ",", "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0"}], 
  "}"}]], "Output",
 CellChangeTimes->{3.5663183195389433`*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"fsL001", " ", ":=", " ", 
   RowBox[{"{", 
    RowBox[{
    "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", "1",
      ",", "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1"}], 
    "}"}]}], ";", " ", 
  RowBox[{"fsL001M", " ", "=", " ", 
   RowBox[{"Map", "[", 
    RowBox[{"ReduceMod2", ",", 
     RowBox[{"fsL001", " ", "+", " ", "mask"}]}], "]"}]}]}]], "Input",
 CellChangeTimes->{{3.565719109201641*^9, 3.565719117137961*^9}, {
   3.565902337409226*^9, 3.565902354082152*^9}, {3.565902428556416*^9, 
   3.565902432699651*^9}, {3.565902553861918*^9, 3.565902555949707*^9}, {
   3.5659026758811827`*^9, 3.565902702830451*^9}, {3.565902737789139*^9, 
   3.565902740412375*^9}, 3.5659028910612583`*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
  "1", ",", "1", ",", "1", ",", "0", ",", "0", ",", "1", ",", "0", ",", "1", 
   ",", "1", ",", "1", ",", "1", ",", "0", ",", "0", ",", "1", ",", "1"}], 
  "}"}]], "Output",
 CellChangeTimes->{3.565902891399453*^9, 3.5659045893683434`*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"drawMatrix", "[", 
  RowBox[{"ApplyMask001", "[", 
   RowBox[{"V1", "[", 
    RowBox[{"fsL001M", ",", "usZero"}], "]"}], "]"}], "]"}]], "Input",
 CellChangeTimes->{{3.5659025925998096`*^9, 3.565902601738888*^9}, {
  3.565902638225073*^9, 3.565902639970593*^9}, {3.5659028619978848`*^9, 
  3.565902872189164*^9}, {3.565902915718103*^9, 3.56590291668274*^9}, {
  3.5659029632167253`*^9, 3.565902966104299*^9}}],

Cell[BoxData[
 GraphicsBox[
  RasterBox[SparseArray[
   Automatic, {21, 21}, 1., {
    1, {{0, 20, 23, 41, 46, 63, 66, 85, 86, 107, 107, 128, 128, 144, 145, 162,
       167, 182, 192, 206, 211, 230}, {{1}, {2}, {3}, {4}, {5}, {6}, {7}, {
      9}, {10}, {11}, {12}, {13}, {14}, {15}, {16}, {17}, {18}, {19}, {20}, {
      21}, {1}, {7}, {9}, {1}, {3}, {4}, {5}, {7}, {9}, {10}, {11}, {12}, {
      13}, {14}, {15}, {16}, {17}, {18}, {19}, {20}, {21}, {1}, {3}, {4}, {
      5}, {7}, {1}, {3}, {4}, {5}, {7}, {10}, {11}, {12}, {13}, {14}, {15}, {
      16}, {17}, {18}, {19}, {20}, {21}, {1}, {7}, {9}, {1}, {2}, {3}, {4}, {
      5}, {6}, {7}, {10}, {11}, {12}, {13}, {14}, {15}, {16}, {17}, {18}, {
      19}, {20}, {21}, {9}, {1}, {2}, {3}, {4}, {5}, {6}, {7}, {8}, {9}, {
      10}, {11}, {12}, {13}, {14}, {15}, {16}, {17}, {18}, {19}, {20}, {21}, {
      1}, {2}, {3}, {4}, {5}, {6}, {7}, {8}, {9}, {10}, {11}, {12}, {13}, {
      14}, {15}, {16}, {17}, {18}, {19}, {20}, {21}, {1}, {2}, {3}, {6}, {
      7}, {9}, {10}, {11}, {12}, {13}, {14}, {15}, {16}, {17}, {20}, {21}, {
      9}, {1}, {2}, {3}, {4}, {5}, {6}, {7}, {9}, {11}, {13}, {15}, {16}, {
      17}, {18}, {19}, {20}, {21}, {1}, {7}, {9}, {15}, {21}, {1}, {3}, {4}, {
      5}, {7}, {9}, {10}, {11}, {12}, {13}, {15}, {17}, {18}, {19}, {21}, {
      1}, {3}, {4}, {5}, {7}, {15}, {17}, {18}, {19}, {21}, {1}, {3}, {4}, {
      5}, {7}, {10}, {11}, {12}, {13}, {15}, {17}, {18}, {19}, {21}, {1}, {
      7}, {9}, {15}, {21}, {1}, {2}, {3}, {4}, {5}, {6}, {7}, {9}, {10}, {
      11}, {12}, {13}, {15}, {16}, {17}, {18}, {19}, {20}, {
      21}}}, CompressedData["
1:eJxTTMoPSmVkYGB4xjAKRsEoGAWjYBSMAmIAAIi2ApE=
     "]}], {{0, 0}, {21, 
   21}}, {0, 1}],
  Frame->Automatic,
  FrameLabel->{None, None},
  FrameTicks->{{None, None}, {None, None}}]], "Output",
 CellChangeTimes->{{3.5659028530713367`*^9, 3.5659028726964207`*^9}, 
   3.56590291705413*^9, 3.565902966545642*^9, 3.565904592723866*^9}]
}, Open  ]]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["General functions for converting to binary", "Section",
 CellChangeTimes->{{3.5657198179025393`*^9, 3.5657198324749928`*^9}}],

Cell[CellGroupData[{

Cell["\<\
Converting from integers to binary\
\>", "Subsection",
 CellChangeTimes->{{3.5657214756717167`*^9, 3.565721480245364*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"toWord", "[", 
   RowBox[{"_", ",", "0"}], "]"}], " ", ":=", " ", 
  RowBox[{"{", "}"}]}]], "Input",
 CellChangeTimes->{{3.565711511963409*^9, 3.5657115163796597`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"toWord", "[", 
   RowBox[{"x_", ",", "n_"}], "]"}], " ", ":=", " ", 
  RowBox[{"Join", "[", 
   RowBox[{
    RowBox[{"toWord", "[", 
     RowBox[{
      RowBox[{"Quotient", "[", 
       RowBox[{"x", ",", "2"}], "]"}], ",", 
      RowBox[{"n", "-", "1"}]}], "]"}], ",", 
    RowBox[{"{", 
     RowBox[{"Mod", "[", 
      RowBox[{"x", ",", "2"}], "]"}], "}"}]}], "]"}]}]], "Input",
 CellChangeTimes->{{3.56571147281474*^9, 3.56571150892835*^9}, {
  3.5657199159287043`*^9, 3.565719918506288*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"byteToWord", "[", "x_", "]"}], " ", ":=", " ", 
  RowBox[{"toWord", "[", 
   RowBox[{"x", ",", "8"}], "]"}]}]], "Input",
 CellChangeTimes->{{3.565711453219784*^9, 3.565711471833535*^9}}]
}, Open  ]],

Cell[CellGroupData[{

Cell["\<\
From bitstream into bytes represented as binary words of length 8\
\>", "Subsection",
 CellChangeTimes->{{3.565721482294857*^9, 3.5657214991345863`*^9}, {
  3.565904597652871*^9, 3.5659045981948643`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"splitIntoBytes", "[", "bs_", "]"}], " ", ":=", " ", 
  RowBox[{"If", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"Length", "[", "bs", "]"}], "\[LessEqual]", "8"}], ",", 
    RowBox[{"{", "bs", "}"}], ",", 
    RowBox[{"Join", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"Take", "[", 
        RowBox[{"bs", ",", "8"}], "]"}], "}"}], ",", 
      RowBox[{"splitIntoBytes", "[", 
       RowBox[{"Drop", "[", 
        RowBox[{"bs", ",", "8"}], "]"}], "]"}]}], "]"}]}], "]"}]}]], "Input",
 CellChangeTimes->{{3.565721467648951*^9, 3.565721469487185*^9}, {
  3.56572162251476*^9, 3.565721639982986*^9}, {3.565721677964972*^9, 
  3.5657217941755037`*^9}}]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["\<\
Alphanumeric coding: 11 bits per pair of alphanumeric characters\
\>", "Section",
 CellChangeTimes->{{3.565719248329417*^9, 3.565719270512047*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"an", "[", "\"\<0\>\"", "]"}], ":=", "0"}], ";", " ", 
  RowBox[{
   RowBox[{"an", "[", "\"\<1\>\"", "]"}], " ", ":=", "1"}], ";", " ", 
  RowBox[{
   RowBox[{"an", "[", "\"\<2\>\"", "]"}], " ", ":=", " ", "2"}], ";", " ", 
  RowBox[{
   RowBox[{"an", "[", "\"\<3\>\"", "]"}], ":=", "3"}], ";", " ", 
  RowBox[{
   RowBox[{"an", "[", "\"\<4\>\"", "]"}], ":=", "4"}], ";", " ", 
  RowBox[{
   RowBox[{"an", "[", "\"\<5\>\"", "]"}], " ", ":=", " ", "5"}], 
  ";"}]], "Input",
 CellChangeTimes->{{3.565719501889443*^9, 3.565719563850892*^9}, {
  3.565722508778883*^9, 3.5657225090045652`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"an", "[", "\"\<6\>\"", "]"}], " ", ":=", " ", "6"}], ";", " ", 
  RowBox[{
   RowBox[{"an", "[", "\"\<7\>\"", "]"}], " ", ":=", " ", "7"}], ";", " ", 
  RowBox[{
   RowBox[{"an", "[", "\"\<8\>\"", "]"}], " ", ":=", " ", "8"}], ";", " ", 
  RowBox[{
   RowBox[{"an", "[", "\"\<9\>\"", "]"}], " ", ":=", " ", "9"}], ";", " ", 
  RowBox[{
   RowBox[{"an", "[", "\"\<A\>\"", "]"}], ":=", "10"}], ";", " ", 
  RowBox[{
   RowBox[{"an", "[", "\"\<B\>\"", "]"}], " ", ":=", " ", "11"}], 
  ";"}]], "Input",
 CellChangeTimes->{{3.56571956518046*^9, 3.5657195989610567`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"an", "[", "\"\<C\>\"", "]"}], " ", ":=", " ", "12"}], ";", " ", 
  RowBox[{
   RowBox[{"an", "[", "\"\<D\>\"", "]"}], " ", ":=", " ", "13"}], ";", " ", 
  RowBox[{
   RowBox[{"an", "[", "\"\<E\>\"", "]"}], " ", ":=", " ", "14"}], ";", " ", 
  RowBox[{
   RowBox[{"an", "[", "\"\<F\>\"", "]"}], " ", ":=", " ", "15"}], ";", " ", 
  RowBox[{
   RowBox[{"an", "[", "\"\<G\>\"", "]"}], ":=", "16"}], ";", " ", 
  RowBox[{
   RowBox[{"an", "[", "\"\<H\>\"", "]"}], " ", ":=", " ", "17"}], 
  ";"}]], "Input",
 CellChangeTimes->{{3.5657195119611607`*^9, 3.565719514069175*^9}, {
  3.565719609934062*^9, 3.565719633663547*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"an", "[", "\"\<I\>\"", "]"}], " ", ":=", " ", "18"}], ";", " ", 
  RowBox[{
   RowBox[{"an", " ", "[", "\"\<J\>\"", "]"}], " ", ":=", " ", "19"}], ";", 
  " ", 
  RowBox[{
   RowBox[{"an", "[", "\"\<K\>\"", "]"}], ":=", "20"}], ";", 
  RowBox[{
   RowBox[{"an", "[", "\"\<L\>\"", "]"}], " ", ":=", " ", "21"}], ";", " ", 
  RowBox[{
   RowBox[{"an", "[", "\"\<M\>\"", "]"}], " ", ":=", " ", "22"}], ";", " ", 
  RowBox[{
   RowBox[{"an", "[", "\"\<N\>\"", "]"}], ":=", "23"}], ";"}]], "Input",
 CellChangeTimes->{{3.565719473876683*^9, 3.565719483959614*^9}, {
  3.5657196367998457`*^9, 3.5657196644705477`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"an", "[", "\"\<O\>\"", "]"}], " ", ":=", " ", "24"}], ";", " ", 
  RowBox[{
   RowBox[{"an", "[", "\"\<P\>\"", "]"}], ":=", "25"}], ";", " ", 
  RowBox[{
   RowBox[{"an", "[", "\"\<Q\>\"", "]"}], " ", ":=", " ", "26"}], ";", " ", 
  RowBox[{
   RowBox[{"an", "[", "\"\<R\>\"", "]"}], " ", ":=", " ", "27"}], ";", " ", 
  RowBox[{
   RowBox[{"an", "[", "\"\<S\>\"", "]"}], " ", ":=", " ", "28"}], ";", " ", 
  RowBox[{
   RowBox[{"an", "[", "\"\<T\>\"", "]"}], " ", ":=", " ", "29"}], 
  ";"}]], "Input",
 CellChangeTimes->{{3.565719665333467*^9, 3.565719692702424*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"an", "[", "\"\<U\>\"", "]"}], " ", ":=", " ", "30"}], ";", " ", 
  RowBox[{
   RowBox[{"an", "[", "\"\<V\>\"", "]"}], ":=", "31"}], ";", 
  RowBox[{
   RowBox[{"an", "[", "\"\<W\>\"", "]"}], ":=", "32"}], ";", " ", 
  RowBox[{
   RowBox[{"an", "[", "\"\<X\>\"", "]"}], ":=", "33"}], ";", " ", 
  RowBox[{
   RowBox[{"an", "[", "\"\<Y\>\"", "]"}], ":=", "34"}], ";", " ", 
  RowBox[{
   RowBox[{"an", "[", "\"\<Z\>\"", "]"}], " ", ":=", " ", "35"}], 
  ";"}]], "Input",
 CellChangeTimes->{{3.565719693851591*^9, 3.565719727756752*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"an", "[", "\"\< \>\"", "]"}], " ", ":=", " ", "36"}], ";", " ", 
  RowBox[{
   RowBox[{"an", "[", "\"\<$\>\"", "]"}], " ", ":=", " ", "37"}], ";", " ", 
  RowBox[{
   RowBox[{"an", "[", "\"\<%\>\"", "]"}], " ", ":=", " ", "38"}], ";", " ", 
  RowBox[{
   RowBox[{"an", "[", "\"\<*\>\"", "]"}], " ", ":=", " ", "39"}], ";", " ", 
  RowBox[{
   RowBox[{"an", "[", "\"\<+\>\"", "]"}], ":=", "40"}], ";", " ", 
  RowBox[{
   RowBox[{"an", "[", "\"\<-\>\"", "]"}], ":=", "41"}], ";"}]], "Input",
 CellChangeTimes->{{3.565719728919838*^9, 3.565719769047785*^9}, {
  3.5657207609123697`*^9, 3.565720761197502*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"an", "[", "\"\<.\>\"", "]"}], " ", ":=", " ", "42"}], ";", " ", 
  RowBox[{
   RowBox[{"an", "[", "\"\</\>\"", "]"}], ":=", "43"}], ";", " ", 
  RowBox[{
   RowBox[{"an", "[", "\"\<:\>\"", "]"}], " ", ":=", " ", "44"}], 
  ";"}]], "Input",
 CellChangeTimes->{{3.565719770089075*^9, 3.565719794416418*^9}}],

Cell[CellGroupData[{

Cell["\<\
See page 26 for conversion to binary: a single final letter is converted to a \
6 bit word\
\>", "Subsection",
 CellChangeTimes->{{3.565721307024515*^9, 3.5657213249732122`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"anp", "[", "str_", "]"}], " ", ":=", " ", 
  RowBox[{"If", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"StringLength", "[", "str", "]"}], " ", "\[Equal]", "1"}], ",", 
    " ", 
    RowBox[{"toWord", "[", 
     RowBox[{
      RowBox[{"an", "[", "str", "]"}], ",", "6"}], "]"}], ",", 
    RowBox[{"toWord", "[", 
     RowBox[{
      RowBox[{
       RowBox[{"45", "*", 
        RowBox[{"an", "[", 
         RowBox[{"StringTake", "[", 
          RowBox[{"str", ",", "1"}], "]"}], "]"}]}], "+", 
       RowBox[{"an", "[", 
        RowBox[{"StringDrop", "[", 
         RowBox[{"str", ",", "1"}], "]"}], "]"}]}], ",", "11"}], "]"}]}], 
   "]"}]}]], "Input",
 CellChangeTimes->{{3.565720557606966*^9, 3.5657205811500807`*^9}, {
  3.565720641165873*^9, 3.565720679315316*^9}, {3.5657212025983343`*^9, 
  3.565721214733705*^9}, {3.5657212486565*^9, 3.5657212618459053`*^9}, {
  3.5657213348813667`*^9, 3.565721335049285*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"stringSplit", "[", "str_", "]"}], " ", ":=", " ", 
  RowBox[{"{", 
   RowBox[{
    RowBox[{"StringTake", "[", 
     RowBox[{"str", ",", "2"}], "]"}], ",", 
    RowBox[{"StringDrop", "[", 
     RowBox[{"str", ",", "2"}], "]"}]}], "}"}]}]], "Input",
 CellChangeTimes->{{3.565720162525897*^9, 3.565720176675003*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"stringPrep", "[", "str_", "]"}], " ", ":=", " ", 
  RowBox[{"If", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"StringLength", "[", "str", "]"}], "<=", "2"}], ",", 
    RowBox[{"{", "str", "}"}], ",", "\[IndentingNewLine]", 
    RowBox[{"Module", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"p", " ", "=", " ", 
        RowBox[{"stringSplit", "[", "str", "]"}]}], "}"}], ",", 
      "\[IndentingNewLine]", 
      RowBox[{"Flatten", "[", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"p", "[", 
          RowBox[{"[", "1", "]"}], "]"}], ",", " ", 
         RowBox[{"stringPrep", "[", 
          RowBox[{"p", "[", 
           RowBox[{"[", "2", "]"}], "]"}], "]"}]}], "}"}], "]"}]}], "]"}]}], 
   "]"}]}]], "Input",
 CellChangeTimes->{{3.565720223927554*^9, 3.5657202517532043`*^9}, {
   3.565720322861575*^9, 3.5657204348647614`*^9}, {3.565720467087935*^9, 
   3.565720468725924*^9}, 3.565722649331841*^9, {3.566328252988738*^9, 
   3.5663282539802647`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"stringTo11BitWords", "[", "\"\<\>\"", "]"}], " ", ":=", " ", 
  RowBox[{"{", "}"}]}]], "Input",
 CellChangeTimes->{{3.566328417181625*^9, 3.566328430010453*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"stringTo11BitWords", "[", "str_", "]"}], " ", ":=", " ", 
  RowBox[{"anp", " ", "/@", " ", 
   RowBox[{"stringPrep", "[", "str", "]"}]}]}]], "Input",
 CellChangeTimes->{{3.565720707076152*^9, 3.565720727550243*^9}, {
  3.565721438673758*^9, 3.565721441337143*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"stringToBitStream", "[", "str_", "]"}], " ", ":=", " ", 
  RowBox[{"Apply", "[", 
   RowBox[{"Join", ",", 
    RowBox[{"stringTo11BitWords", "[", "str", "]"}]}], "]"}]}]], "Input",
 CellChangeTimes->{{3.565721938850231*^9, 3.565721951566671*^9}}]
}, Open  ]],

Cell[CellGroupData[{

Cell["\<\
Add mode indicator 0010 and character count (9 bits for M4) to binary data \
(see page 22, it is different for micro-code and normal QR)\
\>", "Subsection",
 CellChangeTimes->{{3.565721966292843*^9, 3.5657219962506227`*^9}, {
  3.565818177850979*^9, 3.565818181989188*^9}, {3.565821799745235*^9, 
  3.5658218431207657`*^9}, {3.565904610917026*^9, 3.565904611458558*^9}, {
  3.565905061733206*^9, 3.565905072386573*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"stringToTaggedBitStream", "[", "str_", "]"}], " ", ":=", " ", 
  RowBox[{"Join", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"0", ",", "0", ",", "1", ",", "0"}], "}"}], " ", ",", 
    RowBox[{"toWord", "[", 
     RowBox[{
      RowBox[{"StringLength", "[", "str", "]"}], ",", "9"}], "]"}], ",", 
    RowBox[{"stringToBitStream", "[", "str", "]"}]}], "]"}]}]], "Input",
 CellChangeTimes->{{3.5657219574407387`*^9, 3.56572196461018*^9}, {
  3.56572226667772*^9, 3.565722275791638*^9}, {3.565722373515823*^9, 
  3.5657224106973267`*^9}, {3.5658180650372963`*^9, 3.565818125585376*^9}, {
  3.565818173618771*^9, 3.5658181761669607`*^9}, {3.56582184711919*^9, 
  3.565821849418013*^9}, {3.565905075733218*^9, 3.565905078244706*^9}}]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["\<\
BitStream to bytes: with L coding we get 19 data bytes and 7 correction bytes \
(all making up a single codeword in the Reed\[Dash]Solomon code of length 26)\
\
\>", "Section",
 CellChangeTimes->{{3.565813046515583*^9, 3.565813051940843*^9}, {
  3.5659030367395983`*^9, 3.565903079009021*^9}, {3.566333730272051*^9, 
  3.566333740069578*^9}}],

Cell[CellGroupData[{

Cell["Pad with final 0s in conversion to bytes", "Subsection",
 CellChangeTimes->{{3.565722764348825*^9, 3.5657227755656633`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"pad", "[", 
   RowBox[{"bs_", ",", "r_"}], "]"}], " ", ":=", " ", 
  RowBox[{"Module", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"l", " ", "=", " ", 
      RowBox[{"Mod", "[", 
       RowBox[{
        RowBox[{"Length", "[", "bs", "]"}], ",", "r"}], "]"}]}], "}"}], ",", 
    RowBox[{"If", "[", 
     RowBox[{
      RowBox[{"l", " ", "\[Equal]", "0"}], ",", "bs", ",", 
      RowBox[{"Join", "[", 
       RowBox[{"bs", ",", 
        RowBox[{"Table", "[", 
         RowBox[{"0", ",", 
          RowBox[{"{", 
           RowBox[{"i", ",", "1", ",", 
            RowBox[{"r", "-", "l"}]}], "}"}]}], "]"}]}], "]"}]}], "]"}]}], 
   "]"}]}]], "Input",
 CellChangeTimes->{{3.565722953347411*^9, 3.5657230307035313`*^9}, {
  3.56572307034335*^9, 3.5657230704062843`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"stringToBytes", "[", "str_", "]"}], " ", ":=", " ", 
  RowBox[{"Module", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"bs", " ", "=", " ", 
      RowBox[{"stringToTaggedBitStream", "[", "str", "]"}]}], "}"}], ",", 
    RowBox[{"splitIntoBytes", "[", 
     RowBox[{"pad", "[", 
      RowBox[{"bs", ",", "8"}], "]"}], "]"}]}], "]"}]}]], "Input",
 CellChangeTimes->{{3.5657214462094517`*^9, 3.565721461720127*^9}, {
   3.56572183489159*^9, 3.565721849749736*^9}, {3.5657224407334023`*^9, 
   3.5657224452304583`*^9}, {3.5657227819898*^9, 3.565722801963195*^9}, {
   3.5657228802341137`*^9, 3.565722959346735*^9}, 3.5657230860045424`*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{"stringToNumBytes", "[", 
   RowBox[{"str_", ",", "K_"}], "]"}], " ", ":=", " ", 
  RowBox[{"Module", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"bytes", " ", "=", " ", 
      RowBox[{"stringToBytes", "[", "str", "]"}]}], "}"}], ",", 
    "\[IndentingNewLine]", 
    RowBox[{"If", "[", 
     RowBox[{
      RowBox[{
       RowBox[{"Length", "[", "bytes", "]"}], " ", ">", " ", "K"}], ",", 
      RowBox[{"Print", "[", "\"\<String too long\>\"", "]"}], ",", 
      RowBox[{"Join", "[", 
       RowBox[{"bytes", ",", 
        RowBox[{"Table", "[", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{
           "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", 
            ",", "0"}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"i", ",", "1", ",", 
            RowBox[{"K", "-", 
             RowBox[{"Length", "[", "bytes", "]"}]}]}], "}"}]}], "]"}]}], 
       "]"}]}], "]"}]}], "]"}]}]], "Input",
 CellChangeTimes->{{3.565814384778611*^9, 3.56581441412031*^9}, {
  3.565814469528474*^9, 3.565814523518153*^9}, {3.5658145727959146`*^9, 
  3.5658145859935293`*^9}, {3.565814621538681*^9, 3.5658146260070457`*^9}, {
  3.565814671410654*^9, 3.565814673107903*^9}, {3.565903085109385*^9, 
  3.5659031131710443`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"stringTo19BytesUnpadded", "[", "str_", "]"}], " ", ":=", " ", 
  RowBox[{"stringToNumBytes", "[", 
   RowBox[{"str", ",", "19"}], "]"}]}]], "Input",
 CellChangeTimes->{{3.565903118747499*^9, 3.565903129839899*^9}, {
  3.566320325083774*^9, 3.566320326219071*^9}}]
}, Open  ]],

Cell[CellGroupData[{

Cell["\<\
We are supposed to terminate with 0000, and then pad the final empty bytes \
with the special words 11101100 and 00010001. These can\[CloseCurlyQuote]t be \
confused with the message because the character count tells the decoder where \
to stop reading. (Clearly most decoders don\[CloseCurlyQuote]t bother \
checking for this padding, because when I forgot to implement it, the \
QR-codes still decoded successfully!)\
\>", "Subsection",
 CellChangeTimes->{{3.566319790688417*^9, 3.566319796676117*^9}, {
  3.566319975795423*^9, 3.566320033840309*^9}, {3.5663200734068613`*^9, 
  3.56632007437431*^9}, {3.566320220713049*^9, 3.566320270396164*^9}, {
  3.566320654064782*^9, 3.566320658184527*^9}, {3.56632256018408*^9, 
  3.5663225603825407`*^9}, {3.566333746261414*^9, 3.5663337485012693`*^9}}],

Cell[BoxData[
 RowBox[{"padding", " ", ":=", 
  RowBox[{"Apply", "[", 
   RowBox[{"Join", ",", 
    RowBox[{"Table", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1", ",", "1", ",", "1", ",", "0", ",", "1", ",", "1", ",", "0", ",",
           "0"}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{
         "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "0", ",",
           "1"}], "}"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"i", ",", "1", ",", "10"}], "}"}]}], "]"}]}], "]"}]}]], "Input",\

 CellChangeTimes->{{3.566320485315609*^9, 3.566320520750236*^9}, {
  3.566320585676025*^9, 3.566320636492243*^9}, {3.566322562825116*^9, 
  3.566322563240562*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"stringTo19Bytes", "[", "str_", "]"}], " ", ":=", " ", 
  RowBox[{"Module", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
      RowBox[{"bs", " ", "=", " ", 
       RowBox[{"stringToTaggedBitStream", "[", "str", "]"}]}], ",", 
      RowBox[{"xs", "=", 
       RowBox[{"stringToBytes", "[", "str", "]"}]}]}], "}"}], ",", 
    "\[IndentingNewLine]", 
    RowBox[{"If", "[", 
     RowBox[{
      RowBox[{
       RowBox[{"Length", "[", "xs", "]"}], " ", ">", " ", "19"}], ",", 
      RowBox[{"Print", "[", "\"\<String too long\>\"", "]"}], ",", 
      "\[IndentingNewLine]", 
      RowBox[{"If", "[", 
       RowBox[{
        RowBox[{
         RowBox[{"Mod", "[", 
          RowBox[{
           RowBox[{"Length", "[", "bs", "]"}], ",", "8"}], "]"}], "<=", "4"}],
         ",", 
        RowBox[{"Join", "[", 
         RowBox[{"xs", ",", " ", 
          RowBox[{"padding", "[", 
           RowBox[{"[", 
            RowBox[{"1", ";;", 
             RowBox[{"(", 
              RowBox[{"19", "-", 
               RowBox[{"Length", "[", "xs", "]"}]}], ")"}]}], "]"}], "]"}]}], 
         "]"}], ",", "\[IndentingNewLine]", 
        RowBox[{"Join", "[", 
         RowBox[{"xs", ",", 
          RowBox[{"{", 
           RowBox[{"{", 
            RowBox[{
            "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", 
             ",", "0"}], "}"}], "}"}], ",", 
          RowBox[{"padding", "[", 
           RowBox[{"[", 
            RowBox[{"1", ";;", 
             RowBox[{"(", 
              RowBox[{"19", "-", 
               RowBox[{"Length", "[", "xs", "]"}], "-", "1"}], ")"}]}], "]"}],
            "]"}]}], "]"}]}], "]"}]}], "]"}]}], "]"}]}]], "Input",
 CellChangeTimes->{{3.566320322449175*^9, 3.566320351288609*^9}, {
  3.566320402878769*^9, 3.5663204835323477`*^9}, {3.566320525948077*^9, 
  3.566320569528014*^9}, {3.5663206100062113`*^9, 3.566320610125823*^9}, {
  3.566320686602475*^9, 3.566320760519808*^9}, {3.566320791840087*^9, 
  3.566320807997465*^9}}]
}, Open  ]],

Cell[CellGroupData[{

Cell["\<\
Example: fortunately tinyurl.com gives case-insensitive shortening of URLs\
\>", "Subsection",
 CellChangeTimes->{{3.565723568894059*^9, 3.565723585696*^9}, {
  3.5659046172354937`*^9, 3.565904617657978*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"stringTo19BytesUnpadded", "[", "\"\<TINYURL.COM/C6SOJLL\>\"", 
  "]"}]], "Input",
 CellChangeTimes->{{3.565723526341762*^9, 3.565723547285104*^9}, {
  3.565814644739771*^9, 3.565814644915597*^9}, {3.565903132431697*^9, 
  3.565903132895588*^9}, {3.566320320067444*^9, 3.566320321121972*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
    "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", "0", ",", "1", ",", 
     "1"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
    "1", ",", "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", "0", ",", 
     "1"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
    "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", 
     "0"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
    "1", ",", "0", ",", "1", ",", "1", ",", "0", ",", "1", ",", "1", ",", 
     "0"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
    "1", ",", "0", ",", "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", 
     "0"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
    "1", ",", "0", ",", "1", ",", "1", ",", "1", ",", "1", ",", "0", ",", 
     "1"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
    "1", ",", "0", ",", "1", ",", "1", ",", "0", ",", "1", ",", "0", ",", 
     "0"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
    "0", ",", "1", ",", "1", ",", "0", ",", "1", ",", "0", ",", "0", ",", 
     "1"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
    "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
     "0"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
    "0", ",", "1", ",", "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", 
     "1"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
    "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", "1", ",", "0", ",", 
     "1"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
    "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", 
     "0"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
    "0", ",", "1", ",", "1", ",", "0", ",", "1", ",", "1", ",", "0", ",", 
     "1"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
    "1", ",", "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", "1", ",", 
     "0"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
    "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
     "0"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
    "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
     "0"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
    "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
     "0"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
    "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
     "0"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
    "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
     "0"}], "}"}]}], "}"}]], "Output",
 CellChangeTimes->{
  3.565723381096208*^9, {3.565723457690774*^9, 3.56572347885077*^9}, 
   3.56572354772302*^9, 3.5658140504836063`*^9, 3.565814645369328*^9, 
   3.5658146757678213`*^9, 3.565816931781818*^9, 3.565821859091568*^9, 
   3.565825409392549*^9, 3.565825584348281*^9, 3.565828500471725*^9, {
   3.565903134135359*^9, 3.565903153789159*^9}, 3.565904618620173*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"stringTo19Bytes", "[", "\"\<TINYURL.COM/BJN6N8P\>\"", 
  "]"}]], "Input",
 CellChangeTimes->{{3.5663214896279087`*^9, 3.566321493112234*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
    "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
     "0"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
    "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", 
     "1"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
    "0", ",", "0", ",", "1", ",", "0", ",", "1", ",", "0", ",", "1", ",", 
     "1"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
    "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", 
     "1"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
    "1", ",", "0", ",", "1", ",", "1", ",", "0", ",", "1", ",", "0", ",", 
     "1"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
    "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", 
     "1"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
    "1", ",", "1", ",", "1", ",", "0", ",", "1", ",", "1", ",", "0", ",", 
     "1"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
    "1", ",", "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
     "1"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
    "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", 
     "0"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
    "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", 
     "0"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
    "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
     "0"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
    "1", ",", "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
     "0"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
    "1", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", 
     "0"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
    "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", 
     "1"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
    "0", ",", "1", ",", "1", ",", "0", ",", "0", ",", "1", ",", "0", ",", 
     "0"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
    "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
     "0"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
    "1", ",", "1", ",", "1", ",", "0", ",", "1", ",", "1", ",", "0", ",", 
     "0"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
    "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", 
     "1"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
    "1", ",", "1", ",", "1", ",", "0", ",", "1", ",", "1", ",", "0", ",", 
     "0"}], "}"}]}], "}"}]], "Output",
 CellChangeTimes->{3.566321493516158*^9, 3.566322567451089*^9}]
}, Open  ]]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[{
 "Bytes to elements of F_{2^8}: using ",
 StyleBox["Mathematica",
  FontSlant->"Italic"],
 " finite fields with defining polynomial x^8 + x^4 + x^3 + x^2 + 1. (This \
package seems to be very slow and buggy.)"
}], "Section",
 CellChangeTimes->{{3.5658130562455606`*^9, 3.565813057244478*^9}, {
   3.5658132464185553`*^9, 3.565813293376548*^9}, {3.565813330838451*^9, 
   3.565813352589279*^9}, 3.5658133855585947`*^9, {3.5658136579770327`*^9, 
   3.565813676286271*^9}, {3.565813841581839*^9, 3.565813849867463*^9}, {
   3.565814270494667*^9, 3.565814304645447*^9}, {3.565903161412982*^9, 
   3.565903166748303*^9}}],

Cell[CellGroupData[{

Cell["\<\
NB polynomials are listed with constant term first, so need to reverse bytes \
to get least significant bit corresponding to constant term.\
\>", "Subsection",
 CellChangeTimes->{{3.565814305901547*^9, 3.5658143079352407`*^9}}],

Cell[BoxData[
 RowBox[{"Needs", "[", "\"\<FiniteFields`\>\"", "]"}]], "Input",
 CellChangeTimes->{{3.56581401986495*^9, 3.565814019866637*^9}}],

Cell[BoxData[
 RowBox[{"F256", " ", ":=", " ", 
  RowBox[{"GF", "[", 
   RowBox[{"2", ",", 
    RowBox[{"{", 
     RowBox[{
     "1", ",", "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", "0", ",", 
      "0", ",", "1"}], "}"}]}], "]"}]}]], "Input",
 CellChangeTimes->{{3.565813680640818*^9, 3.5658136939734297`*^9}, {
  3.565813971447543*^9, 3.565813983702825*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"byteToF256", "[", "u_", "]"}], " ", ":=", " ", 
  RowBox[{"F256", "[", 
   RowBox[{"Reverse", "[", "u", "]"}], "]"}]}]], "Input",
 CellChangeTimes->{{3.565813386583261*^9, 3.565813387942369*^9}, {
  3.565814247505486*^9, 3.5658142596395493`*^9}, {3.5658143110391407`*^9, 
  3.5658143189001102`*^9}, {3.565822361596403*^9, 3.565822363204426*^9}, {
  3.565828096686262*^9, 3.565828098853621*^9}, {3.565828157723225*^9, 
  3.565828159586617*^9}, {3.565829214750362*^9, 3.565829216428577*^9}}],

Cell[BoxData[
 RowBox[{"alpha", " ", ":=", " ", 
  RowBox[{"F256", "[", 
   RowBox[{"{", 
    RowBox[{
    "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
     "0"}], "}"}], "]"}]}]], "Input",
 CellChangeTimes->{{3.565814912993184*^9, 3.56581496740282*^9}}]
}, Open  ]],

Cell[CellGroupData[{

Cell["Example continued", "Subsection",
 CellChangeTimes->{{3.565815201535263*^9, 3.565815203892952*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"testF256elts", " ", "=", "  ", 
  RowBox[{"byteToF256", " ", "/@", " ", 
   RowBox[{
   "stringTo19Bytes", "[", "\"\<TINYURL.COM/BJN6N8P\>\"", "]"}]}]}]], "Input",\

 CellChangeTimes->{{3.566319196518709*^9, 3.566319215336706*^9}, 
   3.566319251932061*^9, {3.566333799581893*^9, 3.566333799884005*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   SubscriptBox[
    RowBox[{"{", 
     RowBox[{
     "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", 
      "0"}], "}"}], "2"], ",", 
   SubscriptBox[
    RowBox[{"{", 
     RowBox[{
     "1", ",", "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", "0", ",", 
      "1"}], "}"}], "2"], ",", 
   SubscriptBox[
    RowBox[{"{", 
     RowBox[{
     "1", ",", "1", ",", "0", ",", "1", ",", "0", ",", "1", ",", "0", ",", 
      "0"}], "}"}], "2"], ",", 
   SubscriptBox[
    RowBox[{"{", 
     RowBox[{
     "1", ",", "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
      "1"}], "}"}], "2"], ",", 
   SubscriptBox[
    RowBox[{"{", 
     RowBox[{
     "1", ",", "0", ",", "1", ",", "0", ",", "1", ",", "1", ",", "0", ",", 
      "1"}], "}"}], "2"], ",", 
   SubscriptBox[
    RowBox[{"{", 
     RowBox[{
     "1", ",", "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
      "1"}], "}"}], "2"], ",", 
   SubscriptBox[
    RowBox[{"{", 
     RowBox[{
     "1", ",", "0", ",", "1", ",", "1", ",", "0", ",", "1", ",", "1", ",", 
      "1"}], "}"}], "2"], ",", 
   SubscriptBox[
    RowBox[{"{", 
     RowBox[{
     "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", 
      "1"}], "}"}], "2"], ",", 
   SubscriptBox[
    RowBox[{"{", 
     RowBox[{
     "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", 
      "0"}], "}"}], "2"], ",", 
   SubscriptBox[
    RowBox[{"{", 
     RowBox[{
     "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", 
      "0"}], "}"}], "2"], ",", 
   SubscriptBox[
    RowBox[{"{", 
     RowBox[{
     "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
      "1"}], "}"}], "2"], ",", 
   SubscriptBox[
    RowBox[{"{", 
     RowBox[{
     "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", 
      "1"}], "}"}], "2"], ",", 
   SubscriptBox[
    RowBox[{"{", 
     RowBox[{
     "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", 
      "1"}], "}"}], "2"], ",", 
   SubscriptBox[
    RowBox[{"{", 
     RowBox[{
     "1", ",", "1", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", 
      "0"}], "}"}], "2"], ",", 
   SubscriptBox[
    RowBox[{"{", 
     RowBox[{
     "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
      "0"}], "}"}], "2"], ",", 
   SubscriptBox[
    RowBox[{"{", 
     RowBox[{
     "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
      "0"}], "}"}], "2"], ",", 
   SubscriptBox[
    RowBox[{"{", 
     RowBox[{
     "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", "1", ",", "1", ",", 
      "1"}], "}"}], "2"], ",", 
   SubscriptBox[
    RowBox[{"{", 
     RowBox[{
     "1", ",", "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", 
      "0"}], "}"}], "2"], ",", 
   SubscriptBox[
    RowBox[{"{", 
     RowBox[{
     "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", "1", ",", "1", ",", 
      "1"}], "}"}], "2"]}], "}"}]], "Output",
 CellChangeTimes->{3.566319217403831*^9, 3.5663192523628683`*^9, 
  3.5663212224778147`*^9}]
}, Open  ]]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["\<\
List of elements of F_{2^8} to Reed\[Dash]Solomon codeword: the coding is \
systematic so only need to calculate the check symbols.\
\>", "Section",
 CellChangeTimes->{{3.565814705426032*^9, 3.565814744604804*^9}, {
  3.565903247024654*^9, 3.565903249386495*^9}, {3.566302606879719*^9, 
  3.566302608844098*^9}}],

Cell[CellGroupData[{

Cell[TextData[{
 "Polynomial division: the built in polynomial division in ",
 StyleBox["Mathematica",
  FontSlant->"Italic"],
 " is absurdly slow over finite fields. This is just fast enough to do the \
low error correction version."
}], "Subsection",
 CellChangeTimes->{{3.565826923490168*^9, 3.565826949043153*^9}, {
  3.5663026115018873`*^9, 3.566302616611679*^9}, {3.5663338044823027`*^9, 
  3.5663338161375732`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"PDiv", "[", 
   RowBox[{"f_", ",", "g_"}], "]"}], " ", ":=", " ", 
  RowBox[{"Module", "[", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"r", " ", "=", " ", 
      RowBox[{"Exponent", "[", 
       RowBox[{"f", ",", "x"}], "]"}]}], "}"}], ",", "\[IndentingNewLine]", 
    RowBox[{"If", "[", 
     RowBox[{
      RowBox[{"r", "\[Equal]", "0"}], ",", "f", ",", 
      RowBox[{"Module", "[", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
          RowBox[{"d", "=", 
           RowBox[{
            RowBox[{"Exponent", "[", 
             RowBox[{"f", ",", "x"}], "]"}], "-", 
            RowBox[{"Exponent", "[", 
             RowBox[{"g", ",", "x"}], "]"}]}]}], ",", "\[IndentingNewLine]", 
          RowBox[{"a", " ", "=", " ", 
           RowBox[{"Coefficient", "[", 
            RowBox[{"f", ",", 
             RowBox[{"x", "^", 
              RowBox[{"Exponent", "[", 
               RowBox[{"f", ",", "x"}], "]"}]}]}], "]"}]}], ",", 
          "\[IndentingNewLine]", 
          RowBox[{"b", " ", "=", " ", 
           RowBox[{"Coefficient", "[", 
            RowBox[{"g", ",", 
             RowBox[{"x", "^", 
              RowBox[{"Exponent", "[", 
               RowBox[{"g", ",", "x"}], "]"}]}]}], "]"}]}]}], "}"}], ",", 
        "\[IndentingNewLine]", 
        RowBox[{"If", "[", 
         RowBox[{
          RowBox[{"d", " ", "\[GreaterEqual]", "0"}], ",", 
          RowBox[{"PDiv", "[", 
           RowBox[{
            RowBox[{"Expand", "[", 
             RowBox[{"f", "-", 
              RowBox[{
               RowBox[{"a", "/", "b"}], "*", 
               RowBox[{"Expand", "[", 
                RowBox[{
                 RowBox[{"x", "^", "d"}], "*", "g"}], "]"}]}]}], "]"}], ",", 
            "g"}], "]"}], ",", "f"}], "]"}]}], "]"}]}], "]"}]}], 
   "]"}]}]], "Input",
 CellChangeTimes->{{3.5658286863162746`*^9, 3.565828727078188*^9}, {
  3.565828757613194*^9, 3.565828771918872*^9}}]
}, Open  ]],

Cell[CellGroupData[{

Cell["\<\
First convert lists of elements of F256 to polynomials over F_{2^8}: NB the \
first data codeword is the coefficient of the highest power term\
\>", "Subsection",
 CellChangeTimes->{{3.565815103514472*^9, 3.565815113241457*^9}, {
  3.565815963341609*^9, 3.5658159657657022`*^9}, {3.565825883590384*^9, 
  3.565825897260994*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"toPolynomial", "[", "vs_", "]"}], " ", ":=", " ", 
  RowBox[{"Total", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"#1", "[", 
      RowBox[{"[", "1", "]"}], "]"}], "&"}], "/@", 
    RowBox[{"MapIndexed", "[", 
     RowBox[{
      RowBox[{
       RowBox[{"#1", "*", 
        RowBox[{"x", "^", 
         RowBox[{"(", 
          RowBox[{"#2", "-", "1"}], ")"}]}]}], "&"}], ",", 
      RowBox[{"Reverse", "[", "vs", "]"}]}], "]"}]}], "]"}]}]], "Input",
 CellChangeTimes->{{3.565815114992763*^9, 3.565815177352489*^9}, {
  3.56581539355754*^9, 3.565815419684061*^9}, {3.56582245800136*^9, 
  3.5658224899905252`*^9}, {3.565825876621573*^9, 3.565825878840866*^9}, {
  3.565828133326332*^9, 3.565828154164258*^9}}]
}, Open  ]],

Cell[CellGroupData[{

Cell["\<\
For the low error-correction L we put in 19 data words and get out 7 error \
correction words\
\>", "Subsection",
 CellChangeTimes->{{3.5658147470366077`*^9, 3.5658147689474*^9}, {
  3.565903262119872*^9, 3.56590327590318*^9}}],

Cell[BoxData[
 RowBox[{"g1L", " ", ":=", " ", 
  RowBox[{
   RowBox[{"x", "^", "7"}], " ", "+", " ", 
   RowBox[{
    RowBox[{"alpha", "^", "87"}], "*", 
    RowBox[{"x", "^", "6"}]}], " ", "+", " ", 
   RowBox[{
    RowBox[{"alpha", "^", "229"}], " ", "*", 
    RowBox[{"x", "^", "5"}]}], " ", "+", " ", 
   RowBox[{
    RowBox[{"alpha", "^", "146"}], "*", 
    RowBox[{"x", "^", "4"}]}], " ", "+", " ", 
   RowBox[{
    RowBox[{"alpha", "^", "149"}], "*", 
    RowBox[{"x", "^", "3"}]}], " ", "+", " ", 
   RowBox[{
    RowBox[{"alpha", "^", "238"}], "*", 
    RowBox[{"x", "^", "2"}]}], " ", "+", " ", 
   RowBox[{
    RowBox[{"alpha", "^", "102"}], "*", "x"}], "+", 
   RowBox[{"alpha", "^", "21"}]}]}]], "Input",
 CellChangeTimes->{{3.5659033166742563`*^9, 3.565903392815715*^9}}],

Cell[CellGroupData[{

Cell[TextData[{
 "In fact g1L is the product of (x - alpha^i) for i between 0 and 6  (note we \
need to include alpha^0, making 1 a root, since the total length of the \
codewords is even) but ",
 StyleBox["Mathematica",
  FontSlant->"Italic"],
 " grinds to a halt trying to expand g4Lalt."
}], "Subsubsection",
 CellChangeTimes->{{3.565867998492153*^9, 3.565868012562772*^9}, {
   3.565868106183662*^9, 3.5658681888018923`*^9}, {3.565903410264185*^9, 
   3.565903413991938*^9}, {3.565903549581133*^9, 3.565903551448762*^9}, 
   3.5659036187134047`*^9, {3.5659039848761806`*^9, 3.565904009073079*^9}, {
   3.5659125158196583`*^9, 3.565912520278926*^9}}],

Cell[BoxData[
 RowBox[{"g1Lalt", " ", ":=", 
  RowBox[{
   RowBox[{"(", 
    RowBox[{"x", "-", "1"}], ")"}], "*", 
   RowBox[{"(", 
    RowBox[{"x", "-", "alpha"}], ")"}], "*", 
   RowBox[{"(", 
    RowBox[{"x", "-", 
     RowBox[{"alpha", "^", "2"}]}], ")"}], "*", 
   RowBox[{"(", 
    RowBox[{"x", "-", 
     RowBox[{"alpha", "^", "3"}]}], ")"}], "*", 
   RowBox[{"(", 
    RowBox[{"x", "-", 
     RowBox[{"alpha", "^", "4"}]}], ")"}], "*", 
   RowBox[{"(", 
    RowBox[{"x", "-", 
     RowBox[{"alpha", "^", "5"}]}], ")"}], "*", 
   RowBox[{"(", 
    RowBox[{"x", "-", 
     RowBox[{"alpha", "^", "6"}]}], ")"}]}]}]], "Input",
 CellChangeTimes->{{3.565867919552652*^9, 3.565867968160706*^9}, {
  3.565868018409831*^9, 3.5658680665314627`*^9}, {3.565868132763908*^9, 
  3.565868151367606*^9}, {3.5658681923881493`*^9, 3.5658681963008013`*^9}, {
  3.5659034167549057`*^9, 3.565903422130121*^9}, {3.565903631095645*^9, 
  3.565903637926762*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"V1Lpoly", "[", "vs_", "]"}], " ", ":=", " ", 
  RowBox[{"PDiv", "[", 
   RowBox[{
    RowBox[{"Expand", "[", 
     RowBox[{
      RowBox[{"x", "^", "7"}], "*", 
      RowBox[{"toPolynomial", "[", "vs", "]"}]}], "]"}], ",", "g1L"}], 
   "]"}]}]], "Input",
 CellChangeTimes->CompressedData["
1:eJxTTMoPSmViYGAQB2IQzdCauMhh4ivHC3f/LgbRU65H7wTRT+bN2wWiV93M
PQSib5zuAtPSa1yPg+gCQw8wHXBe8xKIFppqCqYbki+muALpUx9FM0C01DeN
+SBaYkMcmM76fmYJiObY8BBM/yiK2gqiFxydDqa7GO8cANHG052OgmiLyXKX
QHRBth6YVvgl/glEN8hdAdOHHq4vcQPSXzregOm+68xzQHRDoASYVrgi9xBE
t/Fpgulb6lry7kB60xE7ML1bM0YZRDesXA6mw/ZWaoPoSKfZOiD6iLKlOYg2
W+8Bpud6zJ0Mog9MUZ4Oopee/r0ARL+JFlwIou9vzfsdCaRPHGkD00kpUfI5
QLqzu1oBRAMADGy+yg==
  "]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"TraditionalForm", "[", 
  RowBox[{"Expand", "[", 
   RowBox[{"toPolynomial", "[", "testF256elts", "]"}], "]"}], "]"}]], "Input",\

 CellChangeTimes->{{3.565828555566803*^9, 3.565828559173834*^9}, {
  3.5658285900761347`*^9, 3.5658285961160793`*^9}, {3.565828786018568*^9, 
  3.5658287878440847`*^9}, {3.565828818121078*^9, 3.565828818592519*^9}, {
  3.565828994768279*^9, 3.565828997175474*^9}}],

Cell[BoxData[
 FormBox[
  RowBox[{
   RowBox[{
    SuperscriptBox["x", "18"], " ", 
    FormBox[
     SubscriptBox[
      RowBox[{"{", 
       RowBox[{
       "1", ",", "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", 
        "0"}], "}"}], "2"],
     TraditionalForm]}], "+", 
   RowBox[{
    SuperscriptBox["x", "17"], " ", 
    FormBox[
     SubscriptBox[
      RowBox[{"{", 
       RowBox[{
       "1", ",", "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", "0", ",", 
        "1"}], "}"}], "2"],
     TraditionalForm]}], "+", 
   RowBox[{
    SuperscriptBox["x", "16"], " ", 
    FormBox[
     SubscriptBox[
      RowBox[{"{", 
       RowBox[{
       "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", "1", ",", 
        "0"}], "}"}], "2"],
     TraditionalForm]}], "+", 
   RowBox[{
    SuperscriptBox["x", "15"], " ", 
    FormBox[
     SubscriptBox[
      RowBox[{"{", 
       RowBox[{
       "0", ",", "1", ",", "1", ",", "0", ",", "1", ",", "1", ",", "0", ",", 
        "1"}], "}"}], "2"],
     TraditionalForm]}], "+", 
   RowBox[{
    SuperscriptBox["x", "14"], " ", 
    FormBox[
     SubscriptBox[
      RowBox[{"{", 
       RowBox[{
       "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", 
        "1"}], "}"}], "2"],
     TraditionalForm]}], "+", 
   RowBox[{
    SuperscriptBox["x", "13"], " ", 
    FormBox[
     SubscriptBox[
      RowBox[{"{", 
       RowBox[{
       "1", ",", "0", ",", "1", ",", "1", ",", "1", ",", "1", ",", "0", ",", 
        "1"}], "}"}], "2"],
     TraditionalForm]}], "+", 
   RowBox[{
    SuperscriptBox["x", "12"], " ", 
    FormBox[
     SubscriptBox[
      RowBox[{"{", 
       RowBox[{
       "0", ",", "0", ",", "1", ",", "0", ",", "1", ",", "1", ",", "0", ",", 
        "1"}], "}"}], "2"],
     TraditionalForm]}], "+", 
   RowBox[{
    SuperscriptBox["x", "11"], " ", 
    FormBox[
     SubscriptBox[
      RowBox[{"{", 
       RowBox[{
       "1", ",", "0", ",", "0", ",", "1", ",", "0", ",", "1", ",", "1", ",", 
        "0"}], "}"}], "2"],
     TraditionalForm]}], "+", 
   RowBox[{
    SuperscriptBox["x", "10"], " ", 
    FormBox[
     SubscriptBox[
      RowBox[{"{", 
       RowBox[{
       "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
        "0"}], "}"}], "2"],
     TraditionalForm]}], "+", 
   RowBox[{
    SuperscriptBox["x", "9"], " ", 
    FormBox[
     SubscriptBox[
      RowBox[{"{", 
       RowBox[{
       "1", ",", "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", "1", ",", 
        "0"}], "}"}], "2"],
     TraditionalForm]}], "+", 
   RowBox[{
    SuperscriptBox["x", "8"], " ", 
    FormBox[
     SubscriptBox[
      RowBox[{"{", 
       RowBox[{
       "1", ",", "0", ",", "1", ",", "0", ",", "1", ",", "0", ",", "0", ",", 
        "0"}], "}"}], "2"],
     TraditionalForm]}], "+", 
   RowBox[{
    SuperscriptBox["x", "7"], " ", 
    FormBox[
     SubscriptBox[
      RowBox[{"{", 
       RowBox[{
       "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
        "0"}], "}"}], "2"],
     TraditionalForm]}], "+", 
   RowBox[{
    SuperscriptBox["x", "6"], " ", 
    FormBox[
     SubscriptBox[
      RowBox[{"{", 
       RowBox[{
       "1", ",", "0", ",", "1", ",", "1", ",", "0", ",", "1", ",", "1", ",", 
        "0"}], "}"}], "2"],
     TraditionalForm]}], "+", 
   RowBox[{
    SuperscriptBox["x", "5"], " ", 
    FormBox[
     SubscriptBox[
      RowBox[{"{", 
       RowBox[{
       "0", ",", "1", ",", "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", 
        "1"}], "}"}], "2"],
     TraditionalForm]}], "+", 
   RowBox[{
    SuperscriptBox["x", "4"], " ", 
    FormBox[
     SubscriptBox[
      RowBox[{"{", 
       RowBox[{
       "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
        "1"}], "}"}], "2"],
     TraditionalForm]}], "+", 
   RowBox[{
    SuperscriptBox["x", "3"], " ", 
    FormBox[
     SubscriptBox[
      RowBox[{"{", 
       RowBox[{
       "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
        "0"}], "}"}], "2"],
     TraditionalForm]}], "+", 
   RowBox[{
    SuperscriptBox["x", "2"], " ", 
    FormBox[
     SubscriptBox[
      RowBox[{"{", 
       RowBox[{
       "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
        "0"}], "}"}], "2"],
     TraditionalForm]}], "+", 
   RowBox[{"x", " ", 
    FormBox[
     SubscriptBox[
      RowBox[{"{", 
       RowBox[{
       "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
        "0"}], "}"}], "2"],
     TraditionalForm]}], "+", 
   FormBox[
    SubscriptBox[
     RowBox[{"{", 
      RowBox[{
      "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
       "0"}], "}"}], "2"],
    TraditionalForm]}], TraditionalForm]], "Output",
 CellChangeTimes->{
  3.565828596783352*^9, 3.5658287442577*^9, {3.565828778875092*^9, 
   3.565828788725811*^9}, {3.5658288191637774`*^9, 3.565828844308107*^9}, 
   3.565828998154072*^9, 3.565829249052664*^9, 3.565829386742041*^9, 
   3.5659041376621532`*^9, 3.565904638378831*^9}]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[{
 StyleBox["Mathematica",
  FontSlant->"Italic"],
 " refuses to take the coefficient of x^0 = 1, so need a hack to extract \
constant coefficient: NB the highest order coefficient of the remainder is \
the first error correcting codeword, which goes in the middle of the list of \
codewords, but we still need to reverse when going from F256 to bytes"
}], "Subsubsection",
 CellChangeTimes->{{3.5658157190582237`*^9, 3.565815740616968*^9}, {
  3.5658275333521976`*^9, 3.565827561389431*^9}, {3.565866168996147*^9, 
  3.565866177659217*^9}, {3.56586661420717*^9, 3.565866623113625*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"polynomialToF256s", "[", "r_", "]"}], " ", ":=", " ", 
  RowBox[{"Module", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"d", " ", "=", " ", 
      RowBox[{"Exponent", "[", 
       RowBox[{"r", ",", "x"}], "]"}]}], "}"}], ",", "\[IndentingNewLine]", 
    RowBox[{"Reverse", "[", 
     RowBox[{"Join", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"r", " ", "/.", " ", 
         RowBox[{"{", 
          RowBox[{"x", "\[Rule]", "0"}], "}"}]}], "}"}], ",", 
       RowBox[{"Table", "[", 
        RowBox[{
         RowBox[{"Coefficient", "[", 
          RowBox[{"r", ",", 
           RowBox[{"x", "^", "i"}]}], "]"}], ",", 
         RowBox[{"{", 
          RowBox[{"i", ",", "1", ",", "d"}], "}"}]}], "]"}]}], "]"}], "]"}]}],
    "]"}]}]], "Input",
 CellChangeTimes->{{3.5658660585409822`*^9, 3.5658661105296497`*^9}, {
   3.565866182654291*^9, 3.565866195325387*^9}, 3.565866243642514*^9, {
   3.565866798326984*^9, 3.565866800268942*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"V1Lecc", "[", "vs_", "]"}], " ", ":=", " ", 
  RowBox[{"polynomialToF256s", "[", 
   RowBox[{"V1Lpoly", "[", "vs", "]"}], "]"}]}]], "Input",
 CellChangeTimes->{{3.5658154447389402`*^9, 3.565815450068128*^9}, {
  3.565815532109476*^9, 3.565815575812001*^9}, {3.565815621549775*^9, 
  3.565815659224174*^9}, {3.565815697118566*^9, 3.565815711205708*^9}, {
  3.565815820160282*^9, 3.5658158220477552`*^9}, {3.565827062837219*^9, 
  3.565827065165938*^9}, {3.565827515727633*^9, 3.565827530924198*^9}, {
  3.5658279026416063`*^9, 3.565827931120967*^9}, {3.565866134011553*^9, 
  3.5658661420276833`*^9}, {3.565866211579589*^9, 3.56586622823619*^9}, {
  3.565904169546987*^9, 3.565904173042337*^9}}]
}, Open  ]],

Cell[CellGroupData[{

Cell["Join up with the data words", "Subsubsection",
 CellChangeTimes->{{3.5658157867995358`*^9, 3.565815793374013*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"encodeF256sV1L", "[", "vs_", "]"}], " ", ":=", " ", 
  RowBox[{"Join", "[", 
   RowBox[{"vs", ",", 
    RowBox[{"V1Lecc", "[", "vs", "]"}]}], "]"}]}]], "Input",
 CellChangeTimes->{{3.565815804817586*^9, 3.565815829494214*^9}, 
   3.565816228633854*^9, {3.565866884975951*^9, 3.565866887119535*^9}, {
   3.565904176514724*^9, 3.5659041770102577`*^9}, {3.565904297484378*^9, 
   3.565904298027822*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"encodeF256sV1H", "[", "vs_", "]"}], " ", ":=", " ", 
  RowBox[{"Join", "[", 
   RowBox[{"vs", ",", 
    RowBox[{"V1Hecc", "[", "vs", "]"}]}], "]"}]}]], "Input",
 CellChangeTimes->{{3.566260312702034*^9, 3.566260322813251*^9}}]
}, Open  ]],

Cell[CellGroupData[{

Cell["Convert back from F_{2^8} to a byte (i.e. a list of 8 bits)", \
"Subsubsection",
 CellChangeTimes->{{3.565816225709391*^9, 3.5658162506075773`*^9}, {
  3.56590415323558*^9, 3.565904153777635*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"F256toByte", "[", "0", "]"}], " ", ":=", " ", 
  RowBox[{"{", 
   RowBox[{
   "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
    "0"}], "}"}]}]], "Input",
 CellChangeTimes->{{3.565816525129855*^9, 3.565816532065789*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"F256toByte", "[", "x_", "]"}], " ", ":=", " ", 
  RowBox[{"Reverse", "[", 
   RowBox[{"x", "[", 
    RowBox[{"[", "1", "]"}], "]"}], "]"}]}]], "Input",
 CellChangeTimes->{{3.5658162398833723`*^9, 3.565816259417424*^9}, {
  3.565816421735078*^9, 3.56581642305287*^9}, {3.565828104215184*^9, 
  3.565828127252454*^9}, {3.565829325326899*^9, 3.5658293275750303`*^9}}]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Example", "Subsection",
 CellChangeTimes->{{3.565816765260953*^9, 3.565816767771607*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"toPolynomial", "[", "testF256elts", "]"}]], "Input",
 CellChangeTimes->{{3.565816793012014*^9, 3.56581681086856*^9}, {
  3.5658245116939163`*^9, 3.565824516327479*^9}, {3.5658245551105757`*^9, 
  3.565824556035376*^9}}],

Cell[BoxData[
 RowBox[{
  SubscriptBox[
   RowBox[{"{", 
    RowBox[{
    "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
     "0"}], "}"}], "2"], "+", 
  RowBox[{"x", " ", 
   SubscriptBox[
    RowBox[{"{", 
     RowBox[{
     "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
      "0"}], "}"}], "2"]}], "+", 
  RowBox[{
   SuperscriptBox["x", "2"], " ", 
   SubscriptBox[
    RowBox[{"{", 
     RowBox[{
     "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
      "0"}], "}"}], "2"]}], "+", 
  RowBox[{
   SuperscriptBox["x", "3"], " ", 
   SubscriptBox[
    RowBox[{"{", 
     RowBox[{
     "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
      "0"}], "}"}], "2"]}], "+", 
  RowBox[{
   SuperscriptBox["x", "4"], " ", 
   SubscriptBox[
    RowBox[{"{", 
     RowBox[{
     "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
      "1"}], "}"}], "2"]}], "+", 
  RowBox[{
   SuperscriptBox["x", "14"], " ", 
   SubscriptBox[
    RowBox[{"{", 
     RowBox[{
     "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", 
      "1"}], "}"}], "2"]}], "+", 
  RowBox[{
   SuperscriptBox["x", "16"], " ", 
   SubscriptBox[
    RowBox[{"{", 
     RowBox[{
     "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", "1", ",", 
      "0"}], "}"}], "2"]}], "+", 
  RowBox[{
   SuperscriptBox["x", "7"], " ", 
   SubscriptBox[
    RowBox[{"{", 
     RowBox[{
     "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
      "0"}], "}"}], "2"]}], "+", 
  RowBox[{
   SuperscriptBox["x", "12"], " ", 
   SubscriptBox[
    RowBox[{"{", 
     RowBox[{
     "0", ",", "0", ",", "1", ",", "0", ",", "1", ",", "1", ",", "0", ",", 
      "1"}], "}"}], "2"]}], "+", 
  RowBox[{
   SuperscriptBox["x", "10"], " ", 
   SubscriptBox[
    RowBox[{"{", 
     RowBox[{
     "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
      "0"}], "}"}], "2"]}], "+", 
  RowBox[{
   SuperscriptBox["x", "5"], " ", 
   SubscriptBox[
    RowBox[{"{", 
     RowBox[{
     "0", ",", "1", ",", "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", 
      "1"}], "}"}], "2"]}], "+", 
  RowBox[{
   SuperscriptBox["x", "15"], " ", 
   SubscriptBox[
    RowBox[{"{", 
     RowBox[{
     "0", ",", "1", ",", "1", ",", "0", ",", "1", ",", "1", ",", "0", ",", 
      "1"}], "}"}], "2"]}], "+", 
  RowBox[{
   SuperscriptBox["x", "9"], " ", 
   SubscriptBox[
    RowBox[{"{", 
     RowBox[{
     "1", ",", "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", "1", ",", 
      "0"}], "}"}], "2"]}], "+", 
  RowBox[{
   SuperscriptBox["x", "11"], " ", 
   SubscriptBox[
    RowBox[{"{", 
     RowBox[{
     "1", ",", "0", ",", "0", ",", "1", ",", "0", ",", "1", ",", "1", ",", 
      "0"}], "}"}], "2"]}], "+", 
  RowBox[{
   SuperscriptBox["x", "17"], " ", 
   SubscriptBox[
    RowBox[{"{", 
     RowBox[{
     "1", ",", "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", "0", ",", 
      "1"}], "}"}], "2"]}], "+", 
  RowBox[{
   SuperscriptBox["x", "8"], " ", 
   SubscriptBox[
    RowBox[{"{", 
     RowBox[{
     "1", ",", "0", ",", "1", ",", "0", ",", "1", ",", "0", ",", "0", ",", 
      "0"}], "}"}], "2"]}], "+", 
  RowBox[{
   SuperscriptBox["x", "6"], " ", 
   SubscriptBox[
    RowBox[{"{", 
     RowBox[{
     "1", ",", "0", ",", "1", ",", "1", ",", "0", ",", "1", ",", "1", ",", 
      "0"}], "}"}], "2"]}], "+", 
  RowBox[{
   SuperscriptBox["x", "13"], " ", 
   SubscriptBox[
    RowBox[{"{", 
     RowBox[{
     "1", ",", "0", ",", "1", ",", "1", ",", "1", ",", "1", ",", "0", ",", 
      "1"}], "}"}], "2"]}], "+", 
  RowBox[{
   SuperscriptBox["x", "18"], " ", 
   SubscriptBox[
    RowBox[{"{", 
     RowBox[{
     "1", ",", "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", 
      "0"}], "}"}], "2"]}]}]], "Output",
 CellChangeTimes->{{3.5658167950384293`*^9, 3.565816811695161*^9}, 
   3.565816934009468*^9, {3.56582440761271*^9, 3.565824426392413*^9}, 
   3.5658245170227127`*^9, 3.565824556561256*^9, 3.565825411856963*^9, 
   3.565825585394945*^9, 3.565825950964774*^9, 3.56582769543913*^9, 
   3.56582850336631*^9, {3.565829308669573*^9, 3.565829331569467*^9}, 
   3.565829392014237*^9, 3.565904161704173*^9, 3.56590465015341*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"V1Lecc", "[", "testF256elts", "]"}]], "Input",
 CellChangeTimes->{{3.566302562815866*^9, 3.566302568399461*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   SubscriptBox[
    RowBox[{"{", 
     RowBox[{
     "1", ",", "1", ",", "0", ",", "1", ",", "1", ",", "1", ",", "1", ",", 
      "1"}], "}"}], "2"], ",", 
   SubscriptBox[
    RowBox[{"{", 
     RowBox[{
     "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", "0", ",", "1", ",", 
      "0"}], "}"}], "2"], ",", 
   SubscriptBox[
    RowBox[{"{", 
     RowBox[{
     "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", "1", ",", 
      "1"}], "}"}], "2"], ",", 
   SubscriptBox[
    RowBox[{"{", 
     RowBox[{
     "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
      "1"}], "}"}], "2"], ",", 
   SubscriptBox[
    RowBox[{"{", 
     RowBox[{
     "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", "1", ",", "0", ",", 
      "0"}], "}"}], "2"], ",", 
   SubscriptBox[
    RowBox[{"{", 
     RowBox[{
     "1", ",", "0", ",", "1", ",", "1", ",", "0", ",", "0", ",", "1", ",", 
      "0"}], "}"}], "2"], ",", 
   SubscriptBox[
    RowBox[{"{", 
     RowBox[{
     "1", ",", "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
      "0"}], "}"}], "2"]}], "}"}]], "Output",
 CellChangeTimes->{3.566302574030776*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"V1Lpoly", "[", "testF256elts", "]"}]], "Input",
 CellChangeTimes->{{3.565824864746408*^9, 3.565824870172825*^9}, {
  3.5659041809219503`*^9, 3.565904181857541*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   SuperscriptBox["x", "4"], " ", 
   SubscriptBox[
    RowBox[{"{", 
     RowBox[{
     "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", "1", ",", 
      "1"}], "}"}], "2"]}], "+", 
  RowBox[{
   SuperscriptBox["x", "3"], " ", 
   SubscriptBox[
    RowBox[{"{", 
     RowBox[{
     "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
      "1"}], "}"}], "2"]}], "+", 
  RowBox[{
   SuperscriptBox["x", "5"], " ", 
   SubscriptBox[
    RowBox[{"{", 
     RowBox[{
     "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", "0", ",", "1", ",", 
      "0"}], "}"}], "2"]}], "+", 
  RowBox[{
   SuperscriptBox["x", "2"], " ", 
   SubscriptBox[
    RowBox[{"{", 
     RowBox[{
     "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", "1", ",", "0", ",", 
      "0"}], "}"}], "2"]}], "+", 
  RowBox[{"x", " ", 
   SubscriptBox[
    RowBox[{"{", 
     RowBox[{
     "1", ",", "0", ",", "1", ",", "1", ",", "0", ",", "0", ",", "1", ",", 
      "0"}], "}"}], "2"]}], "+", 
  RowBox[{
   SuperscriptBox["x", "6"], " ", 
   SubscriptBox[
    RowBox[{"{", 
     RowBox[{
     "1", ",", "1", ",", "0", ",", "1", ",", "1", ",", "1", ",", "1", ",", 
      "1"}], "}"}], "2"]}], "+", 
  SubscriptBox[
   RowBox[{"{", 
    RowBox[{
    "1", ",", "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
     "0"}], "}"}], "2"]}]], "Output",
 CellChangeTimes->{
  3.565824870851446*^9, {3.565825456438814*^9, 3.565825475476901*^9}, {
   3.56582554973223*^9, 3.565825586006719*^9}, 3.5658259749148808`*^9, 
   3.565826992280631*^9, 3.565827705981215*^9, 3.565828504440413*^9, {
   3.565829295354691*^9, 3.565829333091745*^9}, 3.565829394686532*^9, 
   3.565866804961224*^9, {3.565904164370634*^9, 3.5659041874040613`*^9}, 
   3.5659042638522177`*^9, 3.565904658070489*^9, 3.566260338875778*^9}]
}, Open  ]]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Combined functions", "Section",
 CellChangeTimes->{{3.565815890210908*^9, 3.5658158948175592`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"encodeStringV1L", "[", "str_", "]"}], " ", ":=", " ", 
  RowBox[{"F256toByte", "/@", 
   RowBox[{"encodeF256sV1L", "[", 
    RowBox[{"byteToF256", " ", "/@", " ", 
     RowBox[{"stringTo19Bytes", "[", "str", "]"}]}], "]"}]}]}]], "Input",
 CellChangeTimes->{{3.56581589657712*^9, 3.5658159369846563`*^9}, {
   3.5658159894140368`*^9, 3.5658159924537067`*^9}, {3.565816441232512*^9, 
   3.5658164713007936`*^9}, {3.5658165475292397`*^9, 3.56581657812741*^9}, {
   3.565817576790208*^9, 3.565817578109614*^9}, 3.565817692131109*^9, {
   3.565866907078662*^9, 3.565866908920299*^9}, {3.565904502401801*^9, 
   3.565904502657502*^9}, {3.5659048104594584`*^9, 3.565904814441594*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"unmaskedV1LfromString000", "[", "str_", "]"}], ":=", 
  RowBox[{"V1", "[", 
   RowBox[{"fsL000M", ",", 
    RowBox[{"encodeStringV1L", "[", "str", "]"}]}], "]"}]}]], "Input",
 CellChangeTimes->{{3.565816989657585*^9, 3.5658170009704037`*^9}, {
  3.5658170404159946`*^9, 3.565817040493287*^9}, {3.5659048226414948`*^9, 
  3.5659048318566847`*^9}, {3.566318587573804*^9, 3.5663186004195547`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"unmaskedV1LfromString001", "[", "str_", "]"}], ":=", 
  RowBox[{"V1", "[", 
   RowBox[{"fsL001M", ",", 
    RowBox[{"encodeStringV1L", "[", "str", "]"}]}], "]"}]}]], "Input",
 CellChangeTimes->{{3.565816989657585*^9, 3.5658170009704037`*^9}, {
  3.5658170404159946`*^9, 3.565817040493287*^9}, {3.5659048226414948`*^9, 
  3.5659048318566847`*^9}, {3.566318587573804*^9, 3.56631858778026*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"V1LfromString000", "[", "str_", "]"}], " ", ":=", " ", 
  RowBox[{"ApplyMask000", "[", 
   RowBox[{"unmaskedV1LfromString000", "[", "str", "]"}], "]"}]}]], "Input",
 CellChangeTimes->{{3.566318475114216*^9, 3.566318520141149*^9}, {
  3.566318590964376*^9, 3.566318591236237*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"V1LfromString001", "[", "str_", "]"}], " ", ":=", " ", 
  RowBox[{"ApplyMask001", "[", 
   RowBox[{"unmaskedV1LfromString001", "[", "str", "]"}], "]"}]}]], "Input",
 CellChangeTimes->{
  3.565816018683267*^9, {3.5658161260396423`*^9, 3.565816178140193*^9}, 
   3.565816581847435*^9, {3.565817005298468*^9, 3.565817028975823*^9}, {
   3.565904835008518*^9, 3.565904839696248*^9}, {3.566318421175784*^9, 
   3.566318421916953*^9}, {3.5663185930462303`*^9, 3.566318593236083*^9}}],

Cell[CellGroupData[{

Cell["\<\
Examples: these take a few seconds to appear\
\>", "Subsection",
 CellChangeTimes->{{3.565904885196136*^9, 3.56590489749937*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"drawMatrix", "[", 
  RowBox[{"V1LfromString000", "[", "\"\<TINYURL.COM/BJN6N8P\>\"", "]"}], 
  "]"}]], "Input",
 CellChangeTimes->{{3.5662564768908443`*^9, 3.566256476894774*^9}, {
  3.566256569519271*^9, 3.566256587350844*^9}, {3.5663185139851723`*^9, 
  3.566318514223598*^9}, {3.566318648971416*^9, 3.566318664320352*^9}}],

Cell[BoxData[
 GraphicsBox[
  RasterBox[SparseArray[
   Automatic, {21, 21}, 1., {
    1, {{0, 15, 24, 34, 46, 57, 64, 78, 86, 99, 112, 123, 134, 147, 150, 167, 
      174, 186, 197, 209, 214, 230}, {{1}, {2}, {3}, {4}, {5}, {6}, {7}, {
      9}, {10}, {11}, {15}, {16}, {18}, {19}, {21}, {1}, {7}, {9}, {12}, {
      14}, {16}, {17}, {20}, {21}, {1}, {3}, {4}, {5}, {7}, {9}, {12}, {16}, {
      19}, {21}, {1}, {3}, {4}, {5}, {7}, {11}, {12}, {14}, {15}, {18}, {
      19}, {20}, {1}, {3}, {4}, {5}, {7}, {9}, {10}, {13}, {15}, {18}, {19}, {
      1}, {7}, {9}, {10}, {14}, {16}, {17}, {1}, {2}, {3}, {4}, {5}, {6}, {
      7}, {9}, {11}, {13}, {15}, {17}, {18}, {20}, {9}, {10}, {13}, {14}, {
      15}, {17}, {18}, {19}, {2}, {6}, {7}, {8}, {9}, {10}, {12}, {13}, {
      16}, {17}, {18}, {19}, {21}, {1}, {2}, {4}, {5}, {6}, {8}, {11}, {12}, {
      13}, {14}, {16}, {20}, {21}, {1}, {5}, {7}, {9}, {10}, {11}, {12}, {
      13}, {14}, {15}, {19}, {3}, {6}, {9}, {10}, {11}, {12}, {14}, {16}, {
      18}, {19}, {21}, {1}, {2}, {3}, {5}, {6}, {7}, {8}, {9}, {11}, {13}, {
      14}, {15}, {19}, {9}, {11}, {12}, {1}, {2}, {3}, {4}, {5}, {6}, {7}, {
      9}, {11}, {13}, {15}, {16}, {17}, {18}, {19}, {20}, {21}, {1}, {7}, {
      10}, {11}, {12}, {15}, {21}, {1}, {3}, {4}, {5}, {7}, {10}, {13}, {
      15}, {17}, {18}, {19}, {21}, {1}, {3}, {4}, {5}, {7}, {13}, {15}, {
      17}, {18}, {19}, {21}, {1}, {3}, {4}, {5}, {7}, {9}, {11}, {15}, {17}, {
      18}, {19}, {21}, {1}, {7}, {13}, {15}, {21}, {1}, {2}, {3}, {4}, {5}, {
      6}, {7}, {11}, {13}, {15}, {16}, {17}, {18}, {19}, {20}, {
      21}}}, CompressedData["
1:eJxTTMoPSmVkYGB4xjAKRsEoGAWjYBSMAmIAAIi2ApE=
     "]}], {{0, 0}, {21, 
   21}}, {0, 1}],
  Frame->Automatic,
  FrameLabel->{None, None},
  FrameTicks->{{None, None}, {None, None}}]], "Output",
 CellChangeTimes->{
  3.566256601407967*^9, 3.566318528607299*^9, 3.566318614959958*^9, {
   3.566318651994567*^9, 3.566318669908914*^9}, 3.5663211348754997`*^9, 
   3.5663213828753147`*^9, 3.5663216230077477`*^9, 3.566322579737833*^9, 
   3.566323286689911*^9, 3.566328073856718*^9}]
}, Open  ]]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Random noise", "Section",
 CellChangeTimes->{{3.565911955695756*^9, 3.565911957873911*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"randomBit", "[", "p_", "]"}], " ", ":=", " ", 
  RowBox[{"If", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"Random", "[", "]"}], "<", "p"}], ",", "1", ",", "0"}], 
   "]"}]}]], "Input",
 CellChangeTimes->{{3.565911959311049*^9, 3.565911966358317*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"randomWord", "[", 
   RowBox[{"p_", ",", "n_"}], "]"}], " ", ":=", " ", 
  RowBox[{"Table", "[", 
   RowBox[{
    RowBox[{"randomBit", "[", "p", "]"}], ",", 
    RowBox[{"{", 
     RowBox[{"i", ",", "1", ",", "n"}], "}"}]}], "]"}]}]], "Input",
 CellChangeTimes->{{3.565911706410686*^9, 3.565911715078768*^9}, {
  3.565911976397435*^9, 3.5659119887572308`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"randomMask", "[", 
   RowBox[{"p_", ",", "n_"}], "]"}], ":=", " ", 
  RowBox[{"Table", "[", 
   RowBox[{
    RowBox[{"randomWord", "[", 
     RowBox[{"p", ",", "n"}], "]"}], ",", 
    RowBox[{"{", 
     RowBox[{"i", ",", "1", ",", "n"}], "}"}]}], "]"}]}]], "Input",
 CellChangeTimes->{{3.56591199036845*^9, 3.565912004204356*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"drawMatrix", "[", 
  RowBox[{"randomMask", "[", 
   RowBox[{"0.02", ",", "21"}], "]"}], "]"}]], "Input",
 CellChangeTimes->{{3.5659120073321047`*^9, 3.565912039409318*^9}}],

Cell[BoxData[
 GraphicsBox[
  RasterBox[SparseArray[
   Automatic, {21, 21}, 1., {
    1, {{0, 0, 0, 1, 1, 1, 1, 1, 1, 2, 2, 2, 2, 2, 4, 5, 5, 6, 6, 8, 8, 8}, {{
      19}, {15}, {12}, {17}, {12}, {16}, {10}, {20}}}, {0., 0., 0., 0., 0., 
     0., 0., 0.}}], {{0, 0}, {21, 21}}, {0, 1}],
  Frame->Automatic,
  FrameLabel->{None, None},
  FrameTicks->{{None, None}, {None, None}}]], "Output",
 CellChangeTimes->{{3.565912014567705*^9, 3.565912041560872*^9}}]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{"send", "[", 
   RowBox[{"M_", ",", "p_"}], "]"}], " ", ":=", 
  RowBox[{"Map", "[", 
   RowBox[{"ReduceMod2", ",", 
    RowBox[{"M", "+", 
     RowBox[{"randomMask", "[", 
      RowBox[{"p", ",", 
       RowBox[{"Length", "[", 
        RowBox[{"M", "[", 
         RowBox[{"[", "1", "]"}], "]"}], "]"}]}], "]"}]}]}], "]"}]}]], "Input",\

 CellChangeTimes->{{3.565912072894763*^9, 3.565912192466227*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"drawMatrix", "[", 
  RowBox[{"send", "[", 
   RowBox[{"V1test", ",", "0.005"}], "]"}], "]"}]], "Input",
 CellChangeTimes->{{3.5659121074132643`*^9, 3.565912131788756*^9}, {
  3.565912270701172*^9, 3.565912273708641*^9}, {3.5659123697677507`*^9, 
  3.565912370183631*^9}}],

Cell[BoxData[
 GraphicsBox[
  RasterBox[SparseArray[
   Automatic, {21, 21}, 1., {
    1, {{0, 16, 26, 41, 52, 62, 72, 84, 91, 104, 113, 125, 133, 149, 150, 167,
       172, 187, 197, 211, 216, 235}, {{1}, {2}, {3}, {4}, {5}, {6}, {7}, {
      9}, {11}, {12}, {13}, {14}, {15}, {19}, {20}, {21}, {1}, {7}, {9}, {
      10}, {11}, {13}, {15}, {17}, {18}, {21}, {1}, {3}, {4}, {5}, {7}, {9}, {
      10}, {11}, {12}, {13}, {14}, {18}, {19}, {20}, {21}, {1}, {3}, {4}, {
      5}, {7}, {11}, {12}, {13}, {15}, {16}, {19}, {1}, {3}, {4}, {5}, {7}, {
      13}, {14}, {15}, {16}, {20}, {1}, {7}, {9}, {10}, {11}, {13}, {15}, {
      17}, {18}, {20}, {1}, {2}, {3}, {4}, {5}, {6}, {7}, {10}, {14}, {15}, {
      16}, {17}, {9}, {10}, {15}, {16}, {17}, {19}, {20}, {1}, {3}, {4}, {
      6}, {7}, {8}, {10}, {13}, {14}, {17}, {19}, {20}, {21}, {1}, {2}, {3}, {
      4}, {8}, {11}, {12}, {18}, {21}, {2}, {3}, {5}, {7}, {8}, {9}, {13}, {
      15}, {16}, {18}, {19}, {20}, {2}, {3}, {4}, {6}, {10}, {19}, {20}, {
      21}, {1}, {2}, {3}, {6}, {7}, {9}, {10}, {11}, {12}, {13}, {14}, {15}, {
      16}, {17}, {20}, {21}, {9}, {1}, {2}, {3}, {4}, {5}, {6}, {7}, {9}, {
      11}, {13}, {15}, {16}, {17}, {18}, {19}, {20}, {21}, {1}, {7}, {9}, {
      15}, {21}, {1}, {3}, {4}, {5}, {7}, {9}, {10}, {11}, {12}, {13}, {15}, {
      17}, {18}, {19}, {21}, {1}, {3}, {4}, {5}, {7}, {15}, {17}, {18}, {
      19}, {21}, {1}, {3}, {4}, {5}, {7}, {10}, {11}, {12}, {13}, {15}, {
      17}, {18}, {19}, {21}, {1}, {7}, {9}, {15}, {21}, {1}, {2}, {3}, {4}, {
      5}, {6}, {7}, {9}, {10}, {11}, {12}, {13}, {15}, {16}, {17}, {18}, {
      19}, {20}, {21}}}, CompressedData["
1:eJxTTMoPSmVkYGB4zTAKRsEoGAWjYBSMAmoCABQ5ApY=
     "]}], {{0, 0}, {21, 
   21}}, {0, 1}],
  Frame->Automatic,
  FrameLabel->{None, None},
  FrameTicks->{{None, None}, {None, None}}]], "Output",
 CellChangeTimes->{{3.565912111210733*^9, 3.565912195839123*^9}, {
  3.565912262020351*^9, 3.565912288761837*^9}, {3.5659123537955837`*^9, 
  3.565912378059491*^9}}]
}, Open  ]]
}, Open  ]]
},
WindowSize->{907, 751},
WindowMargins->{{114, Automatic}, {Automatic, 0}},
ShowSelection->True,
FrontEndVersion->"8.0 for Mac OS X x86 (32-bit, 64-bit Kernel) (February 23, \
2011)",
StyleDefinitions->"Default.nb"
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[557, 20, 164, 3, 34, "Subsection"],
Cell[CellGroupData[{
Cell[746, 27, 215, 4, 37, "Section"],
Cell[964, 33, 633, 17, 58, "Input"],
Cell[1600, 52, 6561, 132, 343, "Input"],
Cell[CellGroupData[{
Cell[8186, 188, 186, 3, 27, "Input"],
Cell[8375, 193, 1177, 22, 374, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[9589, 220, 233, 4, 49, "Subsection"],
Cell[9825, 226, 386, 8, 27, "Input"],
Cell[10214, 236, 3592, 97, 163, "Input"],
Cell[CellGroupData[{
Cell[13831, 337, 290, 6, 27, "Input"],
Cell[14124, 345, 3297, 61, 349, "Output"]
}, Open  ]],
Cell[17436, 409, 292, 7, 27, "Input"],
Cell[17731, 418, 294, 7, 27, "Input"],
Cell[18028, 427, 2009, 59, 73, "Input"],
Cell[20040, 488, 1536, 44, 73, "Input"],
Cell[21579, 534, 2458, 70, 103, "Input"],
Cell[24040, 606, 1686, 46, 73, "Input"],
Cell[25729, 654, 2358, 68, 103, "Input"],
Cell[28090, 724, 2384, 53, 163, "Input"],
Cell[30477, 779, 1221, 28, 43, "Input"],
Cell[31701, 809, 534, 14, 27, "Input"],
Cell[32238, 825, 376, 10, 27, "Input"],
Cell[CellGroupData[{
Cell[32639, 839, 253, 5, 27, "Input"],
Cell[32895, 846, 4135, 72, 349, "Output"]
}, Open  ]]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[37091, 925, 271, 5, 67, "Section"],
Cell[CellGroupData[{
Cell[37387, 934, 372, 8, 27, "Input"],
Cell[37762, 944, 363, 7, 27, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[38162, 956, 653, 18, 27, "Input"],
Cell[38818, 976, 336, 6, 27, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[39191, 987, 633, 17, 27, "Input"],
Cell[39827, 1006, 338, 6, 27, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[40202, 1017, 471, 13, 27, "Input"],
Cell[40676, 1032, 340, 6, 27, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[41053, 1043, 388, 8, 27, "Input"],
Cell[41444, 1053, 339, 6, 27, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[41820, 1064, 491, 10, 27, "Input"],
Cell[42314, 1076, 340, 6, 27, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[42691, 1087, 441, 9, 27, "Input"],
Cell[43135, 1098, 340, 6, 27, "Output"]
}, Open  ]],
Cell[43490, 1107, 777, 13, 58, "Input"],
Cell[CellGroupData[{
Cell[44292, 1124, 137, 2, 27, "Input"],
Cell[44432, 1128, 2391, 43, 374, "Output"]
}, Open  ]],
Cell[46838, 1174, 220, 5, 27, "Input"],
Cell[47061, 1181, 533, 10, 27, "Input"]
}, Open  ]],
Cell[CellGroupData[{
Cell[47631, 1196, 232, 5, 67, "Section"],
Cell[CellGroupData[{
Cell[47888, 1205, 728, 19, 27, "Input"],
Cell[48619, 1226, 338, 6, 27, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[48994, 1237, 523, 15, 27, "Input"],
Cell[49520, 1254, 336, 6, 27, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[49893, 1265, 445, 13, 27, "Input"],
Cell[50341, 1280, 370, 7, 27, "Output"]
}, Open  ]],
Cell[50726, 1290, 827, 14, 43, "Input"],
Cell[CellGroupData[{
Cell[51578, 1308, 137, 2, 27, "Input"],
Cell[51718, 1312, 1159, 22, 374, "Output"]
}, Open  ]],
Cell[52892, 1337, 482, 9, 27, "Input"],
Cell[CellGroupData[{
Cell[53399, 1350, 178, 3, 27, "Input"],
Cell[53580, 1355, 1772, 29, 374, "Output"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[55401, 1390, 245, 3, 67, "Section"],
Cell[55649, 1395, 119, 1, 34, "Subsection"],
Cell[CellGroupData[{
Cell[55793, 1400, 516, 8, 57, "Subsection"],
Cell[56312, 1410, 321, 7, 27, "Input"],
Cell[CellGroupData[{
Cell[56658, 1421, 511, 12, 27, "Input"],
Cell[57172, 1435, 257, 6, 27, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[57466, 1446, 774, 16, 27, "Input"],
Cell[58243, 1464, 279, 6, 27, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[58559, 1475, 432, 8, 27, "Input"],
Cell[58994, 1485, 1965, 32, 374, "Output"]
}, Open  ]]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[61020, 1524, 131, 1, 67, "Section"],
Cell[CellGroupData[{
Cell[61176, 1529, 132, 3, 34, "Subsection"],
Cell[61311, 1534, 203, 5, 27, "Input"],
Cell[61517, 1541, 529, 15, 27, "Input"],
Cell[62049, 1558, 221, 5, 27, "Input"]
}, Open  ]],
Cell[CellGroupData[{
Cell[62307, 1568, 214, 4, 34, "Subsection"],
Cell[62524, 1574, 693, 18, 27, "Input"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[63266, 1598, 157, 3, 67, "Section"],
Cell[63426, 1603, 636, 16, 27, "Input"],
Cell[64065, 1621, 613, 15, 27, "Input"],
Cell[64681, 1638, 667, 16, 27, "Input"],
Cell[65351, 1656, 659, 16, 27, "Input"],
Cell[66013, 1674, 616, 15, 27, "Input"],
Cell[66632, 1691, 581, 15, 27, "Input"],
Cell[67216, 1708, 654, 15, 27, "Input"],
Cell[67873, 1725, 352, 9, 27, "Input"],
Cell[CellGroupData[{
Cell[68250, 1738, 188, 4, 34, "Subsection"],
Cell[68441, 1744, 951, 25, 43, "Input"],
Cell[69395, 1771, 348, 9, 27, "Input"],
Cell[69746, 1782, 1011, 26, 58, "Input"],
Cell[70760, 1810, 196, 4, 27, "Input"],
Cell[70959, 1816, 299, 6, 27, "Input"],
Cell[71261, 1824, 281, 6, 27, "Input"]
}, Open  ]],
Cell[CellGroupData[{
Cell[71579, 1835, 429, 7, 49, "Subsection"],
Cell[72011, 1844, 767, 15, 27, "Input"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[72827, 1865, 352, 7, 89, "Section"],
Cell[CellGroupData[{
Cell[73204, 1876, 130, 1, 34, "Subsection"],
Cell[73337, 1879, 804, 23, 27, "Input"],
Cell[74144, 1904, 673, 14, 27, "Input"],
Cell[74820, 1920, 1291, 32, 58, "Input"],
Cell[76114, 1954, 298, 6, 27, "Input"]
}, Open  ]],
Cell[CellGroupData[{
Cell[76449, 1965, 806, 12, 80, "Subsection"],
Cell[77258, 1979, 747, 21, 27, "Input"],
Cell[78008, 2002, 2015, 52, 73, "Input"]
}, Open  ]],
Cell[CellGroupData[{
Cell[80060, 2059, 218, 4, 34, "Subsection"],
Cell[CellGroupData[{
Cell[80303, 2067, 315, 5, 27, "Input"],
Cell[80621, 2074, 2898, 84, 88, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[83556, 2163, 165, 3, 27, "Input"],
Cell[83724, 2168, 2587, 79, 88, "Output"]
}, Open  ]]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[86372, 2254, 632, 12, 89, "Section"],
Cell[CellGroupData[{
Cell[87029, 2270, 237, 4, 49, "Subsection"],
Cell[87269, 2276, 143, 2, 27, "Input"],
Cell[87415, 2280, 367, 9, 27, "Input"],
Cell[87785, 2291, 524, 9, 27, "Input"],
Cell[88312, 2302, 280, 7, 27, "Input"]
}, Open  ]],
Cell[CellGroupData[{
Cell[88629, 2314, 105, 1, 34, "Subsection"],
Cell[CellGroupData[{
Cell[88759, 2319, 327, 7, 27, "Input"],
Cell[89089, 2328, 3129, 99, 88, "Output"]
}, Open  ]]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[92279, 2434, 322, 6, 89, "Section"],
Cell[CellGroupData[{
Cell[92626, 2444, 422, 9, 50, "Subsection"],
Cell[93051, 2455, 1991, 52, 118, "Input"]
}, Open  ]],
Cell[CellGroupData[{
Cell[95079, 2512, 338, 6, 49, "Subsection"],
Cell[95420, 2520, 742, 19, 27, "Input"]
}, Open  ]],
Cell[CellGroupData[{
Cell[96199, 2544, 237, 5, 34, "Subsection"],
Cell[96439, 2551, 785, 22, 43, "Input"],
Cell[CellGroupData[{
Cell[97249, 2577, 653, 12, 37, "Subsubsection"],
Cell[97905, 2591, 946, 26, 27, "Input"],
Cell[98854, 2619, 719, 18, 27, "Input"],
Cell[CellGroupData[{
Cell[99598, 2641, 419, 8, 27, "Input"],
Cell[100020, 2651, 5075, 175, 87, "Output"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[105144, 2832, 600, 10, 37, "Subsubsection"],
Cell[105747, 2844, 986, 26, 43, "Input"],
Cell[106736, 2872, 729, 12, 27, "Input"]
}, Open  ]],
Cell[CellGroupData[{
Cell[107502, 2889, 120, 1, 24, "Subsubsection"],
Cell[107625, 2892, 435, 9, 27, "Input"],
Cell[108063, 2903, 261, 6, 27, "Input"]
}, Open  ]],
Cell[CellGroupData[{
Cell[108361, 2914, 202, 3, 24, "Subsubsection"],
Cell[108566, 2919, 279, 7, 27, "Input"],
Cell[108848, 2928, 399, 8, 27, "Input"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[109296, 2942, 95, 1, 34, "Subsection"],
Cell[CellGroupData[{
Cell[109416, 2947, 243, 4, 27, "Input"],
Cell[109662, 2953, 4276, 137, 103, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[113975, 3095, 136, 2, 27, "Input"],
Cell[114114, 3099, 1194, 38, 43, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[115345, 3142, 188, 3, 27, "Input"],
Cell[115536, 3147, 1839, 54, 49, "Output"]
}, Open  ]]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[117436, 3208, 105, 1, 67, "Section"],
Cell[117544, 3211, 712, 12, 27, "Input"],
Cell[118259, 3225, 429, 8, 27, "Input"],
Cell[118691, 3235, 426, 8, 27, "Input"],
Cell[119120, 3245, 314, 6, 27, "Input"],
Cell[119437, 3253, 512, 9, 27, "Input"],
Cell[CellGroupData[{
Cell[119974, 3266, 139, 3, 34, "Subsection"],
Cell[CellGroupData[{
Cell[120138, 3273, 349, 6, 27, "Input"],
Cell[120490, 3281, 2109, 35, 374, "Output"]
}, Open  ]]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[122660, 3323, 97, 1, 67, "Section"],
Cell[122760, 3326, 286, 8, 27, "Input"],
Cell[123049, 3336, 395, 10, 27, "Input"],
Cell[123447, 3348, 365, 10, 27, "Input"],
Cell[CellGroupData[{
Cell[123837, 3362, 196, 4, 27, "Input"],
Cell[124036, 3368, 457, 10, 374, "Output"]
}, Open  ]],
Cell[124508, 3381, 437, 13, 27, "Input"],
Cell[CellGroupData[{
Cell[124970, 3398, 295, 6, 27, "Input"],
Cell[125268, 3406, 2019, 33, 374, "Output"]
}, Open  ]]
}, Open  ]]
}
]
*)

(* End of internal cache information *)
